(function() {
var serializingSeparator = "|";
var serializingSeparatorLength = serializingSeparator.length;
var lbIPostfixes = ['C', 'I', 'T'];
var lbIIdSuffix = "LBI";
var lbSIIdSuffix = lbIIdSuffix + "-1";
var lbAIRIdSuffix = "AIR";
var lbAIRTIdSuffix = lbAIRIdSuffix + "-1";
var lbTSIdSuffix = "_TS";
var lbBSIdSuffix = "_BS";
var lbHeaderDivIdSuffix = "_H";
var lTableIdSuffix = "_LBT";
var leVISuffix = "_VI";
var lbDSuffix = "_D";
var emptyItemsRange = "0:-1";
var nbsp = "&nbsp;";
var nameSeparator = "_";
var nbspChar = String.fromCharCode(160);
var NullSizeCellClassName = "dxlbNullSizeCell";
var itemCellTextAttributeName = "data-item-cell-text";
var itemSerializedTextsAttributeName = "data-item-serialized-texts";
var FIRST_CELL_MARKER_CSS_CLASS_NAME = "dxeFTM";
var LAST_CELL_MARKER_CSS_CLASS_NAME = "dxeLTM";
var selectAllMainElementID = "LBSAME";
var selectAllCheckBoxID = "LBSACB";
var filterMainElementID = "LBF";
var filteringTextBoxID = "LBFE";
var showFilterButtonID = "LBSFEB";
var inactiveFilterElementClassName = "dxeLBInactiveFilterPanelSys";
var listTableCollapsedClassName = "dxeLBTCollapsed";
var ListBoxSelectionMode = { Single : 0, Multiple : 1, CheckColumn : 2 };
var ListBoxVirtualScrollTableContainerIDPostfix = "LBVSTC";
var CONSTANTS = {
 CALLBACK_PREFIXES: {
  CUSTOM: "LECC",
  CUSTOMPERFORM: "LECCP",
  LOAD_RANGE_ITEMS: "LBCRI",
  FILTERING: "CBLF",
  FILTERING_CORRECT: "CBCF"
 },
 CALLBACK_RESULTS: {
  ITEMS: "i",
  FILTER_CUSTOMHIGHLIGHTING: "fCH",
  FILTER_LENGTH: "fL"
 }
};
var ListBoxItemsManagerBase = ASPx.CreateClass(null, {
 constructor: function(listBox) {
  this.listBox = listBox;
  this.listTable = listBox.GetListTable();
 },
 Initialize: function() {
  this.AddStateItems(false, false);  
 },
 HasSampleItemStateItems: function() {
  return this.listBox.hasSampleItem;
 },
 AddStateItems: function(clearCache, hoverItemOnly) {
  if (typeof (ASPx.GetStateController) !== "undefined") {
   var itemCellsIdSuffixes = this.listBox.GetItemCellsIdPostfixes();
   this.AddStateItemsCore(ASPx.GetStateController(), clearCache, itemCellsIdSuffixes, hoverItemOnly);
  }
 },
 AddStateItemsCore: function (controller, clearCache, itemCellsIdSuffixes, hoverItemOnly) {
  if(this.HasSampleItemStateItems())
   this.AddItemStateItems(controller, clearCache, itemCellsIdSuffixes, hoverItemOnly, -1);
 },
 AddItemStateItems: function (controller, clearCache, itemCellsIdSuffixes, hoverItemOnly, index) {
  var name = this.listBox.name + "_" + lbIIdSuffix + index;
  if (clearCache)
   this.listBox.ClearStateItemCache(controller, name, itemCellsIdSuffixes);
  if (!ASPx.Browser.WebKitTouchUI)
   controller.AddHoverItem(name, this.listBox.hoverClasses, this.listBox.hoverCssArray, itemCellsIdSuffixes, null, null, true);
  if (!hoverItemOnly) {
   controller.AddSelectedItem(name, this.listBox.selectedClasses, this.listBox.selectedCssArray, itemCellsIdSuffixes, null, null, true);
   controller.AddDisabledItem(name, this.listBox.disabledClasses, this.listBox.disabledCssArray, itemCellsIdSuffixes, null, null, true);
  }
 },
 RemoveHoverStateItem: function() {
  if (typeof (ASPx.GetStateController) !== "undefined") {
   var itemCellsIdSuffixes = this.listBox.GetItemCellsIdPostfixes();
   this.RemoveHoverStateItemCore(ASPx.GetStateController(), itemCellsIdSuffixes);
  }
 },
 RemoveHoverStateItemCore: function(controller, itemCellsIdSuffixes) {
  if(this.HasSampleItemStateItems())
   this.RemoveItemStateHoverItem(controller, itemCellsIdSuffixes, -1);
 },
 RemoveItemStateHoverItem: function(controller, itemCellsIdSuffixes, index) {
  var name = this.listBox.name + "_" + lbIIdSuffix + index;
  this.listBox.ClearStateItemCache(controller, name, itemCellsIdSuffixes);
  if (!ASPx.Browser.WebKitTouchUI)
   controller.RemoveHoverItem(name, itemCellsIdSuffixes);
 },
 GetListTableRows: function() {
  return this.listTable ? this.listTable.rows : [];
 },
 GetItemHtmlContent: function(index) { return null; },
 GetItem: function () { return null; },
 GetItemIndexByRow: function (itemRow) { return null; },
 GetItemCount: function () { return 0; },
 GetItemRow: function (index) {
  if (this.listTable && index >= 0) {
   var rowIndex = this.ConvertItemIndexToRowIndex(index);
   var itemRow = this.listTable.rows[rowIndex];
   if (itemRow && ASPx.ElementContainsCssClass(itemRow, "dxeListBoxItemRow"))
    return itemRow;
  }
  return null;
 },
 GetItemElement: function (index) {
  var result = null;
  var itemRow = this.GetItemRow(index);
  if (itemRow)
   result = this.GetFirstVisibleCell(itemRow) || itemRow.cells[0];
  return result;
 },
 GetFirstVisibleCell: function (itemRow) {
  for (var i = 0; i < itemRow.cells.length; i++)
   if (ASPx.GetElementDisplay(itemRow.cells[i]))
    return itemRow.cells[i];
  return null;
 },
 GetItemHeight: function (index) {
  var itemElement = this.GetItemElement(index);
  return itemElement != null ? itemElement.getBoundingClientRect().height : this.GetDefaultItemHeight();
 },
 GetDefaultItemHeight: function () { return 0; },
 ResetItemHeightIfRequired: function () { return false; },
 GetItemsHeight: function() { return 0; },
 GetItemsWidth: function() { return 0; },
 GetVisibleItemCount: function () { return 0; },
 GetTopSpacersHeight: function() {
  return this.listBox.GetTopScrollSpacerHeight();
 },
 GetItemTopOffset: function(index) {
  return this.GetItemTopOffsetCore(index);
 },
 GetItemTopOffsetCore: function(index) {
  var itemElement = this.GetItemElement(index);
  return itemElement ? itemElement.offsetTop + this.GetTopSpacersHeight() : 0;
 },
 IsItemVisible: function(index) {
  return this.IsItemEdgeVisible(index, true, true);
 },
 IsItemEdgeVisible: function(index, checkTop, checkBottom) {
  var result = false;
  var itemElement = this.GetItemElement(index);
  if(itemElement != null) {
   var scrollDiv = this.listBox.GetScrollDivElement();
   var topScrollDivEdge = scrollDiv.scrollTop;
   var bottomScrollDivEdge = scrollDiv.scrollTop + scrollDiv.clientHeight;
   var topItemElementEdge = this.GetItemTopOffset(index);
   var bottomItemElementEdge = topItemElementEdge + itemElement.getBoundingClientRect().height;
   var checkTopVisibleResult = !checkTop || this.IsVisibleOffset(topItemElementEdge, topScrollDivEdge, bottomScrollDivEdge);
   var checkBottomVisibleResult = !checkBottom || this.IsVisibleOffset(bottomItemElementEdge, topScrollDivEdge, bottomScrollDivEdge);
   result = checkTopVisibleResult && checkBottomVisibleResult;
  }
  return result;
 },
 IsVisibleOffset: function(offset, topScrollDivEdge, bottomScrollDivEdge) {
  return offset >= topScrollDivEdge && offset <= bottomScrollDivEdge;
 },
 GetFirstVisibleItem: function () { return null; },
 GetFirstVisibleItemRow: function() {
  var firstVisibleItemIndex = this.GetFirstVisibleItem();
  return this.listTable.rows[this.ConvertItemIndexToRowIndex(firstVisibleItemIndex)];
 },
 GetFirstRenderedItem: function () { },
 GetLastRenderedItem: function () { },
 InitializeInternalCheckBoxCollection: function () { },
 GetScrollDivChildElementHeight: function () { return null; },
 RemoveItem: function(index) { this.RemoveItemCore(index); },
 RemoveItemCore: function(index) {
  this.listBox.RemoveItemRow(index);
 },
 InsertItem: function () { },
 CreateNewItemRow: function (index) {
  var newItemRow = this.listBox.GetSampleItemRow();
  if (ASPx.IsExistsElement(newItemRow))
   newItemRow = newItemRow.cloneNode(true);
  return newItemRow;
 },
 ClearItems: function () {
  this.ClearItemsCore();
 },
 ClearItemsCore: function() {
  var tBody = this.listBox.GetListTableRowParent();
  if(ASPx.Browser.IE)
   tBody.innerText = "";
  else
   tBody.innerHTML = "";
 },
 IsItemFiltered: function (index) { return false; },
 ConvertItemIndexToRowIndex: function () { return null; },
 Adjust: function () { },
 BeforeClientFiltering: function () { },
 ApplyFilterToItem: function (index, isSatisfy, savePrevState, isFilterReset) { },
 RestorePrevFilteredState: function (index) { },
 OnEndItemsFiltering: function () { },
 ChangeItemsFilteredState: function(action) {
  var count = this.GetItemCount();
  for (var i = 0; i < count; i++) {
   action(i);
   this.AfterChangeItemFilteredStateAction(i);
  }
 },
 AfterChangeItemFilteredStateAction: function() { },
 MakeAllItemsVisible: function () {
  this.ChangeItemsFilteredState(function (index) {
   this.ApplyFilterToItem(index, true, false, true);
  }.aspxBind(this));
 },
 RewriteFilteredItemIndices: function(newFilteredItemIndices) { },
 OnScrollSpacerVisibilityChanged: function () { },
 SetItemHtml: function (index, html) { },
 SetItemTooltip: function(index, tooltip) { },
 SetItemAttribute: function(index, attrName, attrValue) { },
 AddItemCssClass: function (index, className) { },
 RemoveItemCssClass: function (index, className) { },
 SetItemTextCellHtml: function (itemIndex, textCellIndex, html) { },
 SetItemTextCellTooltip: function(itemIndex, textCellIndex, tooltip) { },
 SetItemTextCellAttribute: function(itemIndex, textCellIndex, attrName, attrValue) { },
 AddItemTextCellCssClass: function (itemIndex, textCellIndex, className) { },
 RemoveItemTextCellCssClass: function (itemIndex, textCellIndex, className) { },
 OnDecoratedItemsRendering: function () { },
 DeactivateScrollHandler: function() { },
 ActivateScrollHandler: function() { },
 IsScrollActivated: function() { return true; },
 FixItemTruncatingIfRequired: function() { }
});
var ListBoxItemsDefaultManager = ASPx.CreateClass(ListBoxItemsManagerBase, {
 constructor: function (listBox) {
  this.constructor.prototype.constructor.call(this, listBox);
 },
 AddStateItemsCore: function (controller, clearCache, itemCellsIdSuffixes, hoverItemOnly) {
  ListBoxItemsManagerBase.prototype.AddStateItemsCore.call(this, controller, clearCache, itemCellsIdSuffixes, hoverItemOnly);
  var count = this.GetItemCount();
  for (var i = 0; i < count; i++)
   this.AddItemStateItems(controller, clearCache, itemCellsIdSuffixes, hoverItemOnly, i);
 },
 RemoveHoverStateItemCore: function(controller, itemCellsIdSuffixes) {
  ListBoxItemsManagerBase.prototype.RemoveHoverStateItemCore.call(this, controller, itemCellsIdSuffixes);
  var count = this.GetItemCount();
  for (var i = 0; i < count; i++)
   this.RemoveItemStateHoverItem(controller, itemCellsIdSuffixes, i);
 },
 GetItemIndexByRow: function (itemRow) {
  var result = itemRow.rowIndex;
  if (this.listBox.ContainsFixWidthRow())
   result--;
  return result;
 },
 GetItemCount: function () {
  if (this.listTable) {
   var rowLength = this.listTable.rows.length;
   if (!!this.listBox.GetAccessibilityHeaderRow())
    rowLength--;
   if (this.listBox.ContainsFixWidthRow())
    rowLength--;
   return rowLength;
  }
  return 0;
 },
 GetItem: function (index) {
  var rowLength = this.GetItemCount();
  if (!this.listTable || index < 0 || index >= rowLength)
   return null;
  var row = this.listBox.GetItemRow(index);
  var image = this.listBox.imageCellExists ? ASPx.GetNodeByTagName(row.cells[this.listBox.GetImageCellIndex()], "IMG", 0) : null;
  var src = image == null ? "" : ASPx.ImageUtils.GetImageSrc(image);
  var itemValue = this.listBox.itemsValue[index] !== undefined ? this.listBox.itemsValue[index] : null;
  return new ASPxClientListBoxItem(this.listBox, index, this.listBox.GetItemRowTexts(row), itemValue, src, this.listBox.GetIsItemSelected(index));
 },
 GetVisibleItemCount: function () {
  var count = this.GetItemCount();
  var visibleItemCount = 0;
  for (var i = 0; i < count; i++) {
   if (ASPx.GetElementDisplay(this.GetItemRow(i)))
    visibleItemCount++;
  }
  return visibleItemCount;
 },
 GetFirstVisibleItem: function () {
  var itemCount = this.GetItemCount();
  for (var i = 0; i < itemCount; i++)
   if (this.GetItemRow(i) && ASPx.GetElementDisplay(this.GetItemRow(i)))
    return i;
  return -1;
 },
 GetFirstFilteredItemIndex: function () {
  return this.GetFirstVisibleItem();
 },
 GetFirstRenderedItem: function () {
  return this.GetItemCount() > 0 ? this.GetItem(0) : null;
 },
 GetLastRenderedItem: function () {
  return this.GetItemCount() > 0 ? this.GetItem(this.GetItemCount() - 1) : null;
 },
 ConvertItemIndexToRowIndex: function (itemIndex) {
  return this.listBox.ContainsFixWidthRow() ? itemIndex + 1 : itemIndex;
 },
 GetScrollDivChildElementHeight: function () {
  return this.listBox.GetListTableHeight() + this.listBox.GetTopScrollSpacerHeight() + this.listBox.GetBottomScrollSpacerHeight();
 },
 IsItemFiltered: function (index) {
  return ASPx.GetElementDisplay(this.GetItemRow(index));
 },
 InsertItem: function (index, itemProperties) {
  this.listBox.InsertItemRow(index, itemProperties);
 },
 InitializeInternalCheckBoxCollection: function () {
  var count = this.GetItemCount();
  var enabled = this.listBox.GetEnabled();
  var changeEventMethod = ASPx.Attr.ChangeEventsMethod(enabled);
  for (var i = 0; i < count; i++)
   this.listBox.AddInternalCheckBoxToCollectionCore(i, enabled, changeEventMethod);
 },
 ApplyFilterToItem: function (index, isSatisfy, savePrevState, isFilterReset) {
  var itemRow = this.GetItemRow(index);
  if (savePrevState) {
   var newDisplayValue = isSatisfy ? "" : "none";
   ASPx.Attr.ChangeStyleAttribute(itemRow, "display", newDisplayValue);
  }
  else
   ASPx.SetElementDisplay(itemRow, isSatisfy);
 },
 RestorePrevFilteredState: function (index) {
  ASPx.Attr.RestoreStyleAttribute(this.GetItemRow(index), "display");
 },
 GetItemsHeight: function () {
  return this.listBox.GetListTableHeight();
 },
 GetItemsWidth: function() {
  return this.listTable.offsetWidth;
 },
 GetNewItemIndexInFilteredRange: function(selectedIndex, step) {
  var rows = Array.prototype.slice.call(this.listTable.rows);
  var filteredRows = rows.filter(function(row) { 
   return ASPx.GetElementDisplay(row);
  });
  var selectedRow = this.GetItemRow(selectedIndex);
  var itemIndexInFilteredRange = ASPx.Data.ArrayIndexOf(filteredRows, selectedRow);
  var newItemIndexInFilteredRange = itemIndexInFilteredRange + step;
  if(newItemIndexInFilteredRange >= filteredRows.length)
   newItemIndexInFilteredRange = filteredRows.length - 1;
  else if(newItemIndexInFilteredRange < 0)
   newItemIndexInFilteredRange = 0;
  var newSelectedRow = filteredRows[newItemIndexInFilteredRange];
  return this.GetItemIndexByRow(newSelectedRow);
 }
});
var ListBoxItemsVirtualManager = ASPx.CreateClass(ListBoxItemsManagerBase, {
 Initialize: function () {
  ListBoxItemsManagerBase.prototype.Initialize.call(this);
  this.virtualScrollTopInvisibleItemsCount = 1;
  this.virtualScrollBottomInvisibleItemsCount = 1;
  this.virtualScrollItemHeight = 0;
  this.virtualEmptyItemWidth = 0;
  this.showFilterButtonWidthCounted = false;
  this.isScrollProcessingActivated = true;
  this.InitializeItemRows();
  this.virtualScrollVisibleItemIndices = [];
 },
 GetItemIndexByRow: function (itemRow) {
  return itemRow.itemIndex;
 },
 GetItemCount: function () {
  return this.deserializedItems.length;
 },
 GetItem: function(index, preventEncodeText) {
  if (index < 0 || index >= this.GetItemCount())
   return null;
  var deserializedItem = this.deserializedItems[index];
  var itemTexts = this.AdjustItemTexts(deserializedItem, preventEncodeText);
  var result = new ASPxClientListBoxItem(this.listBox, index, itemTexts, deserializedItem.value,
   deserializedItem.imageUrl, this.listBox.GetIsItemSelected(index));
  result.insertOrderIndex = deserializedItem.insertOrderIndex;
  return result;
 },
 GetItemHtmlContent: function(index) {
  return this.deserializedItems[index] && this.deserializedItems[index].htmlContent;
 },
 AdjustItemTexts: function (item, preventEncodeText) {
  var itemInnerTexts = this.GetItemInnerTexts(item, preventEncodeText);
  if (this.listBox.IsMultiColumn()) {
   for (var i = itemInnerTexts.length; i < this.listBox.columnFieldNames.length; i++)
    itemInnerTexts.push("");
  }
  return itemInnerTexts;
 },
 GetItemInnerTexts: function(item, preventEncodeText) {
  if(!item.texts)
   return item.texts;
  var adjustedItemTexts = [];
  for(var i = 0; i < item.texts.length; i++) {
   var itemText = item.texts[i] || "";
   if(!this.listBox.encodeHtml && !preventEncodeText)
    itemText = this.GetEncodedItemInnerText(itemText);
   adjustedItemTexts[i] = itemText;
  }
  return adjustedItemTexts;
 },
 GetEncodedItemInnerText: function(itemText) {
  var result = itemText;
  var encodedItemText = ASPx.Str.EncodeHtml(itemText);
  if(itemText !== encodedItemText) {
   var div = document.createElement("DIV");
   ASPx.SetInnerHtml(div, itemText);
   result = ASPx.GetInnerText(div);
  }
  return result;
 },
 GetVisibleItemCount: function () {
  return this.filteredItemIndices.length;
 },
 GetItemsHeight: function () {
  this.EnsureVirtualScrollItemHeight();
  return this.filteredItemIndices.length * this.virtualScrollItemHeight;
 },
 GetItemsWidth: function() {
  var listTableOffsetWidth = this.listTable.offsetWidth;
  var showFilterButton = this.listBox.GetShowFilterButton();
  if(showFilterButton && !this.showFilterButtonWidthCounted) {
   listTableOffsetWidth += showFilterButton.GetMainElement().offsetWidth;
   this.showFilterButtonWidthCounted = true;
  } 
  var itemsWidth = this.UseVirtualItemWidth() ?
   Math.max(this.visibleItemTextMaxWidth + this.virtualEmptyItemWidth, listTableOffsetWidth)
   : listTableOffsetWidth;
  return itemsWidth;
 },
 UseVirtualItemWidth: function() {
  return !this.IsFixedWidth() && !this.listBox.hasDecoratedItems && !this.IsItemTextWrapEnabled();
 },
 IsFixedWidth: function() {
  return this.listBox.IsMultiColumn() || this.IsStandaloneListBoxWithFixedWidth();
 },
 IsStandaloneListBoxWithFixedWidth: function() {
  return !this.listBox.isComboBoxList && this.listBox.width !== "";
 },
 GetFirstRenderedItem: function () {
  for (var i = 0; i < this.listTable.rows.length; i++)
   if (this.listTable.rows[i].itemIndex !== undefined)
    return this.GetItem(this.listTable.rows[i].itemIndex);
  return null;
 },
 GetLastRenderedItem: function () {
  for (var i = this.listTable.rows.length - 1; i >= 0; i--)
   if (this.listTable.rows[i].itemIndex !== undefined)
    return this.GetItem(this.listTable.rows[i].itemIndex);
  return null;
 },
 GetDefaultItemHeight: function (index) {
  return this.virtualScrollItemHeight;
 },
 ResetItemHeightIfRequired: function () {
  var firstItemRow = this.GetFirstVisibleItemRow();
  var isResetRequired = firstItemRow && this.GetVirtualScrollItemHeight(firstItemRow) !== this.virtualScrollItemHeight;
  if(isResetRequired)
   this.virtualScrollItemHeight = 0;
  return isResetRequired;
 },
 GetTopSpacersHeight: function () {
  return ListBoxItemsManagerBase.prototype.GetTopSpacersHeight.call(this) + this.GetVirtualScrollTopSpacer().clientHeight;
 },
 GetItemTopOffset: function (index) {
  var baseItemTopOffset = this.GetItemTopOffsetCore(index);
  if(baseItemTopOffset == 0) {
   var renderedItemRange = this.GetRenderedItemRange();
   if (index < renderedItemRange.startIndex || index > renderedItemRange.endIndex) {
    itemIndexInFilteredRange = ASPx.Data.ArrayIndexOf(this.filteredItemIndices, index);
    var nearestRenderedItemIndex = index < renderedItemRange.startIndex ?
     renderedItemRange.startIndex : renderedItemRange.endIndex;
    var nearestRenderedItemIndexInFilteredRange = ASPx.Data.ArrayIndexOf(this.filteredItemIndices, nearestRenderedItemIndex);
    return this.GetItemTopOffset(nearestRenderedItemIndex)
      + this.virtualScrollItemHeight * (itemIndexInFilteredRange - nearestRenderedItemIndexInFilteredRange);
   }
   return 0;
  }
  return baseItemTopOffset;
 },
 IsItemVisible: function (index) {
  return this.IsItemRendered(index) ? ListBoxItemsManagerBase.prototype.IsItemVisible.call(this, index) : false;
 },
 AreAllItemsVisible: function() {
  return this.filteredItemIndices.length === this.GetItemCount();
 },
 IsLastItemBottomEdgeVisible: function() {
  return this.IsItemEdgeVisible(this.GetLastFilteredItemIndex(), false, true);
 },
 ConvertItemIndexToRowIndex: function (itemIndex) {
  if(this.listTable.rows.length < 1)
   return -1;
  if(this.AreAllItemsVisible() && this.listBox.syncLockCount < 1 && !this.listBox.hasItemTemplate){ 
   var rawIndex = itemIndex - this.listTable.rows[0].itemIndex;
   return rawIndex >= 0 && rawIndex < this.listTable.rows.length ? rawIndex : -1;
  }
  return ASPx.Data.ArrayIndexOf(this.listTable.rows, itemIndex, function (element) { return element.itemIndex === itemIndex; });
 },
 GetScrollDivChildElementHeight: function () {
  return this.GetVirtualScrollTableContainer().getBoundingClientRect().height;
 },
 IsItemFiltered: function (index) {
  return this.deserializedItems[index] && this.deserializedItems[index].filtered;
 },
 GetFirstVisibleItem: function () { 
  for(var i = 0; i < this.listTable.rows.length; i++)
   if (this.listTable.rows[i] && ASPx.ElementContainsCssClass(this.listTable.rows[i], "dxeListBoxItemRow"))
    return this.listTable.rows[i].itemIndex;
  return -1;
 },
 GetFirstFilteredItemIndex: function() {
  return this.filteredItemIndices.length > 0 ? this.filteredItemIndices[0] : -1;
 },
 GetLastFilteredItemIndex: function() {
  return this.filteredItemIndices.length > 0 ? this.filteredItemIndices[this.filteredItemIndices.length - 1] : -1;
 },
 GetNewItemIndexInFilteredRange: function(selectedIndex, step) {
  var itemIndexInFilteredRange = ASPx.Data.ArrayIndexOf(this.filteredItemIndices, selectedIndex);
  var newItemIndexInFilteredRange = itemIndexInFilteredRange + step;
  if(newItemIndexInFilteredRange >= this.filteredItemIndices.length)
   newItemIndexInFilteredRange = this.filteredItemIndices.length - 1;
  else if(newItemIndexInFilteredRange < 0)
   newItemIndexInFilteredRange = 0;
  return this.filteredItemIndices[newItemIndexInFilteredRange];
 },
 ShouldRenderItemOnInsert: function (index) {
  if (!this.listBox.IsDisplayed())
   return false;
  if (this.GetFirstVisibleItemRow() == null)
   return true;
  if (this.IsIndexInRenderedItemRange(index))
   return true;
  if (this.filteredItemIndices.length > 0) {
   var startFilteredItemIndex = this.filteredItemIndices[0];
   var endFilteredItemIndex = this.filteredItemIndices[this.filteredItemIndices.length - 1];
   return index < startFilteredItemIndex && this.IsItemVisible(startFilteredItemIndex)
    || index > endFilteredItemIndex && this.IsItemVisible(endFilteredItemIndex);
  }
  return false;
 },
 InsertItem: function (index, itemProperties) {
  var shouldRenderItemOnInsert = this.ShouldRenderItemOnInsert(index);
  var isItemInsertedToTop = this.virtualScrollVisibleItemIndices.length > 0 && index < this.virtualScrollVisibleItemIndices[0];
  ASPx.Data.ArrayInsert(this.deserializedItems, this.listBox.CreateItem(index, itemProperties), index);
  this.deserializedItems[index].filtered = true;
  this.deserializedItems[index].insertOrderIndex = this.listBox.FindFreeIndex();
  for (var i = 0; i < this.deserializedItems.length; i++)
   this.deserializedItems[i].index = i;
  var requiredItemIndexInFilteredRange = -1;
  for (var i = 0; i < this.filteredItemIndices.length; i++)
   if (this.filteredItemIndices[i] >= index) {
    this.filteredItemIndices[i]++;
    if (requiredItemIndexInFilteredRange == -1)
     requiredItemIndexInFilteredRange = i;
   }
  ASPx.Data.ArrayInsert(this.filteredItemIndices, index, requiredItemIndexInFilteredRange);
  if (shouldRenderItemOnInsert) {
   this.EnsureVirtualScrollItemHeight();
   if (this.GetFirstVisibleItemRow() == null)
    this.EnsureVirtualEmptyItemWidth();
  }
  this.virtualScrollVisibleItemIndices = [];
  var rows = this.GetListTableRows();
  for (var i = 0; i < rows.length; i++) {
   var row = rows[i];
   if (row.itemIndex !== undefined && row.itemIndex >= index)
    row.itemIndex++;
   this.virtualScrollVisibleItemIndices.push(row.itemIndex);
  }
  if(shouldRenderItemOnInsert) {
   ASPx.Data.ArrayInsert(this.virtualScrollVisibleItemIndices, index,
    ASPx.Data.ArrayIndexOf(this.virtualScrollVisibleItemIndices, index,
    function (element) { return element > index; }));
   this.listBox.InsertItemRow(index, itemProperties);
   this.RecreateItemRows();
  }
  this.UpdateScrollTableContainerHeight();
  if (isItemInsertedToTop)
   this.UpdateVirtualScrollSpacerHeight(this.virtualScrollVisibleItemIndices);
  this.UpdateItemTextMaxWidth(this.GetItem(index).text);
  if (!this.listBox.IsDisplayed())
   this.listBox.ResetControlAdjustment();
 },
 RemoveItem: function(index) {
  var shouldRecreateItemRows = this.listBox.IsDisplayed() && this.IsIndexInRenderedItemRange(index);
  var shouldRemoveFromRender = this.GetItemRow(index);
  var isItemRemovedFromTop = this.virtualScrollVisibleItemIndices.length > 0 && index < this.virtualScrollVisibleItemIndices[0];
  var needUpdateItemTextMaxWidth = this.NeedUpdateItemTextMaxWidthOnRemoveItem(index);
  ASPx.Data.ArrayRemoveAt(this.deserializedItems, index);
  ASPx.Data.ArrayRemove(this.filteredItemIndices, index);
  for (var i = 0; i < this.deserializedItems.length; i++)
   this.deserializedItems[i].index = i;
  for (var i = 0; i < this.filteredItemIndices.length; i++)
   if (this.filteredItemIndices[i] > index)
    this.filteredItemIndices[i]--;
  this.virtualScrollVisibleItemIndices = [];
  if (shouldRemoveFromRender)
   this.RemoveItemCore(index);
  var rows = this.GetListTableRows();
  for (var i = 0; i < rows.length; i++) {
   var row = rows[i];
   if (row.itemIndex !== undefined && row.itemIndex > index)
    row.itemIndex--;
   this.virtualScrollVisibleItemIndices.push(row.itemIndex);
  }
  if (shouldRecreateItemRows)
   this.RecreateItemRows();
  this.UpdateScrollTableContainerHeight();
  if (isItemRemovedFromTop)
   this.UpdateVirtualScrollSpacerHeight(this.virtualScrollVisibleItemIndices);
  if (needUpdateItemTextMaxWidth) {
   this.itemTextMaxWidth = 0;
   this.visibleItemTextMaxWidth = 0;
   for (var i = 0; i < this.GetItemCount() ; i++)
    this.UpdateItemTextMaxWidth(this.GetItem(i).text);
  }
  if (!this.listBox.IsDisplayed())
   this.listBox.ResetControlAdjustment();
 },
 ClearItems: function () {
  this.ClearItemsCore();
  this.deserializedItems = [];
  this.filteredItemIndices = [];
  this.virtualScrollVisibleItemIndices = [];
  if (this.listBox.isComboBoxList) {
   this.itemTextMaxWidth = 0;
   this.visibleItemTextMaxWidth = 0;
  }
  this.UpdateScrollTableContainerHeight();
  if (!this.listBox.IsDisplayed())
   this.listBox.ResetControlAdjustment();
 },
 CreateNewItemRow: function (index) {
  var newItemRow = ListBoxItemsManagerBase.prototype.CreateNewItemRow.call(this, index);
  newItemRow.itemIndex = index;
  return newItemRow;
 },
 Adjust: function () {
  if (this.GetItemCount() == 0 || !this.listBox.IsDisplayed())
   return;
  this.EnsureVirtualScrollItemHeight();
  this.EnsureVirtualEmptyItemWidth();
  this.RecreateItemRows();
  this.FixItemTruncatingIfRequired();
  this.listBox.InitializePageSize();
  if(!this.listBox.isComboBoxList)
   this.listBox.CorrectWidth();
 },
 UpdateItemTextMaxWidth: function (itemText, isFiltering) {
  if (!this.UseVirtualItemWidth())
   return;
  if (!ASPx.IsExists(this.visibleItemTextMaxWidth))
   this.visibleItemTextMaxWidth = 0;
  this.visibleItemTextMaxWidth = Math.max(this.GetItemTextWidth(itemText), this.visibleItemTextMaxWidth);
  if (!isFiltering)
   this.itemTextMaxWidth = this.visibleItemTextMaxWidth;
 },
 GetItemTextWidth: function (itemText) {
  return Math.round(this.GetItemTextMeasureContext().measureText(itemText).width);
 },
 GetItemTextMeasureContext: function() {
  if (!this.itemTextMeasureContext) {
   var itemTextMeasureCanvas = document.createElement("canvas");
   this.itemTextMeasureContext = itemTextMeasureCanvas.getContext("2d");
   var mainElementStyle = ASPx.GetCurrentStyle(this.listBox.GetMainElement());
   var mainElementFont = mainElementStyle.font ? mainElementStyle.font :
    mainElementStyle.fontStyle + " " + mainElementStyle.fontVariant + " " + mainElementStyle.fontWeight + " "
     + mainElementStyle.fontSize + " / " + mainElementStyle.lineHeight + " " + mainElementStyle.fontFamily;
   this.itemTextMeasureContext.font = mainElementFont;
  }
  return this.itemTextMeasureContext;
 },
 NeedUpdateItemTextMaxWidthOnRemoveItem: function(index) {
  return this.UseVirtualItemWidth() && this.listBox.isComboBoxList && this.IsItemWithMaxText(this.GetItem(index).text);
 },
 BeforeClientFiltering: function () {
  if (this.listBox.isComboBoxList)
   this.visibleItemTextMaxWidth = 0;
 },
 IsItemWithMaxText: function(itemText) {
  return this.GetItemTextWidth(itemText) === this.itemTextMaxWidth;
 },
 ApplyFilterToItem: function (index, isSatisfy, savePrevState, isFilterReset) {
  if (savePrevState && !ASPx.IsExists(this.deserializedItems[index].savedFiltered))
   this.deserializedItems[index].savedFiltered = this.deserializedItems[index].filtered;
  this.ChangeItemFilteredFlag(index, isSatisfy, isFilterReset);
 },
 RestorePrevFilteredState: function (index) {
  var savedFilteredState = this.deserializedItems[index].savedFiltered;
  if (ASPx.IsExists(savedFilteredState)) {
   this.ChangeItemFilteredFlag(index, savedFilteredState);
   delete this.deserializedItems[index].savedFiltered;
  }
 },
 ChangeItemFilteredFlag: function (index, newValue, isFilterReset) {
  var item = this.deserializedItems[index];
  item.filtered = newValue;
  if (!isFilterReset && this.listBox.isComboBoxList && newValue)
   this.UpdateItemTextMaxWidth(item.text);
 },
 OnEndItemsFiltering: function () {
  if (this.virtualScrollItemHeight && this.listBox.IsDisplayed()) {
   this.RecreateItemRows();
   this.UpdateScrollTableContainerHeight();
   if(!this.listBox.isComboBoxList)
    this.FixItemTruncatingIfRequired();
  }
 },
 ChangeItemsFilteredState: function (action) {
  this.filteredItemIndices = [];
  ListBoxItemsManagerBase.prototype.ChangeItemsFilteredState.call(this, action);
 },
 AfterChangeItemFilteredStateAction: function (index) {
  if (this.IsItemFiltered(index))
   this.filteredItemIndices.push(index);
 },
 RewriteFilteredItemIndices: function (newFilteredItemIndices) {
  this.filteredItemIndices = newFilteredItemIndices;
 },
 MakeAllItemsVisible: function () {
  ListBoxItemsManagerBase.prototype.MakeAllItemsVisible.call(this);
  this.visibleItemTextMaxWidth = this.itemTextMaxWidth;
 },
 InsertTempFirstItemRow: function() {
  try {
   this.listBox.LockRunStartupSciptsInItemRow();
   this.RecreateItemRowsByVisibleIndices([0]);
  }
  finally {
   this.listBox.UnlockRunStartupSciptsInItemRow();
  }
 },
 EnsureVirtualScrollItemHeight: function () {
  if (this.virtualScrollItemHeight == 0) {
   var firstItemRow = this.GetFirstVisibleItemRow();
   if (firstItemRow)
    this.virtualScrollItemHeight = this.GetVirtualScrollItemHeight(firstItemRow);
   else if(this.GetItemCount() > 0) {
    this.virtualScrollVisibleItemIndices = [];
    this.InsertTempFirstItemRow();
    firstItemRow = this.GetFirstVisibleItemRow();
    if(firstItemRow)
     this.virtualScrollItemHeight = this.GetVirtualScrollItemHeight(firstItemRow);
    this.RecreateItemRowsByVisibleIndices([]);
   }
   this.UpdateScrollTableContainerHeight();
  }
 },
 GetVirtualScrollItemHeight: function(virtualScrollItemRow) {
  return virtualScrollItemRow.getBoundingClientRect().height;
 },
 EnsureVirtualEmptyItemWidth: function () {
  if (this.virtualEmptyItemWidth == 0 && this.UseVirtualItemWidth() && this.GetItemCount() > 0) {
   this.InsertTempFirstItemRow();
   var firstItemRow = this.GetFirstVisibleItemRow();
   var itemTextCell = this.listBox.GetItemFirstTextCell(0);
   ASPx.SetInnerHtml(itemTextCell, "");
   ASPx.AddClassNameToElement(this.listTable, listTableCollapsedClassName);
   this.virtualEmptyItemWidth = firstItemRow.offsetWidth;
   ASPx.RemoveClassNameFromElement(this.listTable, listTableCollapsedClassName);
   this.RecreateItemRowsByVisibleIndices([]);
  }
 },
 UpdateScrollTableContainerHeight: function () {
  var virtualScrollTableContainer = this.GetVirtualScrollTableContainer();
  if (virtualScrollTableContainer)
   ASPx.SetStyles(virtualScrollTableContainer, {
    height: this.filteredItemIndices.length * this.virtualScrollItemHeight
     + this.listBox.GetTopScrollSpacerHeight()
     + this.listBox.GetBottomScrollSpacerHeight()
   });
 },
 UpdateVirtualScrollSpacerHeight: function(visibleIndices) {
  var firstVisibleIndex = visibleIndices.length > 0 && this.filteredItemIndices.length > 0 ? ASPx.Data.ArrayIndexOf(this.filteredItemIndices, visibleIndices[0]) : 0;
  var topSpacerHeight = this.virtualScrollItemHeight !== undefined ? firstVisibleIndex * this.virtualScrollItemHeight : 0;
  ASPx.SetStyles(this.GetVirtualScrollTopSpacer(), { height: topSpacerHeight });
 },
 OnScrollSpacerVisibilityChanged: function() {
  this.UpdateScrollTableContainerHeight();
 },
 SetItemHtml: function(index, html) {
  this.deserializedItems[index].htmlContent = html;
 },
 SetItemTooltip: function (index, tooltip) {
  this.deserializedItems[index].tooltip = tooltip;
 },
 SetItemAttribute: function(index, attrName, attrValue) {
  if(!this.deserializedItems[index].attributes)
   this.deserializedItems[index].attributes = {};
  this.deserializedItems[index].attributes[attrName] = attrValue;
 },
 AddClassNameToCssClass: function(cssClass, className) {
  return (cssClass == "" || cssClass == undefined) ? className : cssClass + " " + className;
 },
 RemoveClassNameFromCssClass: function (cssClass, className) {
  var updClassName = " " + cssClass + " ";
  var newClassName = updClassName.replace(" " + className + " ", " ");
  return updClassName.length != newClassName.length ? ASPx.Str.Trim(newClassName) : cssClass;
 },
 AddItemCssClass: function (index, className) {
  this.deserializedItems[index].cssClass = this.AddClassNameToCssClass(this.deserializedItems[index].cssClass, className);
 },
 RemoveItemCssClass: function (index, className) {
  this.deserializedItems[index].cssClass = this.RemoveClassNameFromCssClass(this.deserializedItems[index].cssClass, className);
 },
 SetItemTextCellHtml: function (itemIndex, textCellIndex, html) {
  if (!this.deserializedItems[itemIndex].htmlContents)
   this.deserializedItems[itemIndex].htmlContents = [];
  this.SetItemTextCellInfoValue(this.deserializedItems[itemIndex].htmlContents, textCellIndex, html);
 },
 SetItemTextCellTooltip: function (itemIndex, textCellIndex, tooltip) {
  if (!this.deserializedItems[itemIndex].cellTooltips)
   this.deserializedItems[itemIndex].cellTooltips = [];
  this.SetItemTextCellInfoValue(this.deserializedItems[itemIndex].cellTooltips, textCellIndex, tooltip);
 },
 SetItemTextCellAttribute: function(itemIndex, textCellIndex, attrName, attrValue) {
  if(!this.deserializedItems[itemIndex].cellAttributes)
   this.deserializedItems[itemIndex].cellAttributes = [];
  var setValueAction = function(itemInfo, value) {
   if(!itemInfo.value)
    itemInfo.value = {};
   itemInfo.value[value.attrName] = value.attrValue;
  };
  this.SetItemTextCellInfoValue(this.deserializedItems[itemIndex].cellAttributes, textCellIndex,
   { attrName: attrName, attrValue: attrValue }, setValueAction);
 },
 AddItemTextCellCssClass: function (itemIndex, textCellIndex, className) {
  if (!this.deserializedItems[itemIndex].cellCssClasses)
   this.deserializedItems[itemIndex].cellCssClasses = [];
  var newCssClass = this.AddClassNameToCssClass(this.deserializedItems[itemIndex].cellCssClasses[textCellIndex], className);
  this.SetItemTextCellInfoValue(this.deserializedItems[itemIndex].cellCssClasses, textCellIndex, newCssClass);
 },
 RemoveItemTextCellCssClass: function (itemIndex, textCellIndex, className) {
  if (!this.deserializedItems[itemIndex].cellCssClasses)
   this.deserializedItems[itemIndex].cellCssClasses = [];
  var newCssClass = this.RemoveClassNameFromCssClass(this.deserializedItems[itemIndex].cellCssClasses[textCellIndex], className);
  this.SetItemTextCellInfoValue(this.deserializedItems[itemIndex].cellCssClasses, textCellIndex, newCssClass);
 },
 SetItemTextCellInfoValue: function (infoArray, textCellIndex, value, setValueAction) {
  var itemInfo = null;
  var filteredArray = infoArray.filter(function (info) { return info.index === textCellIndex; });
  if (filteredArray.length == 0) {
   itemInfo = { index: textCellIndex };
   infoArray.push(itemInfo);
  }
  else
   itemInfo = filteredArray[0];
  if(setValueAction)
   setValueAction(itemInfo, value);
  else
   itemInfo.value = value;
 },
 InitializeItems: function(items, itemsValue) {
  this.deserializedItems = this.listBox.DeserializeItems(items);
  this.filteredItemIndices = [];
  this.visibleItemTextMaxWidth = 0;
  this.itemTextMaxWidth = 0;
  for (var i = 0; i < this.deserializedItems.length; i++) {
   this.listBox.AdjustItemProperties(this.deserializedItems[i]);
   itemsValue[i] = this.deserializedItems[i].value;
   this.filteredItemIndices[i] = this.deserializedItems[i].index;
   this.deserializedItems[i].filtered = true;
   this.deserializedItems[i].insertOrderIndex = this.listBox.FindFreeIndex();
   this.UpdateItemTextMaxWidth(this.deserializedItems[i].text);
  }
 },
 InitializeItemRows: function () {
  var topSpacer = ASPx.CreateHtmlElement("DIV");
  topSpacer.id = this.listBox.name + "VirtualScrollTopSpacer";
  var tableContainer = ASPx.CreateHtmlElement("DIV");
  tableContainer.id = this.listBox.name + ListBoxVirtualScrollTableContainerIDPostfix;
  tableContainer.appendChild(topSpacer);
  var scrollDiv = this.listBox.GetScrollDivElement();
  ASPx.MoveChildrenToElement(scrollDiv, tableContainer);
  scrollDiv.appendChild(tableContainer);
  ASPx.SetStyles(tableContainer, { overflow: "hidden", width: "100%" });
  ASPx.Evt.AttachEventToElement(scrollDiv, "scroll", function () {
   if(this.IsScrollActivated()) {
    this.RecreateItemRows();
    this.CorrectScrollTableContainerHeightByContent();
   } else
    this.ActivateScrollHandler();
  }.bind(this));
 },
 RecreateItemRows: function() {
  if(!this.listBox.IsDisplayed()) return;
  var scrollDiv = this.listBox.GetScrollDivElement();
  if(!scrollDiv) return;
  var scrollDivHeight = scrollDiv.clientHeight;
  var scrollTop = scrollDiv.scrollTop - this.listBox.GetTopScrollSpacerHeight();
  if(scrollTop < 0)
   scrollTop = 0;
  var firstVisibleItemIndex = Math.floor(scrollTop / this.virtualScrollItemHeight);
  var lastVisibleItemIndex = Math.floor((scrollTop + scrollDivHeight) / this.virtualScrollItemHeight);
  var topRenderedItemIndex = Math.max(firstVisibleItemIndex - this.virtualScrollTopInvisibleItemsCount, 0);
  var bottomRenderedItemIndex = Math.min(lastVisibleItemIndex + this.virtualScrollBottomInvisibleItemsCount, this.filteredItemIndices.length - 1);
  this.RecreateItemRowsCore(topRenderedItemIndex, bottomRenderedItemIndex);
  if(typeof(ASPxClientHint) != "undefined")
   this.UpdateHintControl();
  this.listBox.AssignEllipsisTooltips();
 },
 RecreateItemRowsCore: function(topRenderedItemIndex, bottomRenderedItemIndex) {
  if(topRenderedItemIndex > bottomRenderedItemIndex && this.filteredItemIndices.length > 0)
   return;
  var newVisibleIndices = this.filteredItemIndices.slice(topRenderedItemIndex, bottomRenderedItemIndex + 1);
  this.RecreateItemRowsByVisibleIndices(newVisibleIndices);
  this.OnDecoratedItemsRendering();
  this.CreateItemRowsInFreeSpace(false);
  if(this.listBox.NeedToHandleCellWidth())
   this.listBox.CorrectCellNullWidthStyle(this.GetFirstVisibleItemRow());
 },
 UpdateHintControl: function() {
  ASPxClientHint.hideByTargetsContainerElement(this.listTable, true);
  ASPxClientHint.Update();
 },
 CorrectScrollTableContainerHeightByContent: function() {
  if(this.virtualScrollVisibleItemIndices.length == 0) return;
  var scrollTableContainer = this.GetVirtualScrollTableContainer();
  if(!scrollTableContainer) return;
  var scrollDiv = this.listBox.GetScrollDivElement();
  var containerHeight = scrollTableContainer.getBoundingClientRect().height;
  var scrollDivHeight = scrollDiv.clientHeight;
  var containerOffsetTop = scrollTableContainer.offsetTop - scrollDiv.offsetTop;
  var isScrolledToBottomEdge = scrollDiv.scrollTop + scrollDivHeight >= containerOffsetTop + containerHeight;
  if(isScrolledToBottomEdge || this.IsLastItemBottomEdgeVisible()) {
   var contentHeight = this.GetScrollContentHeight();
   var heightError = 0.01;
   if(Math.abs(contentHeight - containerHeight) > heightError) {
    this.DeactivateScrollHandler();
    scrollTableContainer.style.height = contentHeight + "px";
    setTimeout(function() {
     scrollDiv.scrollTop = containerOffsetTop + scrollTableContainer.getBoundingClientRect().height - scrollDivHeight + 1;
     var isListBoxDisplayed = this.listBox.IsDisplayed();
     if(!isListBoxDisplayed)
      this.ActivateScrollHandler();
     if(isListBoxDisplayed && this.GetVisibleItemCount() > 0 && !this.IsLastItemBottomEdgeVisible()) {
      this.RecreateItemRowsByVisibleIndices([this.GetLastFilteredItemIndex()], true);
      scrollTableContainer.style.height = this.GetScrollContentHeight() + "px";
      this.CreateItemRowsInFreeSpace(true);
     }
    }.aspxBind(this), 0);
   }
  }
 },
 CreateItemRowsInFreeSpace: function(toTop, edgeRenderedItemIndexInFilteredRange) {
  if(this.virtualScrollVisibleItemIndices.length == 0)
   return;
  var edgeRenderedItemIndex = this.virtualScrollVisibleItemIndices[toTop ? 0 : this.virtualScrollVisibleItemIndices.length - 1];
  var edgeFilteredItemIndex = this.filteredItemIndices[toTop ? 0 : this.filteredItemIndices.length - 1];
  if(edgeRenderedItemIndex !== edgeFilteredItemIndex && this.IsItemVisible(edgeRenderedItemIndex)) {
   edgeRenderedItemIndexInFilteredRange = edgeRenderedItemIndexInFilteredRange || ASPx.Data.ArrayIndexOf(this.filteredItemIndices, edgeRenderedItemIndex);
   var newRenderedItemIndexInFilteredRange = toTop ? --edgeRenderedItemIndexInFilteredRange : ++edgeRenderedItemIndexInFilteredRange;
   var newRenderedItemIndex = this.filteredItemIndices[newRenderedItemIndexInFilteredRange];
   var newRenderedIndices = this.virtualScrollVisibleItemIndices.slice();
   if(toTop)
    newRenderedIndices.unshift(newRenderedItemIndex);
   else
    newRenderedIndices.push(newRenderedItemIndex);
   this.RecreateItemRowsByVisibleIndices(newRenderedIndices, toTop);
   if(toTop) {
    this.GetVirtualScrollTableContainer().style.height = this.GetScrollContentHeight() + "px";
    this.listBox.MakeItemVisible(this.filteredItemIndices[this.filteredItemIndices.length - 1]);
   }
   this.CreateItemRowsInFreeSpace(toTop, newRenderedItemIndexInFilteredRange);
  }
 },
 GetScrollContentHeight: function() {
  return this.GetVirtualScrollTopSpacer().getBoundingClientRect().height
   + this.listBox.GetTopScrollSpacerHeight() + this.listBox.GetBottomScrollSpacerHeight()
   + this.listTable.getBoundingClientRect().height;
 },
 FixItemTruncatingIfRequired: function() {
  var scrollDiv = this.listBox.GetScrollDivElement();
  var scrollTableContainer = this.GetVirtualScrollTableContainer();
  if(scrollTableContainer && scrollDiv.offsetHeight >= scrollTableContainer.offsetHeight) {
   this.CorrectScrollTableContainerHeightByContent();
   if(scrollDiv.offsetHeight < scrollTableContainer.offsetHeight)
    scrollDiv.style.height = scrollTableContainer.style.height;
  }
 },
 RecreateItemRowsByVisibleIndices: function (newVisibleIndices, keepTopSpacerHeight) {
  newVisibleIndices = newVisibleIndices || [];
  var indicesToRemove = this.virtualScrollVisibleItemIndices.filter(function (index) { return newVisibleIndices.indexOf(index) === -1; });
  var indicesToInsert = newVisibleIndices.filter(function (index) { return this.virtualScrollVisibleItemIndices.indexOf(index) === -1; }.bind(this));
  this.listBox.LockSynchronization();
  for (var i = 0; i < indicesToRemove.length; i++) {
   var itemIndex = indicesToRemove[i];
   this.listBox.RemoveItemRow(itemIndex);
  }
  for (var i = 0; i < indicesToInsert.length; i++) {
   var itemIndex = indicesToInsert[i];
   this.listBox.InsertItemRow(itemIndex, this.deserializedItems[itemIndex]);
   var isItemSelected = this.listBox.GetIsItemSelected(itemIndex);
   var stateController = typeof (ASPx.GetStateController) != "undefined" ? ASPx.GetStateController() : null;
   this.listBox.SetItemSelectionAppearance(itemIndex, isItemSelected, stateController, false);
   if (this.listBox.GetIsCheckColumnExists())
    this.listBox.SetCheckBoxChecked(itemIndex, isItemSelected);
   this.listBox.ChangeEnabledStateItem(itemIndex, this.listBox.clientEnabled, ASPx.GetStateController());
  }
  this.listBox.TryApplyHighlighting();
  this.listBox.UnlockSynchronization();
  if(!keepTopSpacerHeight)
   this.UpdateVirtualScrollSpacerHeight(newVisibleIndices);
  this.listBox.InitDXTextAttributes();
  this.virtualScrollVisibleItemIndices = newVisibleIndices;
 },
 RemoveHoverStateItemCore: function (controller, itemCellsIdSuffixes) {
  ListBoxItemsManagerBase.prototype.RemoveHoverStateItemCore.call(this, controller, itemCellsIdSuffixes);
  var range = this.GetRenderedItemRange();
  for (var i = range.startIndex; i <= range.endIndex; i++) {
   if(i >= 0)
    this.RemoveItemStateHoverItem(controller, itemCellsIdSuffixes, i);
  }
 },
 AddStateItemsCore: function (controller, clearCache, itemCellsIdSuffixes, hoverItemOnly) {
  ListBoxItemsManagerBase.prototype.AddStateItemsCore.call(this, controller, clearCache, itemCellsIdSuffixes, hoverItemOnly);
  var range = this.GetRenderedItemRange();
  for (var i = range.startIndex; i <= range.endIndex; i++) {
   if (i >= 0)
    this.AddItemStateItems(controller, clearCache, itemCellsIdSuffixes, hoverItemOnly, i);
  }
 },
 GetVirtualScrollTableContainer: function () {
  return this.listBox.tempCache.Get("virtualScrollTableContainer", this.GetVirtualScrollTableContainerCore.aspxBind(this), this.listBox);
 },
 GetVirtualScrollTableContainerCore: function () {
  if (!ASPx.IsExistsElement(this.listBox.virtualScrollTableContainer))
   this.listBox.virtualScrollTableContainer = ASPx.GetElementById(this.listBox.name + ListBoxVirtualScrollTableContainerIDPostfix);
  return this.listBox.virtualScrollTableContainer;
 },
 GetVirtualScrollTopSpacer: function () {
  return this.listBox.tempCache.Get("virtualScrollTopSpacer", this.GetVirtualScrollTopSpacerCore.aspxBind(this), this.listBox);
 },
 GetVirtualScrollTopSpacerCore: function () {
  if (!ASPx.IsExistsElement(this.listBox.virtualScrollTopSpacer))
   this.listBox.virtualScrollTopSpacer = ASPx.GetElementById(this.listBox.name + "VirtualScrollTopSpacer");
  return this.listBox.virtualScrollTopSpacer;
 },
 GetRenderedItemRange: function () {
  var firstRenderedItem = this.GetFirstRenderedItem();
  var lastRenderedItem = this.GetLastRenderedItem();
  return {
   startIndex: firstRenderedItem ? firstRenderedItem.index : -1,
   endIndex: lastRenderedItem ? lastRenderedItem.index : -1
  };
 },
 IsIndexInRenderedItemRange: function(index) {
  var renderedItemRange = this.GetRenderedItemRange();
  return index >= renderedItemRange.startIndex && index <= renderedItemRange.endIndex;
 },
 IsItemRendered: function (itemIndex) {
  return this.GetItemRow(itemIndex) !== null;
 },
 IsItemTextWrapEnabled: function() {
  if(!ASPx.IsExists(this.enableItemTextWrap)) {
   var sampleItemFirstTextCell = this.listBox.GetSampleItemFirstTextCell();
   this.enableItemTextWrap = sampleItemFirstTextCell && ASPx.GetCurrentStyle(sampleItemFirstTextCell).whiteSpace !== "nowrap";
  }
  return this.enableItemTextWrap;
 },
 OnDecoratedItemsRendering: function () {
  if(this.listBox.hasDecoratedItems && !this.IsFixedWidth() && this.listBox.IsDisplayed() && !this.IsItemTextWrapEnabled())
   this.listBox.CorrectWidth();
 },
 DeactivateScrollHandler: function() { 
  this.isScrollProcessingActivated = false;
 },
 ActivateScrollHandler: function() { 
  this.isScrollProcessingActivated = true;
 },
 IsScrollActivated: function() {
  return this.isScrollProcessingActivated;
 }
});
var ASPxClientListEdit = ASPx.CreateClass(ASPxClientEdit, {
 constructor: function(name) {
  this.constructor.prototype.constructor.call(this, name);
  this.SelectedIndexChanged = new ASPxClientEvent();
  this.savedSelectedIndex = -1;
 },
 FindInputElement: function() {
  return this.FindStateInputElement();
 },
 FindStateInputElement: function(){
  return document.getElementById(this.name + leVISuffix);
 },
 GetItem: function(index) {
  throw "Not implemented";
 },
 GetItemValue: function(index) {
  throw "Not implemented";
 },
 GetValue: function(){
  return this.GetItemValue(this.GetSelectedIndex());
 }, 
 GetSelectedIndexInternal: function(){
  return this.savedSelectedIndex;
 },
 SetSelectedIndexInternal: function(index){
  this.savedSelectedIndex = index;
 },
 FindItemIndexByValue: function(value){
  for(var i = 0; i < this.GetItemCount(); i++){
   if(this.GetItemValue(i) == value)
    return i;
  }
  return -1;
 },
 RaiseItemClick: function() {
  var processOnServer = this.autoPostBack;
  if(!this.ItemClick.IsEmpty()){
   var args = new ASPxClientProcessingModeEventArgs(processOnServer);
   this.ItemClick.FireEvent(this, args);
   processOnServer = args.processOnServer;
  }
  return processOnServer;
 },
 RaiseItemDoubleClick: function() {
  var processOnServer = this.autoPostBack;
  if(!this.ItemDoubleClick.IsEmpty()){
   var args = new ASPxClientProcessingModeEventArgs(processOnServer);
   this.ItemDoubleClick.FireEvent(this, args);
   processOnServer = args.processOnServer;
  }
  return processOnServer;
 },
 RaiseValueChangedEvent: function() {
  if(!this.isInitialized) return false;
  var processOnServer = ASPxClientEdit.prototype.RaiseValueChangedEvent.call(this);
  processOnServer = this.RaiseValueChangedAdditionalEvents(processOnServer);
  return processOnServer;
 },
 RaiseValueChangedAdditionalEvents: function(processOnServer){
  return this.RaiseSelectedIndexChanged(processOnServer);
 },
 RaiseSelectedIndexChanged: function (processOnServer) {
  this.RaiseValidationInternal();
  if(!this.SelectedIndexChanged.IsEmpty()){
   var args = new ASPxClientProcessingModeEventArgs(processOnServer);
   this.SelectedIndexChanged.FireEvent(this, args);
   processOnServer = args.processOnServer;
  }
  return processOnServer;
 },
 UpdateHiddenInputs: function(){
  var element = this.FindStateInputElement();
  if(ASPx.IsExistsElement(element)) {
   var value = this.GetValue();
   if(value == null)
    value = "";
   element.value = value;
  }
 },
 GetModifyEvent: function () {
  return this.SelectedIndexChanged;
 },
 GetSelectedItem: function(){
  var index = this.GetSelectedIndexInternal();
  return this.GetItem(index);
 },
 GetSelectedIndex: function(){
  return this.GetSelectedIndexInternal();
 },
 SetSelectedItem: function(item){
  var index = (item != null) ? item.index : -1;
  this.SetSelectedIndex(index);
 },
 SetSelectedIndex: function(index){
  this.SelectIndexSilent(index);
 },
 SelectIndexSilent: function(index){
  throw "Not implemented";
 },
 OnValueChanged: function () {
  var processOnServer = this.RaiseValueChangedEvent() && this.GetIsValid();
  if(processOnServer)
   this.SendPostBackInternal("");
 }
});
var ASPxClientListEditItem = ASPx.CreateClass(null, {
 constructor: function(listEditBase, index, text, value, imageUrl){
  this.listEditBase = listEditBase;
  this.index = index;
  this.imageUrl = imageUrl;
  this.text = text;
  this.value = value;
 }
});
var ASPxClientListBoxItem = ASPx.CreateClass(ASPxClientListEditItem, {
 constructor: function(listEditBase, index, texts, value, imageUrl, selected, cellStyles, cellCssClasses, cellTooltips, cellAttributes, htmlContents, style, cssClass, tooltip, attributes, htmlContent) {
  this.constructor.prototype.constructor.call(this, listEditBase, index, null, value, imageUrl);
  this.selected = !!selected;
  this.texts = texts;
  this.text = listEditBase.FormatText(texts, value);
  this.cellStyles = cellStyles;
  this.cellCssClasses = cellCssClasses;
  this.cellTooltips = cellTooltips;
  this.cellAttributes = cellAttributes;
  this.htmlContents = htmlContents;
  this.style = style;
  this.cssClass = cssClass;
  this.tooltip = tooltip;
  this.attributes = attributes;
  this.htmlContent = htmlContent;
 },
 GetColumnText: function(columnIndexOrFieldName){
  var columnIndex = -1;
  if(typeof(columnIndexOrFieldName) == "string")
   columnIndex = ASPx.Data.ArrayIndexOf(this.listEditBase.columnFieldNames, columnIndexOrFieldName);
  else if(typeof(columnIndexOrFieldName) == "number")
   columnIndex = columnIndexOrFieldName;
  return this.GetColumnTextByIndex(columnIndex);
 },
 GetColumnTextByIndex: function(columnIndex){
  if(0 <= columnIndex && columnIndex < this.texts.length)
   return this.texts[columnIndex];
  else
   return null;
 }
});
var ListBoxScrollCallbackHelperBase = ASPx.CreateClass(null, {
 constructor: function(listBoxControl) {
  this.listBoxControl = listBoxControl;
  this.itemsRange = "";
  this.defaultItemsRange = "0:" + (this.listBoxControl.callbackPageSize - 1);
 },
 OnScroll: function(){ },
 Reset: function(){ },
 IsScrolledToTopSpacer: function(){ return false; },
 IsScrolledToBottomSpacer: function(){ return false; },
 GetIsNeedToHideTopSpacer: function(){ return false; },
 GetIsNeedCallback: function(){ return false; },
 GetIsAnySpacerVisible: function() { return false; },
 GetItemsRangeForLoad: function(){ return this.defaultItemsRange; },
 SetItemsRangeForLoad: function(){}
});
var ListBoxScrollCallbackHelper = ASPx.CreateClass(ListBoxScrollCallbackHelperBase, {
 constructor: function(listBoxControl) {
  this.constructor.prototype.constructor.call(this, listBoxControl);
  this.isScrolledToTopSpacer = false;
  this.isScrolledToBottomSpacer = false;
 },
 OnScroll: function(){
  this.DetectScrollDirection();
  this.ResetItemsRange();
  if(this.GetIsAnySpacerVisible())
   this.RecalcItemsRangeForLoad();
 },
 DetectScrollDirection: function(){
  var listBoxControl = this.listBoxControl;
  var divElement = listBoxControl.GetScrollDivElement();
  var listTable = listBoxControl.GetListTable();
  var scrollTop = divElement.scrollTop;
  var scrollBottom = divElement.scrollTop + divElement.clientHeight;
  var isTopSpacerVisible = listBoxControl.GetScrollSpacerVisibility(true);
  var isBottomSpacerVisible = listBoxControl.GetScrollSpacerVisibility(false);
  this.isScrolledToTopSpacer = (scrollTop < parseInt(listBoxControl.GetTopSpacersHeight())) && isTopSpacerVisible;
  var listHeight = 0;
  if(listTable && listTable.tagName.toUpperCase() == "TABLE")
   listHeight = listTable.clientHeight;
  else {
   var itemElements = listBoxControl.GetItemElements();
   for(var i = 0; i < itemElements.length; i++)
    listHeight += itemElements[i].clientHeight;
  }
  this.isScrolledToBottomSpacer = (scrollBottom >= listBoxControl.GetTopSpacersHeight() + listHeight) && isBottomSpacerVisible;
 },
 Reset: function(){
  this.ResetItemsRange();
  this.isScrolledToTopSpacer = false;
  this.isScrolledToBottomSpacer = false;
 },
 ResetItemsRange: function(){
  this.itemsRange = "";
 },
 RecalcItemsRangeForLoad: function(){
  if(this.listBoxControl.isCallbackMode) {
   if(this.isScrolledToTopSpacer || this.isScrolledToBottomSpacer)
    this.SetItemsRangeForLoad(this.isScrolledToTopSpacer);
  }
 },
 IsScrolledToTopSpacer: function(){
  return this.isScrolledToTopSpacer;
 },
 IsScrolledToBottomSpacer: function(){
  return this.isScrolledToBottomSpacer;
 },
 GetIsAnySpacerVisible: function(){
  return this.isScrolledToTopSpacer || this.isScrolledToBottomSpacer;
 },
 GetIsNeedCallback: function(){
  return !this.GetIsItemsRangeEmpty();
 },
 GetIsNeedToHideTopSpacer: function(){
  return this.isScrolledToTopSpacer && this.GetIsItemsRangeEmpty();
 },
 GetItemsRangeForLoad: function(){
  return (!this.GetIsItemsRangeEmpty() ? this.itemsRange : this.defaultItemsRange);
 },
 SetItemsRangeForLoad: function(isForTop){
  var listbox = this.listBoxControl;
  var beginIndex = isForTop ? 
   listbox.serverIndexOfFirstItem - listbox.callbackPageSize : 
   listbox.serverIndexOfFirstItem + listbox.GetItemCount();
  beginIndex = beginIndex < 0 ? 0 : beginIndex;
  var endIndex = isForTop ? 
   listbox.serverIndexOfFirstItem - 1 : 
   beginIndex + listbox.callbackPageSize - 1;
  this.itemsRange = beginIndex + ":" + endIndex;
  this.isScrolledToTopSpacer = isForTop;
  this.isScrolledToBottomSpacer = !isForTop;
 },
 GetIsItemsRangeEmpty: function(){
  return (this.itemsRange == "" || this.itemsRange == emptyItemsRange);
 }
});
var ASPxClientListBoxBase = ASPx.CreateClass(ASPxClientListEdit, {
 constructor: function(name) {
  this.constructor.prototype.constructor.call(this, name);
  this.APILockCount = 0;
  this.updateSelectAllElementsLockCount = 0;
  this.enableSyncOnPerfCallback = false;
  this.scrollOnKBNavigationLockCount = 0;
  this.isComboBoxList = false;
  this.isSyncEnabled = true;
  this.ownerName = "";
  this.selectionEventsLockCount = 0;
  this.syncLockCount = 0;
  this.encodeHtml = true;
  this.useCaseInsensitiveSearch = true;
  this.serializingHelper = null;
  this.deletedItems = [];
  this.insertedItems = [];
  this.itemsValue = [];
  this.ItemDoubleClick = new ASPxClientEvent();
  this.ItemClick = new ASPxClientEvent();
 },
 InlineInitialize: function () {
  ASPxClientListEdit.prototype.InlineInitialize.call(this);
  for(var i = 0; i < this.itemsValue.length; i++)
   this.itemsValue[i] = this.GetDecodeValue(this.itemsValue[i]);
 },
 LockScrollOnKBNavigation: function(){
  this.scrollOnKBNavigationLockCount++;
 },
 UnlockScrollOnKBNavigation: function(){
  this.scrollOnKBNavigationLockCount--;
 },
 IsScrollOnKBNavigationLocked: function() {
  return this.scrollOnKBNavigationLockCount > 0;
 },
 LockSelectionEvents: function(){
  this.selectionEventsLockCount++;
 },
 UnlockSelectionEvents: function(){
  this.selectionEventsLockCount--;
 },
 IsSelectionEventsLocked: function(){
  return this.selectionEventsLockCount > 0;
 },
 LockSynchronizationOnInternalCallback: function(){
  if(!this.enableSyncOnPerfCallback)
   this.LockSynchronization();
 },
 UnlockSynchronizationOnInternalCallback: function (){
  if(!this.enableSyncOnPerfCallback)
   this.UnlockSynchronization();
 },
 GetItemCount: function(){
  return 0;
 },
 GetItemValue: function(index){
  if(0 <= index && index < this.GetItemCount())
   return this.PrepareItemValue(this.itemsValue[index]);
  return null;
 },
 GetItemTexts: function(item) {
  return item.text;
 },
 PrepareItemValue: function(value) {
  return (typeof(value) == "string" && value == "" && this.convertEmptyStringToNull) ? null : value;
 },
 LoadItemsFromCallback: function(isToTop, itemStrings){
 },
 SetValue: function(value){
  var index = this.FindItemIndexByValue(value);
  this.SelectIndexSilentAndMakeVisible(index);
 },
 FindItemIndexByText: function(text){
  var transformText = function(text) { return text; };
  var textIsString = typeof(text) === "string";
  if(this.useCaseInsensitiveSearch && textIsString)
   transformText = function(text) { return text.toUpperCase(); };
  text = transformText(text);
  for(var i = 0; i < this.GetItemCount(); i ++){
   if(transformText(this.GetItem(i).text) == text)
    return i;
  }
  return -1;
 },
 SelectIndex: function (index){ 
  if(this.SelectIndexSilentAndMakeVisible(index, false)){
   this.RaisePersonalStandardValidation();
   this.OnValueChanged();
  }
 },
 SelectIndexSilentAndMakeVisible: function(index, lockScrollingToItem){
  var selectionChanged = this.SelectIndexSilent(index);
  if(!this.IsScrollOnKBNavigationLocked() && !lockScrollingToItem)
   this.MakeItemVisible(index);
  return selectionChanged;
 },
 FormatText: function (texts) {
  return texts;
 },
 MakeItemVisible: function(index){
 },
 InitOnContainerMadeVisible: function(){
 },
 AddItem: function(texts, value, imageUrl) {
  return this.AddItemInternal(this.CreateItemProperties(texts, value, imageUrl));
 },
 AddItemInternal: function(itemProperties) {
  var index = this.GetItemCount();
  this.InsertItemInternal(index, itemProperties);
  if(!ASPx.IsExists(this.GetItem(index)))
   index = -1;
  return index;
 },
 InsertItem: function(index, texts, value, imageUrl) {
  this.InsertItemInternal(index, this.CreateItemProperties(texts, value, imageUrl));
 },
 CreateItemProperties: function(texts, value, imageUrl, htmlContent, cssClass, tooltip) {
  return {
   texts: texts,
   value: value,
   imageUrl: imageUrl,
   htmlContent: htmlContent,
   cssClass: cssClass,
   tooltip: tooltip
  };
 },
 InsertItemInternal: function(index, itemProperties) {
 },
 BeginUpdate: function(){
  this.APILockCount ++;
 },
 EndUpdate: function(){
  this.APILockCount --;
  this.Synchronize();
 },
 LockUpdateSelectAllElements: function() {
  this.updateSelectAllElementsLockCount++;
 },
 UnlockUpdateSelectAllElements: function () {
  this.updateSelectAllElementsLockCount--;
 },
 IsUpdateSelectAllElementsLocked: function() {
  return this.updateSelectAllElementsLockCount > 0;
 },
 ClearItems: function(){
  this.BeginUpdate();
  this.UpdateArraysItemsCleared();
  this.ClearItemsCore();
  this.EndUpdate();
 },
 ClearItemsCore: function(){
 },
 ClearItemsForPerformCallback: function(){
  this.itemsValue = [];
  this.ClearItemsCore();
 },
 RemoveItem: function(index){
 },
 FindItemByText: function(text){
  var index = this.FindItemIndexByText(text);
  return this.GetItem(index);
 },
 FindItemByValue: function(value){
  var index = this.FindItemIndexByValue(value);
  return this.GetItem(index);
 },
 PerformCallback: function(arg) {
 },
 GetCallbackArguments: function(){
  var args = this.GetCustomCallbackArg();
  args += this.GetLoadItemsRangeCallbackArg();
  if(this.filterStrategy)
   args += this.filterStrategy.GetCallbackArguments();
  return args;
 },
 GetLoadItemsRangeCallbackArg: function(){
  return this.GetLoadItemsRangeCallbackArgCore(this.GetItemsRangeForLoad());
 },
 GetLoadCustomItemsRangeCallbackArguments: function(beginIndex, endIndex, value) {
  var itemsRange = beginIndex + ":" + endIndex;
  if(ASPx.IsExists(value))
   itemsRange = itemsRange + ":" + ASPx.Json.ToJson(value);
  var args = this.GetCustomCallbackArg();
  args += this.GetLoadItemsRangeCallbackArgCore(itemsRange);
  return args;
 },
 GetLoadItemsRangeCallbackArgCore: function(itemsRange) {
  return this.FormatCallbackArg(CONSTANTS.CALLBACK_PREFIXES.LOAD_RANGE_ITEMS, itemsRange);
 },
 FormatCallbackArg: function(prefix, arg) { 
  arg = arg.toString();
  return (ASPx.IsExists(arg) ? prefix + "|" + arg.length + ';' + arg + ';' : "");
 },
 GetItemsRangeForLoad: function(){
  return emptyItemsRange;
 },
 GetCallbackOwnerControl: function(){
  if(this.ownerName && !this.ownerControl)
   this.ownerControl = ASPx.GetControlCollection().Get(this.ownerName);
  return this.ownerControl;
 },
 GetCustomCallbackArg: function(){
  return this.stateObject["CustomCallback"];
 },
 SetCustomCallbackArg: function(arg){
  this.UpdateStateObjectWithObject({ CustomCallback: arg });
 },
 FormatAndSetCustomCallbackArg: function(arg, onPerformCallback){
  arg = ASPx.IsExists(arg) ? arg.toString() : "";
  var formatArg = this.FormatCallbackArg(onPerformCallback ? CONSTANTS.CALLBACK_PREFIXES.CUSTOMPERFORM : CONSTANTS.CALLBACK_PREFIXES.CUSTOM, arg);
  this.SetCustomCallbackArg(formatArg);
 },
 SendCallback: function(){
 },
 LockSynchronization: function(){
  this.syncLockCount++;
 },
 UnlockSynchronization: function(){
  this.syncLockCount--;
 },
 IsSyncLocked: function(){
  return this.syncLockCount > 0;
 },
 IsSyncEnabled: function(){
  return this.isSyncEnabled && !this.IsSyncLocked();
 },
 RegisterInsertedItem: function(index, itemProperties){
  if(this.IsSyncEnabled()){
   this.RefreshSynchroArraysIndex(index, true);
   var item = this.CreateItem(index, itemProperties);
   this.insertedItems.push(item);
   this.Synchronize();
  }
 },
 CreateItem: function(index, itemProperties) {
  return new ASPxClientListBoxItem(this, index, itemProperties.texts || [itemProperties.text], itemProperties.value, itemProperties.imageUrl,
   itemProperties.selected, itemProperties.cellStyles, itemProperties.cellCssClasses, itemProperties.cellTooltips, itemProperties.cellAttributes, itemProperties.htmlContents,
   itemProperties.style, itemProperties.cssClass, itemProperties.tooltip, itemProperties.attributes, itemProperties.htmlContent);
 },
 UpdateSyncArraysItemDeleted: function(item, isValueRemovingRequired){
  if(isValueRemovingRequired)
   ASPx.Data.ArrayRemoveAt(this.itemsValue, item.index);
  if(this.IsSyncEnabled()){
   var index = this.FindItemInArray(this.insertedItems, item);
   if(index == -1){
    this.RefreshSynchroArraysIndex(item.index, false);
    this.deletedItems.push(item);
   } else {
    this.RefreshSynchroArraysIndex(item.index, false);
    ASPx.Data.ArrayRemoveAt(this.insertedItems, index);
   }
   this.Synchronize();
  }
 },
 UpdateArraysItemsCleared: function(){
  if(this.IsSyncEnabled()){
   for(var i = this.GetItemCount() - 1; i >= 0; i --)
    this.UpdateSyncArraysItemDeleted(this.GetItem(i), false);
  } 
  this.itemsValue = [];
 },
 RefreshSynchroArraysIndex: function(startIndex, isIncrease){
  this.RefreshSynchroArrayIndexIndex(this.deletedItems, startIndex, isIncrease);
  this.RefreshSynchroArrayIndexIndex(this.insertedItems, startIndex, isIncrease);
 },
 RefreshSynchroArrayIndexIndex: function(array, startIndex, isIncrease){
  var delta = isIncrease ? 1 : -1;
  for(var i = 0; i < array.length; i ++){
   if(array[i].index >= startIndex)
    array[i].index += delta;
  }   
 },
 FindItemInArray: function(array, item){
  for(var i = array.length - 1; i >= 0; i--){
   var currentItem = array[i];
   if((!this.encodeHtml || currentItem.text == item.text) && currentItem.value == item.value &&
    currentItem.imageUrl == item.imageUrl)
    break;
  }
  return i;
 },
 Synchronize: function(){
  if(this.APILockCount == 0){
   if(this.IsSyncEnabled()){
    this.SynchronizeItems(this.deletedItems, "DeletedItems");
    this.SynchronizeItems(this.insertedItems, "InsertedItems");
   }
   this.CorrectSizeByTimer();
  }
 },
 CorrectSizeByTimer: function(){
 },
 SynchronizeItems: function(items, syncType){
  var itemsObj = { };
  itemsObj[syncType] = this.SerializeItems(items);
  this.UpdateStateObjectWithObject(itemsObj);
 },
 GetSerializingHelper: function(){ 
  if(this.serializingHelper == null)
   this.serializingHelper = this.CreateSerializingHelper();
  return this.serializingHelper;
 },
 CreateSerializingHelper: function(){
  return new ListBoxBaseItemsSerializingHelper(this);
 },
 SerializeItems: function(items){
  var serialiser = this.GetSerializingHelper();
  return serialiser.SerializeItems(items);
 },
 DeserializeItems: function(items) {
  return items.map(function(itemProperties, index) {
   return this.CreateItem(index, itemProperties);
  }.bind(this));
 }
});
var ListBoxBaseItemsSerializingHelper = ASPx.CreateClass(null, {
 constructor: function(listBoxControl) {
  this.listBoxControl = listBoxControl;
  this.startPos = 0;
 },
 SerializeItems: function(items){
  var sb = [ ];
  for(var i = 0; i < items.length; i++)
   this.SerializeItem(sb, items[i]);
  return sb.join("");
 },
 SerializeItem: function(sb, item) {
  if(!item)
   return;
  this.SerializeAtomValue(sb, item.index);
  this.SerializeAtomValue(sb, item.value);
  this.SerializeAtomValue(sb, item.imageUrl);
  var texts = this.listBoxControl.GetItemTexts(item);
  if(typeof(texts) == "string")
   this.SerializeAtomValue(sb, texts);
  else {
   for(var i = 0; i < texts.length; i++)
    this.SerializeAtomValue(sb, texts[i]);
  }
 },
 SerializeAtomValue: function(sb, value) {
  var valueStr = ASPx.IsExists(value) ? value.toString() : "";
  sb.push(valueStr.length);
  sb.push('|');
  sb.push(valueStr);
 },
 ParseItemIndex: function(serializedItem){
  return parseInt(this.ParseString(serializedItem));
 },
 ParseItemValue: function(serializedItem){
  return this.ParseString(serializedItem);
 },
 ParseString: function(str){
  var indexOfSeparator = str.indexOf(serializingSeparator, this.startPos);
  var strLength = parseInt(str.substring(this.startPos, indexOfSeparator));
  var strStartPos = indexOfSeparator + serializingSeparatorLength;
  this.startPos = strStartPos + strLength;
  return str.substring(strStartPos, strStartPos + strLength);
 },
 ParseTexts: function(serializedItems){
  return this.ParseString(serializedItems);
 },
 DeserializeValues: function(serializedValues){
  var deserializedValues = [];
  this.startPos = 0;
  while(this.startPos < serializedValues.length){
   deserializedValues.push(this.ParseItemValue(serializedValues));
  }
  return deserializedValues;
 }
});
var ListBoxItemsSerializingHelper = ASPx.CreateClass(ListBoxBaseItemsSerializingHelper, {
 constructor: function(listBoxControl) {
  this.constructor.prototype.constructor.call(this, listBoxControl);
 },
 ParseTexts: function(serializedItems){
  var textColumnCount = this.listBoxControl.GetItemTextCellCount();
  return (textColumnCount > 1) ? this.DeserializeItemTexts(serializedItems, textColumnCount) 
   : ListBoxBaseItemsSerializingHelper.prototype.ParseTexts.call(this, serializedItems);
 },
 DeserializeItemTexts: function(serializedItem, textColumnCount){
  var texts = [];
  for(var i = 0; i < textColumnCount; i++)
   texts.push(this.ParseString(serializedItem));
  return texts;
 }
});
var ListBoxSingleSelectionHelper = ASPx.CreateClass(null, {
 constructor: function(listBoxControl) {
  this.listBoxControl = listBoxControl;
  this.savedSelectedIndex = listBoxControl.savedSelectedIndex;
  this.updateHiddenInputsLockCount = 0;
  this.cachedSelectionChangedArgs = [];
 },
 ClearSelection: function(){
  this.SetSelectedIndexCore(-1);
  this.OnSelectionCleared();
 },
 OnSelectionCleared: function(){
  this.cachedSelectionChangedArgs = [];
 },
 GetSelectedIndexInternal: function(){
  return this.savedSelectedIndex;
 }, 
 SetSelectedIndexInternal: function(index){
  this.savedSelectedIndex = index;
 }, 
 SetSelectedIndexCore: function(index){
  if(index != this.savedSelectedIndex && -1 <= index && index < this.GetItemCount()){
   this.BeginSelectionUpdate();
   this.SetSelectedIndexInternal(index);
   this.EndSelectionUpdate();
   return true;
  }
  return false;
 },
 GetSelectedIndex: function(){
  return this.GetSelectedIndexInternal();
 },
 SetSelectedIndex: function(index){
  this.ChangeSelectedItem(index);
  this.SetSelectedIndexCore(index);
  this.OnItemSelectionChanged(index, true);
 },
 GetSelectedIndices: function(){ 
  var selectedIndex = this.GetSelectedIndexInternal();
  return selectedIndex != -1 ? [selectedIndex] : [];
 },
 GetSelectedValues: function(){ 
  var selectedValue =  this.listBoxControl.GetValue();
  return selectedValue != null ? [selectedValue] : [];
 },
 GetSelectedItems: function(){ 
  var selectedItem = this.listBoxControl.GetSelectedItem();
  return selectedItem != null? [selectedItem] : [];
 },
 SelectIndices: function(indices){},
 SelectItems: function(items){},
 SelectValues: function(values){},
 UnselectIndices: function (selected) { this.SetSelectedIndex(-1); },
 UnselectItems: function(items){},
 UnselectValues: function(values){},
 GetIsItemSelected: function(index){ return index == this.GetSelectedIndexInternal(); },
 ResetSelectionCollectionsCache: function(){ },
 OnItemClick: function(index, evt){
  var selected = true;
  this.BeginSelectionUpdate();
  this.ChangeSelectedItem(index);
  var selectedIndexChanged = this.SetSelectedIndexCore(index);
  this.EndSelectionUpdate();
  if(selectedIndexChanged)
   this.OnItemSelectionChanged(index, selected);
 },
 ChangeSelectedItem: function(newSelectedIndex){
  var selected = true;
  var oldSelectedIndex = this.GetSelectedIndexInternal();
  this.BeginSelectionUpdate();
  this.SetItemSelectionState(oldSelectedIndex, !selected);
  this.SetItemSelectionState(newSelectedIndex, selected);
  this.EndSelectionUpdate();
 },
 SetItemSelectionState: function (itemIndex, selected, controller) {
  this.BeginSelectionUpdate();
  this.listBoxControl.SetItemSelectionAppearance(itemIndex, selected, controller, true);
  this.EndSelectionUpdate();
 },
 GetFocusedIndex: function(){
  return this.GetSelectedIndexInternal();
 },
 BeginSelectionUpdate: function(){
  this.updateHiddenInputsLockCount++;
 },
 EndSelectionUpdate: function(){
  this.updateHiddenInputsLockCount--;
  if(!this.IsUpdateInternalSelectionStateLocked()){
   this.listBoxControl.UpdateInternalState();
   this.FlushSelectionChanged();
  }
 },
 IsUpdateInternalSelectionStateLocked: function(){
  return this.updateHiddenInputsLockCount > 0;
 },
 GetItemCount: function(){
  return this.listBoxControl.GetItemCount();
 },
 OnItemSelectionChanged: function(index, selected){
  if(this.IsUpdateInternalSelectionStateLocked()){
   var a = {Index: index, Selected: selected};
   this.cachedSelectionChangedArgs.push(a);
  }
  else 
   this.listBoxControl.OnItemSelectionChanged(index, selected);
 },
 FlushSelectionChanged: function(){
  if(this.IsUpdateInternalSelectionStateLocked()) 
   return;
  for(var i = 0; i < this.cachedSelectionChangedArgs.length; i++)
   this.listBoxControl.OnItemSelectionChanged(this.cachedSelectionChangedArgs[i].Index, this.cachedSelectionChangedArgs[i].Selected);
  this.cachedSelectionChangedArgs = [];
 },
 OnItemInserted: function(index){
  if(index <= this.savedSelectedIndex && this.savedSelectedIndex != -1)
   this.SetSelectedIndexInternal(this.savedSelectedIndex + 1);
 },
 OnItemRemoved: function(index){
  if(index < this.savedSelectedIndex)
   this.SetSelectedIndexInternal( this.savedSelectedIndex - 1);
  else if(index == this.savedSelectedIndex)
   this.SetSelectedIndexInternal(-1);
 },
 OnItemsCleared: function(){
  this.ClearSelection();
 }
});
var ListBoxMultiSelectionHelper = ASPx.CreateClass(ListBoxSingleSelectionHelper, {
 constructor: function(listBoxControl) {
  this.constructor.prototype.constructor.call(this, listBoxControl);
  this.selectedValuesCache = [];
  this.selectedItemsCache = [];
  this.savedSelectedIndices = [];
  this.selectedIndicesSortingRequired = false;
  this.focusedIndex = -1;
  this.lastIndexFocusedWithoutShift = -1;
 },
 SetSelectedIndex: function(index){
  this.SingleIndexSelection(index);
 },
 SetSelectedIndexCore: function(index){
  ListBoxSingleSelectionHelper.prototype.SetSelectedIndexCore.call(this, index);
  this.updateSelectAllElementsState();
 },
 updateSelectAllElementsState: function() {
  this.listBoxControl.updateSelectAllElementsState();
 },
 ResetSelectionCollectionsCache: function(){
  this.selectedIndicesSortingRequired = true;
  this.selectedItemsCache = [];
  this.selectedValuesCache = [];
 },
 GetSelectedIndices: function(){
  return this.GetSortedSelectedIndices().slice();
 },
 GetSortedSelectedIndices: function() {
  if(this.savedSelectedIndices.length > 1 && this.selectedIndicesSortingRequired)
   this.SortSelectedIndices();
  return this.savedSelectedIndices;
 },
 GetSelectedValues: function(){ 
  if(this.savedSelectedIndices.length == 0)
   return [];
  if(this.selectedValuesCache.length == 0)
   this.selectedValuesCache = this.GetSelectedValuesCore();
  return this.selectedValuesCache;
 },
 GetSelectedValuesCore: function(){
  var selectedValues = [];
  var selectedIndices = this.GetSortedSelectedIndices();
  if(selectedIndices.length == 0)
   return selectedValues;
  for(var i = 0; i < selectedIndices.length; i++)
   selectedValues.push(this.listBoxControl.GetItemValue([selectedIndices[i]]));
  return selectedValues;
 },
 GetSelectedItems: function(){
  if(this.savedSelectedIndices.length == 0)
   return [];
  if(this.selectedItemsCache.length == 0)
   this.selectedItemsCache = this.GetSelectedItemsCore();
  return this.selectedItemsCache;
 },
 GetSelectedItemsCore: function(){
  var selectedItems = [];
  for(var i = 0; i < this.savedSelectedIndices.length; i++)
   selectedItems.push(this.listBoxControl.GetItem(this.savedSelectedIndices[i]));
  return selectedItems;
 },
 SetIndicesSelectionState: function(indices, selected){
  this.BeginSelectionUpdate();
  var controller = typeof(ASPx.GetStateController) != "undefined" ? ASPx.GetStateController() : null;
  this.LockForceRedrawAppearance(controller);
  if(indices){
   var itemCount = this.listBoxControl.GetItemCount();
   for(var i = 0; i < indices.length; i++) {
    var index = indices[i];
    if(index >= 0 && index < itemCount)
     this.SetItemSelectionState(indices[i], selected, controller);
   }
  } else if(this.IsClientFilterApplied())
   this.SetAllFilteredItemsSelectionState(selected, controller);
  else
   this.SetAllItemsSelectionState(selected, controller);
  this.UnlockForceRedrawAppearance(controller);
  this.SetSelectedIndexCore(this.GetFirstSelectedIndex());
  this.EndSelectionUpdate();
 },
 IsClientFilterApplied: function() {
  return this.listBoxControl.IsClientFilterApplied();
 },
 SetAllFilteredItemsSelectionState: function (selected, controller) {
  for (var i = 0; i < this.listBoxControl.GetItemCount() ; i++) {
   if (this.listBoxControl.IsItemFiltered && !this.listBoxControl.IsItemFiltered(i))
    continue;
   this.SetItemSelectionState(i, selected, controller);
  }
 },
 SetItemsSelectionState: function(items, selected){
  var indices = items ? this.ConvertItemsToIndices(items) : null;
  this.SetIndicesSelectionState(indices, selected);
 },
 SetValuesSelectionState: function(values, selected){
  var indices = values ? this.ConvertValuesToIndices(values)  : null;
  this.SetIndicesSelectionState(indices, selected);
 },
 ConvertValuesToIndices: function(values){
  var indices = [];
  for(var i = 0; i < values.length; i++)
   indices.push(this.listBoxControl.FindItemIndexByValue(values[i]));
  return indices;
 },
 ConvertItemsToIndices: function(items){
  var indices = [];
  for(var i = 0; i < items.length; i++)
   indices.push(items[i].index);
  return indices;
 },
 SelectIndices: function(indices){
  this.SetIndicesSelectionState(indices, true);
 },
 SelectItems: function(items){
  this.SetItemsSelectionState(items, true);
 },
 SelectValues: function(values){
  this.SetValuesSelectionState(values, true);
 },
 UnselectIndices: function(indices){
  this.SetIndicesSelectionState(indices, false);
 },
 UnselectItems: function(items){
  this.SetItemsSelectionState(items, false);
 },
 UnselectValues: function(values){
  this.SetValuesSelectionState(values, false);  
 },
 GetIsItemSelected: function(index){ 
  return ASPx.Data.ArrayBinarySearch(this.GetSortedSelectedIndices(), index) > -1;
 },
 OnItemClick: function(index, evt){
  this.BeginSelectionUpdate();
  var ctrlKey = evt.ctrlKey || evt.metaKey;
  var shift = evt.shiftKey;
  if(ctrlKey)
   this.AddSelectedIndex(index);
  else if(shift){
   var startIndex = index > this.lastIndexFocusedWithoutShift ? this.lastIndexFocusedWithoutShift + 1 : index;
   var endIndex = index > this.lastIndexFocusedWithoutShift ? index : this.lastIndexFocusedWithoutShift - 1;
   this.SelectRangeIndicesOnly(startIndex, endIndex);
   this.SetFocusedIndexInternal(index, true);
  }else 
   this.SingleIndexSelection(index);
  this.EndSelectionUpdate();
 },
 OnItemCheckBoxClick: function(index, evt){
  this.BeginSelectionUpdate();
  this.AddSelectedIndex(index);
  this.EndSelectionUpdate();
 },
 AddSelectedIndex: function(index){
  this.SetFocusedIndexInternal(index, false);
  var indexInSelectedIndices = ASPx.Data.ArrayIndexOf(this.savedSelectedIndices, index);
  var selectionOperation = indexInSelectedIndices == -1;
  this.SetItemSelectionState(index, selectionOperation);
  this.SetSelectedIndexCore(this.GetFirstSelectedIndex());
 },
 SelectRangeIndicesOnly: function(startIndex, endIndex){
  this.BeginSelectionUpdate();
  var controller = typeof(ASPx.GetStateController) != "undefined" ? ASPx.GetStateController() : null;
  if(startIndex < endIndex)
   this.LockForceRedrawAppearance(controller);
  var itemCount = this.GetItemCount();
  for(var i = 0; i < itemCount; i ++) {
   if(i == this.lastIndexFocusedWithoutShift) 
    continue;
   if(startIndex !== endIndex && this.listBoxControl.IsItemFiltered && !this.listBoxControl.IsItemFiltered(i))
    continue;
   this.SetItemSelectionState(i, i >= startIndex && i <= endIndex, controller);
  }
  this.SetSelectedIndexCore(this.GetFirstSelectedIndex());
  if(startIndex < endIndex)
   this.UnlockForceRedrawAppearance(controller);
  this.EndSelectionUpdate();
 },
 SingleIndexSelection: function(index){
  this.SetFocusedIndexInternal(-1, false);
  this.SelectRangeIndicesOnly(index, index);
  this.SetFocusedIndexInternal(index, false);
 },
 LockForceRedrawAppearance: function(controller) {
   if(controller && ASPx.Browser.IE && ASPx.Browser.MajorVersion >= 11)
   controller.LockForceRedrawAppearance();
 },
 UnlockForceRedrawAppearance: function(controller) {
  if(controller && ASPx.Browser.IE && ASPx.Browser.MajorVersion >= 11)
   controller.UnlockForceRedrawAppearance();
 },
 SetAllItemsSelectionState: function(selected, controller){
  this.BeginSelectionUpdate();
  this.savedSelectedIndices = [ ];
  var itemCount = this.GetItemCount();
  for (var i = 0; i < itemCount; i++) {
   this.SetItemSelectionStateCore(i, selected, controller);
   if(selected)
    this.PushSelectedIndex(i);
   this.OnItemSelectionChanged(i, selected);
  }
  this.ResetSelectionCollectionsCache();
  this.EndSelectionUpdate();
 },
 SetItemSelectionState: function(itemIndex, selected, controller){
  this.SetItemSelectionStateCore(itemIndex, selected, controller);
  this.ResetSelectionCollectionsCache();
  var indexInSelectionArray = this.savedSelectedIndices.indexOf(itemIndex);
  if(selected && indexInSelectionArray == -1){
   this.PushSelectedIndex(itemIndex);
   this.OnItemSelectionChanged(itemIndex, true);
  }
  if(!selected && indexInSelectionArray != -1){
   this.RemoveSelectedIndexAt(indexInSelectionArray);
   this.OnItemSelectionChanged(itemIndex, false);
  }
 },
 GetFirstSelectedIndex: function(){
  var selectedIndices = this.GetSelectedIndices();
  var selectedIndicesCount = selectedIndices.length;
  var firstSelectedIndex = -1;
  if(selectedIndicesCount > 0){
   firstSelectedIndex = selectedIndices[0];
   for(var i = 1; i < selectedIndices.length; i++){
    if(firstSelectedIndex > selectedIndices[i])
     firstSelectedIndex = selectedIndices[i];
   }
  }
  return firstSelectedIndex;
 },
 PushSelectedIndex: function(index){
  this.savedSelectedIndices.push(index);
 },
 RemoveSelectedIndex: function(index){
  ASPx.Data.ArrayRemove(this.savedSelectedIndices, index);
 },
 RemoveSelectedIndexAt: function(indexInArray){
  ASPx.Data.ArrayRemoveAt(this.savedSelectedIndices, indexInArray);
 },
 SortSelectedIndices: function(){
  ASPx.Data.ArrayIntegerAscendingSort(this.savedSelectedIndices);
  this.selectedIndicesSortingRequired = false;
 },
 SetItemSelectionStateCore: function(itemIndex, selected, controller){
  ListBoxSingleSelectionHelper.prototype.SetItemSelectionState.call(this, itemIndex, selected, controller);
 },
 GetFocusedIndex: function(){
  return this.focusedIndex;
 },
 SetFocusedIndexInternal: function(index, isShiftPressed){
  if(!isShiftPressed)
   this.lastIndexFocusedWithoutShift = index;
  this.focusedIndex = index;
 },
 OnItemInserted: function(index){
  this.ResetSelectionCollectionsCache();
  ListBoxSingleSelectionHelper.prototype.OnItemInserted.call(this, index);
  if(this.focusedIndex >= index)
   this.focusedIndex ++;
  for(var i = 0; i < this.savedSelectedIndices.length; i++){
   if(this.savedSelectedIndices[i] >= index)
    this.savedSelectedIndices[i]++;
  }
  this.updateSelectAllElementsState();
 },
 OnItemRemoved: function(index){
  this.ResetSelectionCollectionsCache();
  ListBoxSingleSelectionHelper.prototype.OnItemRemoved.call(this, index);
  if(this.focusedIndex == index)
   this.focusedIndex = -1;
  else if(this.focusedIndex > index)
   this.focusedIndex --;
  if(this.GetIsItemSelected(index))
   this.RemoveSelectedIndex(index);
  for(var i = 0; i < this.savedSelectedIndices.length; i++){
   if(this.savedSelectedIndices[i] > index)
    this.savedSelectedIndices[i]--;
  }
  if(this.GetSelectedIndex() == -1)
   this.SetSelectedIndexCore(this.GetFirstSelectedIndex());
  this.updateSelectAllElementsState();
 },
 ClearSelection: function(){
  this.ResetSelectionCollectionsCache();
  ASPx.Data.ArrayClear(this.savedSelectedIndices);
  this.OnSelectionCleared();
  this.SetSelectedIndexCore(-1);
 }
});
var CheckBoxListMultiSelectionHelper = ASPx.CreateClass(ListBoxMultiSelectionHelper, {
 OnItemClick: function(index){
  this.BeginSelectionUpdate();
  this.AddSelectedIndex(index);
  this.EndSelectionUpdate();
 },
 GetFocusedItemIndex: function(){
  return this.lastIndexFocusedWithoutShift;
 },
 updateSelectAllElementsState: function () { },
 IsClientFilterApplied: function() { return false; }
});
var ListBoxCheckSelectionHelper = ASPx.CreateClass(ListBoxMultiSelectionHelper, {
 OnItemClick: function(index, evt){
  this.BeginSelectionUpdate();
  if(evt.shiftKey)
   ListBoxMultiSelectionHelper.prototype.OnItemClick.call(this, index, evt);
  else
   this.AddSelectedIndex(index);
  this.EndSelectionUpdate();
 }
});
var ASPxClientListBox = ASPx.CreateClass(ASPxClientListBoxBase, {
 constructor: function(name) {
  this.constructor.prototype.constructor.call(this, name);
  this.freeUniqIndex = -1;
  this.isHasFakeRow = false;
  this.headerDiv = null;
  this.headerTable = null;
  this.listTable = null;
  this.sampleItemFirstTextCell = null;
  this.width = "";
  this.defaultHeight = "";
  this.hasSampleItem = false;
  this.hoverClasses = [""];
  this.hoverCssArray = [""];
  this.selectAllHoverClasses = [""];
  this.selectAllHoverCssArray = [""];
  this.selectAllDisabledClasses = [""];
  this.selectAllDisabledCssArray = [""];
  this.selectedClasses = [""];
  this.selectedCssArray = [""];
  this.disabledClasses = [""];
  this.disabledCssArray = [""];
  this.imageCellExists = false;
  this.scrollHandlerLockCount = 0;
  this.columnFieldNames = [];
  this.textFormatString = "";
  this.nullValueItemDisplayText = null;
  this.defaultImageUrl = "";
  this.selectionMode = 0;
  this.initSelectedIndices = [];
  this.itemHorizontalAlign = "";
  this.emptyTextRowCellIndices = null;
  this.accessibilityHelper = null;
  this.accessibilityHelperID = "";
  this.allowMultipleCallbacks = false;
  this.isCallbackMode = false;
  this.callbackPageSize = -1;
  this.isTopSpacerVisible = false;
  this.isBottomSpacerVisible = false;
  this.serverIndexOfFirstItem = 0;
  this.scrollHelper = null;
  this.changeSelectAfterCallback = 0;
  this.ownerControl = null;
  this.SampleItem = null;
  this.sampleHeaderRow = null;
  this.scrollDivElement = null;
  this.scrollPageSize = 4;
  this.itemsValue = [];
  this.cachedValue = null;
  this.tempCache = new ListBoxTemporaryCache();
  this.sizingConfig.adjustControl = true;
  this.disableScrolling = false;
  this.icbFocusedStyle = null;
  this.icbImageProperties = null;
  this.internalCheckBoxCollection = null;
  this.focusableCheckInput = null;
  this.nativeCheckOnFocusHandler = null;
  this.enableSelectAll = false;
  this.enableFiltering = false;
  this.filteringDelay = 100;
  this.filterMinLength = 1;
  this.filterTimerID = -1;
  this.customFilteringEditorID = "";
  this.filteringTextBox = null;
  this.filteringTextBoxInput = null;
  this.showFilterButtonInput = null;
  this.highlighting = this.CreateHighlightingHelper();
  this.hasDecoratedItems = false;
  this.scrollDivMinWidth = 0;
  this.ItemFiltering = new ASPxClientEvent();
  this.CustomHighlighting = new ASPxClientEvent();
 },
 Initialize: function() {   
  this.LockScrollHandler();
  this.InitScrollPos();
  if((ASPx.Browser.WebKitTouchUI || (ASPx.Browser.WindowsPhonePlatform && ASPx.Browser.IE)) && !this.disableScrolling)
   ASPx.TouchUIHelper.MakeScrollable(this.GetScrollDivElement(), {showHorizontalScrollbar: false});
  this.CreateInternalCheckBoxCollection();
  this.InitSelection();
  if(!this.isComboBoxList && this.ResetItemHeightIfRequired())
   this.AdjustControlCore();
  this.InitializeLoadOnDemand();
  this.UnlockScrollHandler();
  if(!this.HasVirtualScrolling())
   this.freeUniqIndex = this.GetItemCount();
  ASPxClientEdit.prototype.Initialize.call(this);
  if(this.NeedUnfocusableScrollDivElement())
   ASPx.Attr.SetAttribute(this.GetScrollDivElement(), "tabIndex", "-1");
  this.EnsureFilteringElements();
 },
 InitDXTextAttributes: function(){
  if(this.emptyTextRowCellIndices != null){
   var itemWithDXTextCount = this.emptyTextRowCellIndices.length;
   for(var i = 0; i < itemWithDXTextCount; i++){
    var itemIndex = this.emptyTextRowCellIndices[i][0];
    var cellIndices = this.emptyTextRowCellIndices[i][1];
    var itemRow = this.GetItemRow(itemIndex);
    if(!itemRow) continue;
    for(var j = 0; j < cellIndices.length; j++){
     ASPx.Attr.SetAttribute(itemRow.cells[cellIndices[j]], "DXText", "");
    }
   }
  }
 },
 InitSelection: function(){
  var valueFromLastTime = this.GetValueFromValueInput();
  if(this.MultiSelectionMode()){
   if(valueFromLastTime != ""){
    var serialiser = this.GetSerializingHelper();
    var selectedValuesFromLastTime = serialiser.DeserializeValues(valueFromLastTime);
    var selectedIdicesFromLastTime = [];
    for(var i = 0; i < selectedValuesFromLastTime.length; i++)
     selectedIdicesFromLastTime.push(this.FindItemIndexByValue(selectedValuesFromLastTime[i]));
    this.SelectIndices(selectedIdicesFromLastTime);
   } else
    this.SelectIndices(this.initSelectedIndices);
  } else {
   var selectedIndex = (valueFromLastTime != "") ? 
    this.FindItemIndexByValue(valueFromLastTime) : this.GetSelectedIndexInternal();
   this.SetSelectedIndexInternal(selectedIndex);
   this.SelectIndexSilent(selectedIndex);
   this.GetItemSelectionHelper().SetSelectedIndexInternal(selectedIndex);
  }
  this.CacheValue();
 },
 GetShowFilterButton: function() {
  return ASPx.GetControlCollection().Get(this.name + "_" + showFilterButtonID);
 },
 CreateHighlightingHelper: function() {
  return new ASPx.ListBoxHighlightingHelper(this, "em");
 },
 CreateInternalCheckBoxCollection: function() {
  if(this.IsNativeCheckBoxes() || this.internalCheckBoxCollection)
   return;
  this.internalCheckBoxCollection = new ASPx.CheckBoxInternalCollection(this.icbImageProperties, false, false, null, true, this.accessibilityCompliant);
  this.itemsManager.InitializeInternalCheckBoxCollection();
 },
 AddInternalCheckBoxToCollection: function(index) {
  if(!this.internalCheckBoxCollection)
   return;
  var enabled = this.GetEnabled();
  var changeEventMethod = ASPx.Attr.ChangeEventsMethod(enabled);
  this.AddInternalCheckBoxToCollectionCore(index, enabled, changeEventMethod);
 },
 AddInternalCheckBoxToCollectionCore: function(index, enabled, changeEventMethod) {
  var inputElement = this.GetItemCheckBoxInput(index);
  if(inputElement) {
   var internalCheckBox = this.internalCheckBoxCollection.Add(this.GetInternalCheckBoxKey(index), inputElement);
   internalCheckBox.CreateFocusDecoration(this.icbFocusedStyle);
   internalCheckBox.SetEnabled(enabled);
   internalCheckBox.autoSwitchEnabled = false;
   var checkBoxFocusableElement = this.GetCheckBoxFocusableElement(index);
   this.ChangeSpecialInputEnabledAttributes(checkBoxFocusableElement, changeEventMethod, true);
   internalCheckBox.CheckedChanged.AddHandler(
    function(s, e) {
     if(ASPx.Evt.GetKeyCode(e) == ASPx.Key.Space) {
      var element = ASPx.Evt.GetEventSource(e);
      this.GetItemSelectionHelper().OnItemCheckBoxClick(this.FindInternalCheckBoxIndex(element), e);
     }
    }.aspxBind(this)
   );
   internalCheckBox.Focus.AddHandler(
    function(s, e) {
     var index = this.FindInternalCheckBoxIndex(s.mainElement);
     window.setTimeout(function() { this.ScrollToItemVisible(index); }.aspxBind(this), 50);
    }.aspxBind(this)
   );
  }
 },
 ClearInternalCheckBoxCollection: function() {
  if(this.internalCheckBoxCollection)
   this.internalCheckBoxCollection.Clear();
 },
 RemoveInternalCheckBoxFromCollecntion: function(index) {
  if(this.internalCheckBoxCollection)
   this.internalCheckBoxCollection.Remove(this.GetItemValue(index));
 },
 GetInternalCheckBoxKey: function(index) {
  return this.name + nameSeparator + this.GetItemValue(index);
 },
 GetInternalCheckBox: function (index) {
  if(this.internalCheckBoxCollection == null)
   this.CreateInternalCheckBoxCollection();
  if(this.internalCheckBoxCollection)
   return this.internalCheckBoxCollection.Get(this.GetInternalCheckBoxKey(index));
  return null;
 },
 IsNativeCheckBoxes: function() {
  return !this.icbImageProperties;
 },
 SetCheckBoxChecked: function(index, checked) {
  var checkBox = this.IsNativeCheckBoxes() ? this.GetItemCheckBoxInput(index) : this.GetInternalCheckBox(index);
  if(checkBox)
   this.SetCheckBoxCheckedCore(checkBox, checked);
  if(this.accessibilityCompliant) {
   if(!this.accessibilityHelper)
    this.accessibilityHelper = new AccessibilityHelperListBox(this);
   setTimeout(function () { this.accessibilityHelper.SetCheckBoxesValidationAttributes(); }.aspxBind(this), 0);
  }
 },
 SetCheckBoxCheckedCore: function (checkBox, checked) {
  if(this.IsNativeCheckBoxes())
   checkBox.checked = checked;
  else
   checkBox.SetValue(checked ? ASPx.CheckBoxInputKey.Checked : ASPx.CheckBoxInputKey.Unchecked);
 },
 SetCheckBoxEnabled: function (index, enabled) {
  var checkBox = this.IsNativeCheckBoxes() ? this.GetItemCheckBoxInput(index) : this.GetInternalCheckBox(index);
  if (checkBox)
   this.SetCheckBoxEnabledCore(checkBox, enabled);
 },
 SetCheckBoxEnabledCore: function (checkbox, enabled) {
  if (this.IsNativeCheckBoxes()) {
   checkbox.disabled = !enabled;
   this.ChangeNativeCheckEnabledAttributes(checkbox, ASPx.Attr.ChangeEventsMethod(this.GetEnabled()));
  }
  else
   checkbox.SetEnabled(enabled);
  this.ChangeSpecialInputEnabledAttributes(this.IsNativeCheckBoxes() ?
   checkbox : checkbox.inputElement, ASPx.Attr.ChangeEventsMethod(enabled));
 },
 ClearItems: function() {
  ASPxClientListBoxBase.prototype.ClearItems.call(this);
  this.ClearInternalCheckBoxCollection();
  this.freeUniqIndex = this.GetItemCount();
 },
 OnDelayedSpecialFocusMouseDown: function (evt) {
  if(this.filteringTextBox) {
   var isEventFromFilteringTextBox = ASPx.Evt.GetEventSource(evt) == this.filteringTextBox.GetInputElement();
   this.filteringTextBoxInput = isEventFromFilteringTextBox ? this.filteringTextBox.GetInputElement() : null;
  }
  if(this.showFilterButton) {
   var isEventFromShowFilterButton = ASPx.GetIsParent(this.showFilterButton.GetMainElement(), ASPx.Evt.GetEventSource(evt));
   this.showFilterButtonInput = isEventFromShowFilterButton ? this.showFilterButton.GetInternalButton() : null;
   this.isFilterEditorShowing = isEventFromShowFilterButton;
  }
  if(this.GetIsCheckColumnExists())
   this.SetFocusableCheckInput(this.GetCheckBoxInputFromEvent(evt));
  ASPxClientListBoxBase.prototype.OnDelayedSpecialFocusMouseDown.call(this, evt);
  var shiftPressed = evt.shiftKey;
  var ctrlKey = evt.ctrlKey || evt.metaKey;
  if(shiftPressed || ctrlKey){
   ASPx.Selection.Clear();
   if(ASPx.Browser.IE)
    ASPx.Evt.PreventEventAndBubble(evt);
  }
 },
 GetCheckBoxInputFromEvent: function(evt) {
  var element = ASPx.Evt.GetEventSource(evt);
  if(this.IsNativeCheckBoxes())
   return element.type == "checkbox" ? element : null;
  var index = this.FindInternalCheckBoxIndex(element);
  if(index > -1)
   return this.GetCheckBoxFocusableElement(index);
  else if(this.IsSelectAllCheckBoxClicked(element))
   return this.GetSelectAllCheckBoxFocusableElement();
  return null;
 },
 IsSelectAllCheckBoxClicked: function(eventSource) {
  return this.selectAllCheckBox && ASPx.GetIsParent(this.selectAllCheckBox.container, eventSource)
   && (eventSource == this.selectAllCheckBox.mainElement || eventSource.tagName == "LABEL");
 },
 IsNativeSelectAllCheckBoxClicked: function (eventSource) {
  return this.nativeSelectAllCheckBox && ASPx.GetIsParent(this.nativeSelectAllCheckBox, eventSource);
 },
 GetSelectAllClickableElement: function() {
  return this.IsMultiColumn() ? this.selectAllMainElement.parentNode : this.selectAllMainElement;
 },
 GetSelectAllCheckBoxFocusableElement: function() {
  return this.accessibilityCompliant ? this.selectAllCheckBox.mainElement : this.selectAllCheckBox.inputElement;
 },
 GetCheckBoxFocusableElement: function(index) {
  var internalCheckBox = this.GetInternalCheckBox(index);
  if(!internalCheckBox)
   return null;
  return this.accessibilityCompliant ? internalCheckBox.mainElement : internalCheckBox.inputElement;
 },
 FindInternalCheckBoxIndex: function(element) {
  var level = 5;
  while(level > 0) {
   var id = element.id;
   if(id && element.tagName == "TD" && id.slice(-1) == lbIPostfixes[0])
    return this.GetItemIndexByRow(element.parentNode);
   element = element.parentNode;
   level--;
  }
  return -1;
 },
 IsCheckBoxClicked: function(evt) {
  return !!this.GetCheckBoxInputFromEvent(evt);
 },
 GetFocusableInputElement: function() {
  return this.showFilterButtonInput || this.filteringTextBoxInput || this.focusableCheckInput || this.GetInputElement();
 },
 IsElementBelongToInputElement: function (element) {
  return ASPxClientEdit.prototype.IsElementBelongToInputElement.call(this, element)
  || this.filteringTextBox && this.filteringTextBox.ownerListBox == this && this.filteringTextBox.IsElementBelongToInputElement(element);
 },
 SetFocusableCheckInput: function(element) {
  this.focusableCheckInput = element;
 },
 OnFocusCore: function() {
  if(this.UseDelayedSpecialFocus())
   window.clearTimeout(this.specialFocusTimer);
  if(this.focused)
   this.UnlockFocusEvents();
  else
   ASPxClientListBoxBase.prototype.OnFocusCore.call(this);
 },
 OnLostFocusCore: function() {
  if(!this.IsFocusEventsLocked()) { 
   this.SetFocusableCheckInput(null);
   this.filteringTextBoxInput = null;
   this.showFilterButtonInput = null;
  }
  ASPxClientListBoxBase.prototype.OnLostFocusCore.call(this);
 },
 IsFocusEventsLocked: function() {
  var result = ASPxClientEdit.prototype.IsFocusEventsLocked.call(this) ||
      this.IsInternalFilteringTextBoxFocusEventsLocked() ||
      this.isFilterEditorShowing;
  if(this.accessibilityCompliant)
   result = this.focused && (result || this.HasInternalFilteringTextBoxFocus());
  return result;
 },
 HasInternalFilteringTextBoxFocus: function() {
  return !this.customFilteringEditorID && this.filteringTextBox && ASPx.GetIsParent(this.filteringTextBox.GetMainElement(), ASPx.GetActiveElement());
 },
 IsInternalFilteringTextBoxFocusEventsLocked: function() {
  return !this.customFilteringEditorID && this.filteringTextBox && this.filteringTextBox.IsFocusEventsLocked();
 },
 ForceLockFocusEvents: function() {
  this.focusEventsLocked = true;
 },
 GetValueFromValueInput: function(){
  var valueInput = this.FindStateInputElement();
  if(ASPx.IsExistsElement(valueInput))
   return valueInput.value;
  return "";
 },
 NeedUnfocusableScrollDivElement: function() {
  return ASPx.Browser.Firefox;
 },
 GetInitSelectedIndex: function(){
  return this.savedSelectedIndex;
 },
 CacheValue: function(){
  this.cachedValue = this.GetValue();
 },
 InitScrollPos: function(){ 
  if(!this.isComboBoxList && this.isCallbackMode && this.GetInitSelectedIndex() == -1)
   this.GetScrollDivElement().scrollTop = 0;
 },
 InitializeLoadOnDemand: function(){
  var loadOnDemandRequired = this.isCallbackMode && this.GetEnabledByServer();
  this.scrollHelper = loadOnDemandRequired ? new ListBoxScrollCallbackHelper(this) : new ListBoxScrollCallbackHelperBase(this);
 },
 HasVirtualScrolling: function() { return !!this.itemsInfo || this.itemsManager instanceof ListBoxItemsVirtualManager; },
 CreateItemsManager: function() {
  if (this.HasVirtualScrolling()) {
   var manager = new ListBoxItemsVirtualManager(this);
   manager.InitializeItems(this.itemsInfo, this.itemsValue);
   delete this.itemsInfo;
   return manager;
  }
  return new ListBoxItemsDefaultManager(this);
 },
 InlineInitialize: function(){
  if(this.HasVirtualScrolling())
   this.freeUniqIndex = 0;
  this.itemsManager = this.CreateItemsManager();
  this.filterStrategy = this.isComboBoxList ? null : this.CreateFilterStrategy();
  this.EnsureFixWidthRow();
  this.InitializeNativeCheckHandlers();
  this.LockScrollHandler();
  this.InitSpecialKeyboardHandling();
  this.InitializeItemsAttributes();
  this.InitDXTextAttributes();
  this.itemsManager.Initialize();
  this.AddSelectAllStateItems(true);
  this.UnlockScrollHandler();
  if(this.NeedToHandleCellWidth()) {
   var headerTable = this.GetHeaderTableElement();
   var firstHeaderRow = !!headerTable && headerTable.rows[0];
   this.CorrectCellNullWidthStyle(firstHeaderRow);
   this.CorrectCellNullWidthStyle(this.itemsManager.GetFirstVisibleItemRow());
  }
  this.EnsureSelectAllElements();
  ASPxClientListBoxBase.prototype.InlineInitialize.call(this);
 },
 GetItemIndexByInsertionOrder: function (itemIndex) { 
  return this.HasVirtualScrolling() ? this.GetItem(itemIndex).insertOrderIndex : this.FindFreeIndex();
 },
 InsertItemRow: function (index, itemProperties) {
  var newItemRow = this.itemsManager.CreateNewItemRow(index);
  ASPx.Attr.RemoveAttribute(newItemRow, "id");
  var listTable = this.GetListTable();
  var tbody = this.GetTableRowParent(listTable);
  var rowBeforeNewItemRow = this.GetListTableRowBeforeNewItemRow(index, listTable);
  if(rowBeforeNewItemRow)
   tbody.insertBefore(newItemRow, rowBeforeNewItemRow);
  else
   tbody.appendChild(newItemRow);  
  var newIndex = this.GetItemIndexByInsertionOrder(index);
  var newId = this.CreateItemId(newIndex);
  var newClientId = this.CreateItemClientId(newIndex);
  this.InitializeItemAttributes(newItemRow, newClientId, true);
  this.AddStateControllerClasses(newId);
  this.PrepareItem(newItemRow, itemProperties);
  if (this.needUnselectableItemRows)
   this.SetItemRowUnselectable(newItemRow);
  if (this.GetIsCheckColumnExists() && !this.IsNativeCheckBoxes()) {
   if (!this.internalCheckBoxCollection)
    this.CreateInternalCheckBoxCollection();
   this.AddInternalCheckBoxToCollection(index);
  }
 },
 RemoveItemRow: function (index) {
  if (this.GetIsCheckColumnExists() && !this.IsNativeCheckBoxes())
   this.RemoveInternalCheckBoxFromCollecntion(index);
  var row = this.GetItemRow(index);
  if (ASPx.IsExistsElement(row)) {
   var firstCellId = this.GetItemElement(index).id;
   var itemId = firstCellId.match(/LBI\d+/)[0];
   this.RemoveStateControllerClasses(itemId);
   row.parentNode.removeChild(row);
  }
 },
 SetItemRowsUnselectable: function() {
  var count = this.GetItemCount();
  for (var i = 0; i < count; i++) {
   var itemRow = this.GetItemRow(i);
   if (itemRow)
    this.SetItemRowUnselectable(itemRow);
  }
  this.needUnselectableItemRows = true;
 },
 SetItemRowUnselectable: function (itemRow) {
  for (var j = 0; j < itemRow.cells.length; j++)
   ASPx.Selection.SetElementAsUnselectable(itemRow.cells[j], true);
 },
 GetInactiveFilterElementClassName: function() {
  return inactiveFilterElementClassName;
 },
 GetAnimatedFilterElementClassName: function() {
  return "dxeLBAnimatedFilterPanelSys";
 },
 GetCompactViewFilterAdjacentScrollDivSelector: function() {
  return "*[class*=\"dxeListBoxFilter\"]:not(.dxeLBInactiveFilterPanelSys) + *[class*=\"dxeListBoxSelectAll\"] + .dxlbd";
 },
 GetCompactViewInactiveFilterAdjacentScrollDivSelector: function() {
  return ".dxeLBInactiveFilterPanelSys + *[class*=\"dxeListBoxSelectAll\"] + .dxlbd";
 },
 EnsureFilteringElements: function () {
  if(this.enableFiltering) {
   this.EnsureFilteringTextBox();
   if(!this.customFilteringEditorID) {
    this.filterMainElement = this.GetChildElement(filterMainElementID);
    this.showFilterButton = this.GetShowFilterButton();
    if(this.showFilterButton) {
     this.showFilterButton.ownerListBox = this;
     var changeEventMethod = ASPx.Attr.ChangeEventsMethod(this.GetEnabled());
     this.ChangeSpecialInputEnabledAttributes(this.showFilterButton.GetInternalButton(), changeEventMethod, true);
     this.showFilterButton.SetEnabled(this.GetEnabled());
     this.UpdateFilterButtonHeight();
     this.UpdateShowHideFilterElementCssRules();
    }
   }
  }
 },
 CreateFilterStrategy: function() {
  if(this.enableFiltering)
   return new ListBoxFilterStrategy(this);
  return new ListEditFilterStrategyBase();
 },
 UpdateShowHideFilterElementCssRules: function() {
  var scrollDiv = this.GetScrollDivElement();
  var scrollDivClientHeight = scrollDiv.offsetHeight - ASPx.GetTopBottomBordersAndPaddingsSummaryValue(scrollDiv);
  var filterMainElementOffsetHeight = this.GetFilterMainElementHeight();
  if (ASPx.GetElementVisibility(this.filteringTextBox.GetMainElement(), true))
   scrollDivClientHeight += filterMainElementOffsetHeight;
  var showHideFilterStyle = this.EnsureShowHideFilterStyle();
  var mainElementSelector = "#" + this.name;
  var styleContent = [
   mainElementSelector + " " + this.GetCompactViewFilterAdjacentScrollDivSelector()
    + " { max-height: " + (scrollDivClientHeight - filterMainElementOffsetHeight) + "px; }",
   mainElementSelector + " " + this.GetCompactViewInactiveFilterAdjacentScrollDivSelector()
    + " { max-height: " + scrollDivClientHeight + "px; }"
  ];
  showHideFilterStyle.innerHTML = styleContent.join('\n');
 },
 EnsureShowHideFilterStyle: function() {
  if(!this.showHideFilterStyle) {
   this.showHideFilterStyle = this.FindShowHideFilterStyle();
   if(!this.showHideFilterStyle) {
    this.showHideFilterStyle = document.createElement('style');
    this.showHideFilterStyle.id = this.GetShowHideFilterStyleID();
    ASPx.Attr.AppendStyleType(this.showHideFilterStyle);
    document.getElementsByTagName('head')[0].appendChild(this.showHideFilterStyle);
   }
  }
  return this.showHideFilterStyle;
 },
 FindShowHideFilterStyle: function() {
  return ASPx.GetChildById(document.getElementsByTagName('head')[0], this.GetShowHideFilterStyleID());
 },
 GetShowHideFilterStyleID: function() {
  return this.name + "ShowHideFilterStyle";
 },
 GetFilterMainElementHeight: function() {
  if(!this.filterMainElementHeight) {
   var filteringTextBoxClone = this.filteringTextBox.GetMainElement().cloneNode(true);
   filteringTextBoxClone.style.position = "absolute";
   filteringTextBoxClone.style.visibility = "hidden";
   document.body.appendChild(filteringTextBoxClone);
   this.filterMainElementHeight = filteringTextBoxClone.offsetHeight;
   document.body.removeChild(filteringTextBoxClone);
   var filterMainElementClone = this.filterMainElement.cloneNode(false);
   filterMainElementClone.style.position = "absolute";
   filterMainElementClone.style.visibility = "hidden";
   ASPx.RemoveClassNameFromElement(filterMainElementClone, this.GetInactiveFilterElementClassName());
   ASPx.RemoveClassNameFromElement(filterMainElementClone, this.GetAnimatedFilterElementClassName());
   document.body.appendChild(filterMainElementClone);
   this.filterMainElementHeight += ASPx.GetTopBottomBordersAndPaddingsSummaryValue(filterMainElementClone);
   document.body.removeChild(filterMainElementClone);
  }
  return this.filterMainElementHeight;
 },
 RemoveShowHideFilterCssRules: function () {
  var showHideFilterStyle = this.FindShowHideFilterStyle();
  if(showHideFilterStyle)
   showHideFilterStyle.innerHTML = "";
 },
 UpdateFilterButtonHeight: function() {
  setTimeout(function () {
   this.showFilterButton.SetHeight(this.selectAllMainElement.offsetHeight - ASPx.GetVerticalBordersWidth(this.selectAllMainElement));
  }.aspxBind(this), 0);
 },
 EnsureFilteringTextBox: function() {
  this.filteringTextBox = this.FindFilteringTextBox();
  if(this.filteringTextBox) {
   this.filteringTextBox.UserInput.AddHandler(this.filterStrategy.OnInput.bind(this.filterStrategy));
   if(!this.customFilteringEditorID) {
    this.filteringTextBox.ownerListBox = this;
    var changeEventMethod = ASPx.Attr.ChangeEventsMethod(this.GetEnabled());
    this.ChangeSpecialInputEnabledAttributes(this.filteringTextBox.GetInputElement(), changeEventMethod, true);
    this.filteringTextBox.SetEnabled(this.GetEnabled());
    this.filteringTextBox.KeyDown.AddHandler(function(sender, args) {
     if(ASPx.Evt.GetKeyCode(args.htmlEvent) === ASPx.Key.Esc)
      sender.GetInputElement().value = "";
    });
   }
  }
 },
 FindFilteringTextBox: function() {
  var actualFilteringTextBoxID = this.customFilteringEditorID ? this.customFilteringEditorID : this.name + "_" + filteringTextBoxID;
  return ASPx.GetControlCollection().Get(actualFilteringTextBoxID);
 },
 CollectionChanged: function(isFiltering) {
  if(this.APILockCount == 0) {
   if(ASPx.Browser.IE) { 
    var selectedIndex = this.GetSelectedIndex();
    if (selectedIndex > -1) {
     var selectedItemTextCell = this.GetItemFirstTextCell(selectedIndex);
     var controller = ASPx.GetStateController();
     controller.DeselectElementBySrcElement(selectedItemTextCell);
     controller.SelectElementBySrcElement(selectedItemTextCell);
    }
   }
  }
  if(isFiltering)
   this.itemsManager.OnEndItemsFiltering();
 },
 ChangeItemsFilteredState: function(action) {
  this.itemsManager.ChangeItemsFilteredState(action);
 },
 RewriteFilteredItemIndices: function (newFilteredItemIndices) {
  this.itemsManager.RewriteFilteredItemIndices(newFilteredItemIndices);
 },
 BeforeClientFiltering: function () {
  this.itemsManager.BeforeClientFiltering();
 },
 ApplyFilterToItem: function (index, isSatisfy, savePrevState, isFilterReset) {
  this.itemsManager.ApplyFilterToItem(index, isSatisfy, savePrevState, isFilterReset);
 },
 RestorePrevFilteredState: function (index) {
  this.itemsManager.RestorePrevFilteredState(index);
 },
 IsItemFiltered: function (index) {
  return this.itemsManager.IsItemFiltered(index);
 },
 IsClientFilterApplied: function() {
  return !this.isComboBoxList && this.filterStrategy.filter != "" && !this.isCallbackMode;
 },
 MakeAllItemsVisible: function () {
  this.itemsManager.MakeAllItemsVisible();
 },
 ShowFilterElement: function() {
  ASPx.RemoveClassNameFromElement(this.filterMainElement, this.GetInactiveFilterElementClassName());
  this.showFilterButton.SetVisible(false);
  if(ASPx.Browser.VirtualKeyboardSupported) {
   this.ReplaceFilteringTextBoxShowNullTextOnFocusFunction();
   this.isFilterEditorShowing = false;
   this.filteringTextBox.GetInputElement().focus();
  }
  else
   setTimeout(function () {
    this.isFilterEditorShowing = false;
    this.filteringTextBox.GetInputElement().focus();
   }.aspxBind(this), 200);
 },
 HideFilterElement: function () {
  ASPx.AddClassNameToElement(this.filterMainElement, this.GetInactiveFilterElementClassName());
  this.showFilterButton.SetVisible(true);
  this.UpdateFilterButtonHeight();
  this.CorrectHeight(true);
  setTimeout(function () {
   this.filteringTextBox.UnlockFocusEvents();
   this.showFilterButton.GetInternalButton().focus();
  }.aspxBind(this), 0);
 },
 ReplaceFilteringTextBoxShowNullTextOnFocusFunction: function () {
  if(this.filteringTextBox.nullTextDisplayMode === ASPx.NullTextDisplayMode.UnfocusedAndFocused) {
   var origin = this.filteringTextBox.ensureActivateFocusedNullTextMechanism;
   var filteringTextBox = this.filteringTextBox;
   this.filteringTextBox.ensureActivateFocusedNullTextMechanism = function() {
    setTimeout(function() {
     origin.call(filteringTextBox);
     filteringTextBox.ensureActivateFocusedNullTextMechanism = origin;
     setTimeout(function () {
      if(filteringTextBox.isFocusedNullTextElementDisplayed())
       filteringTextBox.adjustFocusedNullTextElement();
     }, 300);
    }, 400);
   };
  }
 },
 EnsureSelectAllElements: function () {
  if(this.enableSelectAll && !this.selectAllMainElement) {
   this.EnsureSelectAllCheckElement();
   this.selectAllMainElement = this.GetChildElement(selectAllMainElementID);
   var selectAllClickableElement = this.GetSelectAllClickableElement();
   ASPx.Evt.AttachEventToElement(selectAllClickableElement, "click", this.onSelectAllClickableElementClick.bind(this));
  }
 },
 EnsureSelectAllCheckElement: function () {
  var selectAllCheckBoxInput = null;
  if(!this.IsNativeCheckBoxes()) {
   this.CreateSelectAllCheckBox();
   selectAllCheckBoxInput = this.GetSelectAllCheckBoxFocusableElement();
  }
  else {
   this.nativeSelectAllCheckBox = this.GetChildElement(selectAllCheckBoxID + "_I");
   this.nativeSelectAllCheckBox.disabled = !this.GetEnabled();
   selectAllCheckBoxInput = this.nativeSelectAllCheckBox;
  }
  var changeEventMethod = ASPx.Attr.ChangeEventsMethod(this.GetEnabled());
  this.ChangeSpecialInputEnabledAttributes(selectAllCheckBoxInput, changeEventMethod, true);
 },
 CreateSelectAllCheckBox: function () {
  var selectAllCheckBoxElement = this.GetChildElement(selectAllCheckBoxID);
  var selectAllCheckBoxInputElement = this.GetChildElement(selectAllCheckBoxID + "_S");
  var selectAllStateController = ASPx.CheckableElementStateController.Create(this.icbImageProperties, CheckBoxInputKey.Checked, CheckBoxInputKey.Unchecked, CheckBoxInputKey.Indeterminate, true);  
  this.selectAllCheckBox = new ASPx.CheckBoxInternal(selectAllCheckBoxInputElement, selectAllStateController, true, false,
   ASPx.CheckEditElementHelper.Instance, selectAllCheckBoxElement, true, undefined, undefined, this.accessibilityCompliant);
  this.selectAllCheckBox.CreateFocusDecoration(this.icbFocusedStyle);
  this.selectAllCheckBox.SetEnabled(this.GetEnabled());
  this.selectAllCheckBox.GetReadOnly = this.GetReadOnly.bind(this);
  this.selectAllCheckBox.CheckedChanged.AddHandler(this.onSelectAll.aspxBind(this));
  if(ASPx.Browser.WebKitFamily)
   ASPx.Evt.AttachEventToElement(this.selectAllCheckBox.mainElement.parentNode, "selectstart", ASPx.Evt.PreventEventAndBubble);
 },
 onSelectAllClickableElementClick: function (evt) {
  if (!this.GetEnabled() || this.GetReadOnly()) {
   if (this.IsNativeCheckBoxes() || this.isNative)
    ASPx.Evt.PreventEvent(evt);
   return false;
  }
  if(this.IsSelectAllCheckBoxClicked(ASPx.Evt.GetEventSource(evt)))
   return;
  if(!this.IsNativeSelectAllCheckBoxClicked(ASPx.Evt.GetEventSource(evt))) {
   var currentCheckState = this.getSelectAllCheckElementState();
   var newCheckState = currentCheckState != ASPx.CheckBoxCheckState.Checked ?
    ASPx.CheckBoxCheckState.Checked : ASPx.CheckBoxCheckState.Unchecked;
   this.updateSelectAllCheckElementState(newCheckState);
  }
  this.onSelectAll();
 },
 onSelectAll: function () {
  this.LockUpdateSelectAllElements();
  var selectAllCheckState = this.getSelectAllCheckElementState();
  this.onSelectAllCore(selectAllCheckState);
  this.UnlockUpdateSelectAllElements();
 },
 onSelectAllCore: function (currentCheckState) {
  var toSelect = currentCheckState == ASPx.CheckBoxCheckState.Checked;
  var valueBeforeSelectAll = this.GetValue();
  var selectionBeforeSelectAll = this.GetValueFromValueInput();
  if (toSelect)
   this.SelectAll();
  else
   this.UnselectAll();
  if(selectionBeforeSelectAll !== this.GetValueFromValueInput())
   this.OnItemSelectionChanged(-1, toSelect, true, valueBeforeSelectAll !== this.GetValue());
 },
 getSelectAllCheckElementState: function () {
  if(this.selectAllCheckBox)
   return this.selectAllCheckBox.GetCurrentCheckState();
  if(this.nativeSelectAllCheckBox)
   return this.nativeSelectAllCheckBox.checked ? ASPx.CheckBoxCheckState.Checked : ASPx.CheckBoxCheckState.Unchecked;
  return null;
 },
 updateSelectAllCheckElementState: function (checkState) {
  if(this.selectAllCheckBox) {
   var checkValue = this.selectAllCheckBox.stateController.GetValueByCheckState(checkState);
   this.selectAllCheckBox.SetValue(checkValue, !this.isInitialized);
  } else if(this.nativeSelectAllCheckBox)
   this.nativeSelectAllCheckBox.checked = checkState === ASPx.CheckBoxCheckState.Checked;
 },
 updateSelectAllElementsState: function() {
  if(!this.IsUpdateSelectAllElementsLocked() && this.enableSelectAll) {
   this.EnsureSelectAllElements();
   this.updateSelectAllElementsStateCore();
  }
 },
 updateSelectAllElementsStateCore: function() {
  var selectAllCheckState = ASPx.CheckBoxCheckState.Unchecked;
  var isFilteredSelectedItemFound = false;
  var isFilteredUnselectedItemFound = false;
  var itemCount = this.GetItemCount();
  for(var i = 0; i < itemCount; i++) {
   if(this.IsItemFiltered(i)) {
    if(this.GetIsItemSelected(i))
     isFilteredSelectedItemFound = true;
    else
     isFilteredUnselectedItemFound = true;
   }
   if (isFilteredSelectedItemFound && isFilteredUnselectedItemFound) {
    selectAllCheckState = ASPx.CheckBoxCheckState.Indeterminate;
    break;
   }
   if(i == itemCount - 1 && isFilteredSelectedItemFound && !isFilteredUnselectedItemFound)
    selectAllCheckState = ASPx.CheckBoxCheckState.Checked;
  }
  this.updateSelectAllCheckElementState(selectAllCheckState);
 },
 changeSelectAllElementsEnabledState: function(enabled) {
  var selectAllCheckBoxInput = null;
  if(this.selectAllCheckBox) {
   this.selectAllCheckBox.SetEnabled(enabled);
   selectAllCheckBoxInput = this.GetSelectAllCheckBoxFocusableElement();
  }
  else if(this.nativeSelectAllCheckBox) {
   this.nativeSelectAllCheckBox.disabled = !enabled;
   selectAllCheckBoxInput = this.nativeSelectAllCheckBox;
  }
  if(selectAllCheckBoxInput) {
   var changeEventMethod = ASPx.Attr.ChangeEventsMethod(enabled);
   this.ChangeSpecialInputEnabledAttributes(selectAllCheckBoxInput, changeEventMethod, true);
  }
  ASPx.GetStateController().SetElementEnabled(this.selectAllMainElement, enabled);
 },
 NeedToHandleCellWidth: function() {
  return this.IsMultiColumn() && (ASPx.Browser.Firefox || ASPx.Browser.IE || ASPx.Browser.Edge);
 },
 CorrectCellNullWidthStyle: function(row) {
  if(!row) return;
  var cellCount = row.cells.length;
  for(var i = 0; i < cellCount; i++) {
   var cellStyle = !!window.getComputedStyle ? window.getComputedStyle(row.cells[i]) : ASPx.GetCurrentStyle(row.cells[i]);
   var originalWidth = parseInt(cellStyle.width);
   var needToApply = originalWidth === 0 || originalWidth <= ASPx.PxToInt(cellStyle.paddingLeft) || originalWidth <= ASPx.PxToInt(cellStyle.paddingRight);
   var action = needToApply ? ASPx.AddClassNameToElement : ASPx.RemoveClassNameFromElement;
   action(row.cells[i], NullSizeCellClassName);
  }
 },
 InitializeNativeCheckHandlers: function() {
  this.nativeCheckOnFocusHandler = function(evt) {
   this.SetFocusableCheckInput(ASPx.Evt.GetEventSource(evt));
  }.aspxBind(this);
 },
 ChangeNativeCheckEnabledAttributes: function(element, method) {
  if(this.nativeCheckOnFocusHandler)
   method(element, "focus", this.nativeCheckOnFocusHandler);
 },
 InitializeItemsAttributes: function() { 
  var listTable = this.GetListTable();
  if(this.isHasFakeRow){
   this.LockSynchronization();
   this.ClearItems();
   this.UnlockSynchronization();
  }
  listTable.ListBoxId = this.name;
  var rowIdConst = this.name + "_";
  if(this.hasSampleItem)
   this.InitializeItemAttributes(this.GetSampleItemRow(), rowIdConst + lbSIIdSuffix);
  if(!this.HasVirtualScrolling()) {
   rowIdConst += lbIIdSuffix;
   var count = this.GetItemCount();
   if (this.accessibilityCompliant && this.IsMultiColumn())
    count--;
   for (var i = 0; i < count; i++)
    this.InitializeItemAttributes(this.GetItemRow(i), rowIdConst + i);
  }
  var rows = listTable.rows;
  if(this.accessibilityCompliant && rows[rows.length - 1])
   rows[rows.length - 1].id = this.GetAccessibilityHeaderRowID();
 },
 InitializeItemAttributes: function(row, rowId) {
  var cells = row.cells;
  var itemCellsIdSuffixes = this.GetItemCellsIdPostfixes();
  for(var i = 0; i < row.cells.length; i++) {
   cells[i].style.textAlign = this.itemHorizontalAlign;
   cells[i].id = rowId + itemCellsIdSuffixes[i];
  }
  if(this.GetIsCheckColumnExists() && this.IsNativeCheckBoxes() && rowId != this.GetSampleItemRowID()) {
   var input = this.GetItemCheckBoxInput(this.GetItemIndexByRow(row));
   this.ChangeNativeCheckEnabledAttributes(input, ASPx.Attr.ChangeEventsMethod(this.GetEnabled()));
   this.ChangeSpecialInputEnabledAttributes(input, ASPx.Attr.ChangeEventsMethod(this.GetEnabled()));
  }
 },
 InitializePageSize: function(){
  var divElement = this.GetScrollDivElement();
  var count = this.GetItemCount();
  if (divElement && count > 0) {
   var firstVisibleRow = this.itemsManager.GetFirstVisibleItemRow();
   if(firstVisibleRow)
    this.scrollPageSize = Math.round(divElement.clientHeight / firstVisibleRow.offsetHeight) - 1;
  }
 },
 AddSelectAllStateItems: function(isInitialization) {
  if (this.enableSelectAll && typeof (ASPx.GetStateController) !== "undefined") {
   var stateController = ASPx.GetStateController();
   var name = this.name + "_" + selectAllMainElementID;
   if (!isInitialization)
    this.ClearStateItemCache(stateController, name, [""]);
   stateController.AddHoverItem(name, this.selectAllHoverClasses, this.selectAllHoverCssArray, "", null, null, true);
   stateController.AddDisabledItem(name, this.selectAllDisabledClasses, this.selectAllDisabledCssArray, "", null, null, true);
  }
 },
 RemoveSelectAllStateItems: function() {
  if (this.enableSelectAll && typeof (ASPx.GetStateController) !== "undefined") {
   var stateController = ASPx.GetStateController();
   var name = this.name + "_" + selectAllMainElementID;
   this.ClearStateItemCache(stateController, name, [""]);
   stateController.RemoveHoverItem(name, "");
   stateController.RemoveDisabledItem(name, "");
  }
 },
 ClearStateItemCache: function(stateController, name, suffixes) {
  for (var i = 0; i < suffixes.length; i++) {
   var element = document.getElementById(name + suffixes[i]);
   var elements = ASPx.GetNodes(element);
   elements.push(element);
   ASPx.Data.ForEach(elements, stateController.ClearElementCache.bind(stateController));
  }
 },
 AfterInitialize: function() {
  if(this.disableScrolling) {
   var scrollDiv = this.GetScrollDivElement();
   var mainElement = this.GetMainElement();
   var listTable = this.GetListTable();
   scrollDiv.style.height = mainElement.style.height = (listTable 
    ? ASPx.GetClearClientHeight(listTable)
    : this.GetListTableHeight() - ASPx.GetTopBottomBordersAndPaddingsSummaryValue(mainElement)) + "px";
  }
  this.CallbackSpaceInit(true);
  if(this.accessibilityCompliant)
   this.accessibilityHelper = new AccessibilityHelperListBox(this);
  ASPxClientListBoxBase.prototype.AfterInitialize.call(this);
 },
 GetEnabledByServer: function(){
  return this.enabled;
 },
 SetEnabled: function(enabled){  
  ASPxClientListBoxBase.prototype.SetEnabled.call(this, enabled);
  this.CallbackSpaceInit(false);
 },
 SetReadOnlyInternal: function(readOnly) {
  ASPxClientListBoxBase.prototype.SetReadOnlyInternal.call(this, readOnly);
  if (readOnly) {
   this.RemoveSelectAllStateItems();
   this.itemsManager.RemoveHoverStateItem();
  }
  else {
   this.AddSelectAllStateItems(false);
   this.itemsManager.AddStateItems(true, true);
  }
 }, 
 CallbackSpaceInit: function(isInitialization){
  if(this.isCallbackMode){
   this.SetBottomScrollSpacerVisibility(this.GetScrollSpacerVisibility(false));
   this.SetTopScrollSpacerVisibility(this.GetScrollSpacerVisibility(true));
   if(isInitialization || this.isComboBoxList){
    this.EnsureSelectedItemVisible();
    ASPx.Evt.AttachEventToElement(this.GetScrollDivElement(), "scroll", aspxLBScroll);
   }
   this.itemsManager.FixItemTruncatingIfRequired();
  }
 },
 GetListTable: function() {
  return this.tempCache.Get("ListTable", this.GetListTableCore, this);
 },
 GetListTableCore: function(){
  if(!ASPx.IsExistsElement(this.listTable))
   this.listTable = ASPx.GetElementById(this.name + lTableIdSuffix);
  return this.listTable;
 },
 GetItemElements: function() {
  return this.GetListTable().rows;
 },
 GetListTableHeight: function(){
  return this.GetListTable().offsetHeight;
 },
 GetHeaderDivElement: function(){
  if(!ASPx.IsExistsElement(this.headerDiv))
   this.headerDiv = ASPx.GetElementById(this.name + lbHeaderDivIdSuffix);
  return this.headerDiv;
 },
 GetHeaderTableElement: function(){
  if(!ASPx.IsExistsElement(this.headerTable)){
   var headerDiv = this.GetHeaderDivElement();
   this.headerTable = ASPx.GetNodeByTagName(headerDiv, "table", 0);
  }
  return this.headerTable;
 },
 GetScrollDivElement: function(){
  if(!ASPx.IsExistsElement(this.scrollDivElement))
   this.scrollDivElement = document.getElementById(this.name + lbDSuffix);
  return this.scrollDivElement;
 },
 GetItemElement: function(index) {
  return this.itemsManager.GetItemElement(index);
 },
 GetItemRow: function(index){
  return this.itemsManager.GetItemRow(index);
 },
 GetItemIndexByRow: function (itemRow) {
  return this.itemsManager.GetItemIndexByRow(itemRow);
 },
 GetItemSelectableElementsByRow: function(row) {
  return row.cells;
 },
 GetItemTexts: function(item) {
  return item.texts ? item.texts : [ item.text ];
 },
 GetItemHtmlContent: function(index) {
  return this.itemsManager.GetItemHtmlContent(index);
 },
 GetItemCount: function(){
  return this.itemsManager.GetItemCount();
 },
 GetListTableRowParent: function() {
  var listTable = this.GetListTable();
  return this.GetTableRowParent(listTable);
 },
 EnsureFixWidthRow: function (isSetItemHtmlProcessing) {
  var needfixWidthRow = !this.ContainsFixWidthRow() && this.IsMultiColumn() && (isSetItemHtmlProcessing || this.hasItemTemplate);
  if (needfixWidthRow)
   this.CreateFixWidthRow();
 },
 CreateFixWidthRow: function() {
  this.fixWidthRow = document.createElement("TR");
  var etalonRow = this.GetSampleItemRow();
  for(var i = 0; i < etalonRow.cells.length; i++) {
   var fixWidthCell = document.createElement("TD");
   var etalonCell = etalonRow.cells[i];
   var etalonCellStyle = ASPx.GetCurrentStyle(etalonCell);
   fixWidthCell.style.width = etalonCell.style.width || etalonCellStyle.width;
   fixWidthCell.style.borderLeftWidth = etalonCellStyle.borderLeftWidth;
   fixWidthCell.style.borderRightWidth = etalonCellStyle.borderRightWidth;
   fixWidthCell.style.borderLeftStyle = etalonCellStyle.borderLeftStyle;
   fixWidthCell.style.borderRightStyle = etalonCellStyle.borderRightStyle;
   fixWidthCell.style.paddingLeft = etalonCellStyle.paddingLeft;
   fixWidthCell.style.paddingRight = etalonCellStyle.paddingRight;
   fixWidthCell.style.boxSizing = etalonCellStyle.boxSizing;
   fixWidthCell.style.display = etalonCellStyle.display;
   this.fixWidthRow.appendChild(fixWidthCell);
  }
  ASPx.SetElementVisibility(this.fixWidthRow, "hidden");
  this.fixWidthRow.style.height = "0px";
  var listTableBody = this.GetListTableRowParent();
  listTableBody.insertBefore(this.fixWidthRow, listTableBody.childNodes[0]);
 },
 ContainsFixWidthRow: function() {
  return this.fixWidthRow && this.fixWidthRow.parentNode === this.GetListTableRowParent();
 },
 GetVisibleItemCount: function () {
  return this.itemsManager.GetVisibleItemCount();
 },
 GetIndexVisibleItem: function(item) {
  var count = this.GetItemCount();
  var visibleItemCount = 0;
  for(var i = 0; i < count; i ++){
   if(this.IsItemFiltered(i))
    visibleItemCount++;
   var curItem = this.GetItem(i);
   if(item.value === curItem.value && item.text === curItem.text)
    break;
  }
  return visibleItemCount;
 },
 GetItemCellCount: function(){
  if(this.hasSampleItem)
   return this.GetSampleItemRow().cells.length;
  if(this.GetItemCount() > 0)
   return this.itemsManager.GetFirstVisibleItemRow().cells.length;
  return 0;
 },
 GetItemTextCellCount: function(){
  return this.GetItemCellCount() - this.GetItemFirstTextCellIndex();
 },
 GetItemFirstTextCellIndex: function(){
  var itemFirstTextCellIndex  = 0;
  if(this.GetIsCheckColumnExists())
   itemFirstTextCellIndex++;
  if(this.imageCellExists)
   itemFirstTextCellIndex++;
  return itemFirstTextCellIndex;
 },
 GetItemFirstTextCell: function(index){
  return this.GetItemTextCell(index, 0);
 },
 GetItemTextCell: function(itemIndex, textCellIndex) {
  var rowElement = this.GetItemRow(itemIndex);
  if(rowElement == null) 
   return null;
  return rowElement.cells[this.GetItemFirstTextCellIndex() + textCellIndex];
 },
 GetItemTopOffset: function(index){
  return this.itemsManager.GetItemTopOffset(index);
 },
 GetItemHeight: function(index){
  return this.itemsManager.GetItemHeight(index);
 },
 ResetItemHeightIfRequired: function (index) {
  return this.itemsManager.ResetItemHeightIfRequired(index);
 },
 GetItemsHeight: function(){
  return this.itemsManager.GetItemsHeight();
 },
 GetItemsWidth: function () {
  return this.itemsManager.GetItemsWidth();
 },
 GetItemCheckBoxInput: function(index){
  var itemRow = this.GetItemRow(index);
  var checkBoxCell = itemRow ? itemRow.cells[this.GetCheckBoxCellIndex()] : null;
  return checkBoxCell ? ASPx.GetNodesByTagName(checkBoxCell, "input")[0] : null;
 },
 GetIsCheckColumnExists: function(){
  if(!this.checkCellExists)
   this.checkCellExists = this.CheckColumnSelectionMode();
  return this.checkCellExists;
 },
 GetCheckBoxCellIndex: function(){
  return 0;
 },
 GetImageCellIndex: function(){
  return this.GetIsCheckColumnExists() ? 1 : 0;
 },
 GetItemCellsIdPostfixes: function(){
  if(this.itemCellsIdPostfixes == null){
   this.itemCellsIdPostfixes = [];
   var i = 0;
   if(this.GetIsCheckColumnExists()) {
    this.itemCellsIdPostfixes.push(lbIPostfixes[0]);
    i++;
   }
   if(this.imageCellExists){
    this.itemCellsIdPostfixes.push(lbIPostfixes[1]);
    i++;
   }
   var cellCount = this.GetItemCellCount();
   for(; i < cellCount; i++) 
    this.itemCellsIdPostfixes.push(lbIPostfixes[2] + i);
  }
  return this.itemCellsIdPostfixes;
 },
 AdjustControl: function (nestedCall) {
  if(this.IsAdjustmentRequired()) 
   this.heightCorrected = false;
  ASPxClientEdit.prototype.AdjustControl.call(this, nestedCall);
 },
 AdjustControlCore: function(){
  this.RemoveShowHideFilterCssRules();
  if(this.disableScrolling)
   return;
  ASPxClientEdit.prototype.AdjustControlCore.call(this);
  this.CorrectSize();
  this.itemsManager.Adjust();
  this.EnsureSelectedItemVisible();
  if(!this.isComboBoxList && ASPx.Browser.IE) 
   this.CorrectWidth();
  if(this.showFilterButton) {
   this.UpdateFilterButtonHeight();
   this.UpdateShowHideFilterElementCssRules();
  }
 },
 CorrectSize: function() {
  if(this.isComboBoxList || this.disableScrolling || this.filterStrategy.currentCallbackIsFiltration)
   return;
  this.LockScrollHandler();
  this.CorrectHeight();
  this.CorrectWidth();
  this.InitializePageSize();
  this.UnlockScrollHandler();
 },
 OnCorrectSizeByTimer: function() {
  if(this.IsVisible())
   this.CorrectSize();
 }, 
 SetProtectionFromFlick_inFF: function(changeVisibility, changeDisplay){
  if(!ASPx.Browser.Firefox) return;
  var listTable = this.GetListTable();
  if(changeVisibility)
   listTable.style.visibility = "hidden";
  if(changeDisplay)
   listTable.style.display = "none";
 },
 ResetProtectionFromFlick_inFF: function(){
  if(!ASPx.Browser.Firefox) return;
  var listTable = this.GetListTable();
  listTable.style.visibility = "";
  listTable.style.display = "";
 },
 CorrectHeight: function(force){
  if(ASPx.Browser.Firefox && this.heightCorrected && !force) return; 
  this.heightCorrected = true;
  var mainElement = this.GetMainElement();
  var divElement = this.GetScrollDivElement();
  divElement.style.height = "0px";
  var height = mainElement.offsetHeight;
  divElement.style.height = height + "px";
  var extrudedHeight = mainElement.offsetHeight;
  var heightCorrection = extrudedHeight - height;
  if(heightCorrection > 0){
   var divHeight = divElement.offsetHeight;
   this.SetProtectionFromFlick_inFF(true, false);
   divElement.style.height = (divHeight - heightCorrection) + "px";
   this.ResetProtectionFromFlick_inFF(); 
   extrudedHeight = mainElement.offsetHeight;
   var paddingsHeightCorrection = extrudedHeight - height;
   if(paddingsHeightCorrection > 0)
    divElement.style.height = (divHeight - heightCorrection - paddingsHeightCorrection) + "px";
  } 
 },
 IsMultiColumn: function(){
  return this.columnFieldNames.length > 0;
 },
 GetVisibleColumnCount: function() {
  if (!this.visibleColumnCount) {
   this.visibleColumnCount = this.IsMultiColumn() ?
    ASPx.Data.CollectionToArray(this.GetSampleItemRow().cells)
     .slice(this.GetItemFirstTextCellIndex())
     .filter(function (cell) { return ASPx.GetElementDisplay(cell); }).length
    : -1;
  }
  return this.visibleColumnCount;
 },
 CorrectWidth: function(){
  if(this.IsMultiColumn())
   this.CorrectMultiColumnWidth();
  else
   this.CorrectNonMultiColumnWidth();
 },
 CorrectMultiColumnWidth: function(){
  var scrollBarWidth = this.GetVerticalScrollBarWidth(); 
  this.CorrectMultiColumnHeaderWidth(scrollBarWidth);
 },
 CollapseMultiColumnHeaderWidth:function(){
  var headerDivElement = this.GetHeaderDivElement();
  headerDivElement.style.width = "0px";
 },
 CorrectMultiColumnHeaderWidth: function(scrollBarWidth){
  var headerDivElement = this.GetHeaderDivElement();
  if(ASPx.IsExistsElement(headerDivElement)){
   var headerTable;
   if(ASPx.Browser.WebKitFamily){
    headerTable = this.GetHeaderTableElement();
    if(!ASPx.IsExistsElement(headerTable))
     headerTable = null;
   }
   if(headerTable)
    headerTable.style.width = "0";
   if(this.rtl)
    headerDivElement.style.paddingLeft = scrollBarWidth + "px";
   else
    headerDivElement.style.paddingRight = scrollBarWidth + "px";
   if(headerTable)
    window.setTimeout(function() { headerTable.style.width = "100%"; }, 0);
  }
 },
 CorrectNonMultiColumnWidth: function(){
  var mainElement = this.GetMainElement(),
   divElement = this.GetScrollDivElement();
  if(this.width == ""){
   var itemsWidth = this.GetItemsWidth();
   if (itemsWidth != 0 || !ASPx.Browser.NetscapeFamily) { 
    divElement.style.width = Math.max((itemsWidth + this.GetVerticalScrollBarWidth()), this.scrollDivMinWidth) + "px";
    if(ASPx.Browser.Firefox) 
     mainElement.style.width = divElement.offsetWidth + "px";
   }
  } else {  
   mainElement.style.width = this.width;
   if(this.width !== "100%") {
    var scrollDivWidth = ASPx.Browser.WebKitFamily ? 1 : 0,
     isMicrosoftBrowser = ASPx.Browser.Edge || ASPx.Browser.IE;
    var oldScrollTop = divElement.scrollTop;
    divElement.style.width = scrollDivWidth + "px";
    scrollDivWidth = isMicrosoftBrowser ? mainElement.clientWidth - ASPx.GetHorizontalBordersWidth(mainElement) : mainElement.clientWidth;
    divElement.style.width = scrollDivWidth + "px";
    var isScrollEventWillRaised = divElement.scrollTop != oldScrollTop;
    if(isScrollEventWillRaised)
     this.itemsManager.DeactivateScrollHandler();
    divElement.scrollTop = oldScrollTop;
   }
  }
 },
 UpdateAdjustmentFlags: function() {
  var mainElement = this.GetMainElement();
  if(mainElement) {
   var mainElementStyle = ASPx.GetCurrentStyle(mainElement);
   this.UpdatePercentSizeConfig([this.width], [mainElementStyle.height, mainElement.style.height]);
  }
 },
 EnsureSelectedItemVisible: function(){
  var index = this.GetSelectedIndex();
  if(index != -1)
   this.MakeItemVisible(index);
 },
 MakeItemVisible: function(index){
  if(!this.IsItemVisible(index))
   this.ScrollItemToTop(index);
 },
 IsItemVisible: function(index){
  return this.itemsManager.IsItemVisible(index);
 },
 ScrollItemToTop: function(index){
  this.LockScrollHandler();
  this.SetScrollTop(this.GetItemTopOffset(index));
  this.UnlockScrollHandler();
 },
 ScrollToItemVisible: function(index){
  if(!this.IsItemVisible(index)){
   var scrollDiv = this.GetScrollDivElement();
   var scrollTop = scrollDiv.scrollTop;
   var scrollDivHeight = scrollDiv.clientHeight;
   var itemOffsetTop = this.GetItemTopOffset(index);
   var itemHeight = this.GetItemHeight(index);
   var itemAbove = scrollTop > itemOffsetTop;
   var itemBelow = scrollTop  + scrollDivHeight < itemOffsetTop + itemHeight;
   if(itemAbove)
    scrollDiv.scrollTop = itemOffsetTop;
   else if(itemBelow){
    var scrollDivChildElementHeight = this.GetScrollDivChildElementHeight();
    var scrollPaddings = scrollDiv.scrollHeight - scrollDivChildElementHeight;
    scrollDiv.scrollTop = itemOffsetTop + itemHeight - scrollDivHeight + scrollPaddings;
   }
  }
 },
 GetScrollDivChildElementHeight: function() {
  return this.itemsManager.GetScrollDivChildElementHeight();
 },
 SetScrollTop: function(scrollTop){
  var scrollDiv = this.GetScrollDivElement();
  if(scrollDiv){ 
   scrollDiv.scrollTop = scrollTop;
   if(ASPx.Browser.Opera) 
    this.CachedScrollTop();
  }   
 },
 CachedScrollTop: function(){
  var scrollDiv = this.GetScrollDivElement();
  scrollDiv.cachedScrollTop = scrollDiv.scrollTop;
 },
 RestoreScrollTopFromCache: function(){
  var scrollDiv = this.GetScrollDivElement();
  if(scrollDiv && ASPx.IsExists(scrollDiv.cachedScrollTop))
   scrollDiv.scrollTop = scrollDiv.cachedScrollTop;
 },
 IsListBoxWidthLessThenList: function(){
  var divElement = this.GetScrollDivElement();
  var listTable = this.GetListTable();
  var listTabelWidth = listTable.style.width;
  var isLess = false;
  listTable.style.width = "";
  isLess = listTable.offsetWidth < divElement.offsetWidth;
  listTable.style.width = listTabelWidth;
  return isLess;
 },
 GetVerticalScrollBarWidth: function(){
  var divElement = this.GetScrollDivElement(); 
  if(!this.verticalScrollBarWidth || this.verticalScrollBarWidth <= 0){
   this.verticalScrollBarWidth = this.GetVerticalScrollBarWidthCore(divElement);
   return this.verticalScrollBarWidth;
  } else
   return this.GetIsVerticalScrollBarVisible(divElement) ? this.verticalScrollBarWidth : 0;
 },
 GetIsVerticalScrollBarVisible: function(divElement){
  var verticalOverflow = this.GetVerticalOverflow(divElement);
  if(verticalOverflow != "auto"){
   return divElement.clientHeight < this.GetListTableHeight();
  } else {
   var borderWidthWithScroll = divElement.offsetWidth - divElement.clientWidth;
   return borderWidthWithScroll == this.scrollDivBordersWidthWithScroll;
  }
 },
 GetVerticalScrollBarWidthCore: function(divElement){
  var overflowYReserv = this.GetVerticalOverflow(divElement);
  this.SetVerticalOverflow(divElement, "auto");
  this.scrollDivBordersWidthWithScroll = divElement.offsetWidth - divElement.clientWidth;
  if(ASPx.Browser.IE)
   return this.scrollDivBordersWidthWithScroll; 
  this.SetProtectionFromFlick_inFF(false, true);
  this.SetVerticalOverflow(divElement, "hidden");
  var bordersWidthWithoutScroll = divElement.offsetWidth - divElement.clientWidth;
  this.SetVerticalOverflow(divElement, overflowYReserv);
  this.ResetProtectionFromFlick_inFF();
  return this.scrollDivBordersWidthWithScroll - bordersWidthWithoutScroll;
 },
 GetVerticalOverflow: function(element){
  if(ASPx.Browser.IE || ASPx.Browser.Safari && ASPx.Browser.Version >= 3 || ASPx.Browser.Chrome || ASPx.Browser.Firefox && ASPx.Browser.Version >= 3)
   return element.style.overflowY;
  return element.style.overflow;
 },
 SetVerticalOverflow: function(element, value) {
  if(ASPx.Browser.IE || ASPx.Browser.Safari && ASPx.Browser.Version >= 3 || ASPx.Browser.Chrome || ASPx.Browser.AndroidDefaultBrowser || ASPx.Browser.Firefox && ASPx.Browser.Version >= 3) {
   element.style.overflowY = value;
  } else {
   element.style.overflow = value;
  }
 },
 MultiSelectionMode: function(){
  return this.selectionMode != ListBoxSelectionMode.Single;
 },
 CheckColumnSelectionMode: function(){
  return this.selectionMode == ListBoxSelectionMode.CheckColumn;
 },
 OnItemClick: function(index, evt){
  if(!this.isInitialized) 
   return;
  if (this.GetReadOnly()) {
   ASPx.Evt.PreventEvent(evt);
   return this.OnItemClickOrDblClickReadOnly();
  }
  if(this.CheckColumnSelectionMode() && this.IsCheckBoxClicked(evt))
   this.GetItemSelectionHelper().OnItemCheckBoxClick(index, evt);
  else
   this.GetItemSelectionHelper().OnItemClick(index, evt);
  this.SetFocus();
  this.RaiseItemClick();
 },
 OnItemClickOrDblClickReadOnly: function(){
  return false;
 },
 OnItemDblClick: function(){
  if (this.GetReadOnly())
   return this.OnItemClickOrDblClickReadOnly();
  return this.RaiseItemDoubleClick();
 },
 CanChangeSelection: function(){
  return !this.GetReadOnly() || !this.isInitialized;
 },
 SelectIndexSilent: function(index){ 
  return this.SetItemSelectionStateSilent(index);
 },
 SetItemSelectionStateSilent: function(index){
  if(!this.CanChangeSelection())
   return;
  var oldSelectionIndex = this.GetSelectedIndex();
  this.LockSelectionEvents();
  this.SetSelectedIndexCore(index);
  this.UnlockSelectionEvents();
  return index != oldSelectionIndex;
 },
 SetItemSelectionAppearance: function (index, selected, controller, checkCanChangeSelection) {
  if (checkCanChangeSelection && !this.CanChangeSelection())
   return;
  if(!controller)
   controller = ASPx.GetStateController();
  var itemFirstTextCell = this.GetItemFirstTextCell(index);
  if(selected)
   controller.SelectElementBySrcElement(itemFirstTextCell);
  else
   controller.DeselectElementBySrcElement(itemFirstTextCell);
 },
 GetItemSelectionHelper: function(){
  if(!this.itemSelectionHelper)
   this.itemSelectionHelper = this.CreateItemSelectionHelper();
  return this.itemSelectionHelper;
 },
 CreateItemSelectionHelper: function(){
  if(this.selectionMode == ListBoxSelectionMode.Single)
   return new ListBoxSingleSelectionHelper(this);
  else if(this.selectionMode == ListBoxSelectionMode.Multiple)
   return new ListBoxMultiSelectionHelper(this);
  else if(this.selectionMode == ListBoxSelectionMode.CheckColumn)
   return new ListBoxCheckSelectionHelper(this);
 },
 GetValue: function(){
  var index = this.GetSelectedIndex();
  if(0 <= index && index < this.itemsValue.length)
   return this.itemsValue[index];
  return null;
 },
 SetValue: function(value){
  var index = this.FindItemIndexByValue(value);
  this.SetSelectedIndex(index);
 },
 GetSelectedItem: function(){
  var index = this.GetSelectedIndex();
  return this.GetItem(index);
 },
 GetSelectedIndex: function(){
  if(!this.itemSelectionHelper)
   return this.GetSelectedIndexInternal();
  return this.GetItemSelectionHelper().GetSelectedIndex();
 },
 SetSelectedIndex: function(index){
  this.LockSelectionEvents();
  this.SetSelectedIndexCore(index);
  this.EnsureSelectedItemVisible(index);
  this.UnlockSelectionEvents();
 },
 SetSelectedIndexCore: function(index){
  this.GetItemSelectionHelper().SetSelectedIndex(index);
 },
 GetSelectedIndices: function(){
  return this.GetItemSelectionHelper().GetSelectedIndices();
 },
 GetSelectedValues: function(){ 
  return this.GetItemSelectionHelper().GetSelectedValues();
 },
 GetSelectedItems: function(){
  return this.GetItemSelectionHelper().GetSelectedItems();
 },
 SelectAll: function(){
  this.SelectIndices();
 },
 UnselectAll: function(){
  this.UnselectIndices();
 },
 SelectIndices: function(indices){
  this.LockSelectionEvents();
  this.GetItemSelectionHelper().SelectIndices(indices);
  this.UnlockSelectionEvents();
 },
 SelectItems: function(items){
  this.LockSelectionEvents();
  this.GetItemSelectionHelper().SelectItems(items);
  this.UnlockSelectionEvents();
 },
 SelectValues: function(values){
  this.LockSelectionEvents();
  this.GetItemSelectionHelper().SelectValues(values);
  this.UnlockSelectionEvents();
 },
 UnselectIndices: function(indices){
  this.LockSelectionEvents();
  this.GetItemSelectionHelper().UnselectIndices(indices);
  this.UnlockSelectionEvents();
 },
 UnselectItems: function(items){
  this.LockSelectionEvents();
  this.GetItemSelectionHelper().UnselectItems(items);
  this.UnlockSelectionEvents();
 },
 UnselectValues: function(values){
  this.LockSelectionEvents();
  this.GetItemSelectionHelper().UnselectValues(values);
  this.UnlockSelectionEvents();
 },
 GetIsItemSelected: function(index){
  return this.GetItemSelectionHelper().GetIsItemSelected(index);
 },
 GetFocusedIndex: function(){
  return this.GetItemSelectionHelper().GetFocusedIndex();
 },
 UpdateInternalState: function(){
  this.UpdateHiddenInputs();
 },
 IsUpdateHiddenInputsLocked: function(){
  return this.GetItemSelectionHelper().IsUpdateInternalSelectionStateLocked();
 },
 UpdateHiddenInputs: function(){
  if(this.IsUpdateHiddenInputsLocked())
   return;
  if(this.MultiSelectionMode()){ 
   var element = this.FindStateInputElement();
   if(ASPx.IsExistsElement(element)) {
    var sb = [ ];
    var serialiser = this.GetSerializingHelper();
    var selectedIndices = this.GetSelectedIndices();
    for(var i = 0; i < selectedIndices.length; i++)
     serialiser.SerializeAtomValue(sb, this.GetItemValue(selectedIndices[i]));
    element.value = sb.join("");
   }
  } else 
   ASPxClientListBoxBase.prototype.UpdateHiddenInputs.call(this);
 },
 UseDelayedSpecialFocus: function() { 
  return true;
 },
 AdjustWidthInDropDown: function(parentComboBoxMainElement, isCallbackMode, customWidth) {
  var lbScrollDiv = this.GetScrollDivElement();
  var lbMainElement = this.GetMainElement();
  var scrollWidth = 0;
  if (this.IsMultiColumn() && isCallbackMode && this.GetScrollSpacerVisibility(false) && this.GetBottomScrollSpacerHeight() == 0)
   this.SetBottomScrollSpacerVisibility(true);
  var keepCurrentWidth = this.HasVirtualScrolling() && this.hasDecoratedItems && this.isComboBoxScrollingCallbackProcessing;
  if(!keepCurrentWidth) {
   lbMainElement.style.width = "";
   lbScrollDiv.style.paddingRight = "0px";
   lbScrollDiv.style.width = "100%";
  }
  else
   this.isComboBoxScrollingCallbackProcessing = false;
  if (customWidth != "") {
   lbMainElement.style.width = customWidth;
   var width = lbMainElement.clientWidth;
   var scrollInfo = this.SetScrollDivAndCorrectionForScroll(width, false);
   width = scrollInfo.scrollDivWidth;
   scrollWidth = scrollInfo.scrollWidth;
   if((!ASPx.Browser.IE || this.HasVirtualScrolling()) && !this.enableEllipsis) {
    var difference = this.GetItemsWidth() - lbScrollDiv.clientWidth;
    if (difference > 0) {
     lbMainElement.style.width = (lbMainElement.offsetWidth + difference) + "px";
     lbScrollDiv.style.width = (lbMainElement.clientWidth) + "px";
    }
   }
  } else {
   var width = this.GetItemsWidth();
   var scrollInfo = this.SetScrollDivAndCorrectionForScroll(width, true);
   width = scrollInfo.scrollDivWidth;
   scrollWidth = scrollInfo.scrollWidth;
   if (ASPx.Browser.Firefox && lbMainElement.offsetWidth < lbScrollDiv.offsetWidth)
    lbMainElement.style.width = "0%"; 
   if (parentComboBoxMainElement) {
    var widthDifference = parentComboBoxMainElement.offsetWidth - lbMainElement.offsetWidth;
    if (widthDifference > 0) {
     this.scrollDivMinWidth = width + widthDifference;
     lbScrollDiv.style.width = this.scrollDivMinWidth + "px";
     var twoBorderSize = (lbMainElement.offsetWidth - lbMainElement.clientWidth);
     lbMainElement.style.width = (width + widthDifference + twoBorderSize) + "px"; 
    }
   }
  }
  if (this.IsMultiColumn())
   this.CorrectMultiColumnHeaderWidth(scrollWidth);
  if (this.NeedToHandleCellWidth())
   this.CorrectCellNullWidthStyle(this.itemsManager.GetFirstVisibleItemRow());
  if (this.ContainsFixWidthRow()) {
   var lbHeaderDiv = this.GetHeaderDivElement();
   if (lbHeaderDiv)
    lbScrollDiv.style.width = lbHeaderDiv.offsetWidth - ASPx.GetLeftRightBordersAndPaddingsSummaryValue(lbScrollDiv) + "px";
  }
  return lbScrollDiv.offsetWidth;
 },
 SetScrollDivAndCorrectionForScroll: function(width, widthByContent) {
  var lbScrollDiv = this.GetScrollDivElement();
  var scrollWidth = this.GetVerticalScrollBarWidth();
  var browserCanHaveScroll = this.GetVerticalOverflow(lbScrollDiv) == "auto";
  if (widthByContent && browserCanHaveScroll)
   width += scrollWidth;
  lbScrollDiv.style.width = width + "px";
  return { scrollDivWidth: width, scrollWidth: scrollWidth };
 },
 BeforeAdjustHeightInDropDown: function() {
  this.GetMainElement().style.height = "0px";
 },
 AdjustHeightInDropDown: function(customHeight, visibleRowCount, getDefaultHeight) {
  this.BeforeAdjustHeightInDropDown();
  var lbHeight = 0;
  if (customHeight == "")
   lbHeight = this.GetHeightByContent(visibleRowCount, getDefaultHeight);
  else
   lbHeight = this.GetHeightByServerValue(customHeight);
  this.itemsManager.Adjust();
  this.InitializePageSize();
  return lbHeight;
 },
 GetHeightByContent: function(visibleRowCount, getDefaultHeight) {
  var lbScrollDiv = this.GetScrollDivElement(),
   itemCount = this.GetVisibleItemCount(),
   hasVerticalScrollbar = itemCount > visibleRowCount;
  lbScrollDiv.style.height = "";
  if (!hasVerticalScrollbar)
   lbScrollDiv.style.height = this.GetListTableHeight() + "px";
  var height = hasVerticalScrollbar ? this.GetItemsHeight() : Math.max(this.GetItemsHeight(), this.GetListTableHeight());
  if (hasVerticalScrollbar)
   height = getDefaultHeight(height, itemCount);
  else
   height = itemCount == 0 ? "0px" : height + "px";
  lbScrollDiv.style.height = height;
  height = lbScrollDiv.offsetHeight;
  height += ASPx.GetTopBottomBordersAndPaddingsSummaryValue(this.GetMainElement());
  var lbHeaderDiv = this.GetHeaderDivElement();
  if (ASPx.IsExists(lbHeaderDiv))
   height += lbHeaderDiv.offsetHeight;
  return height;
 },
 GetHeightByServerValue: function(customHeight) {
  var lbMainElement = this.GetMainElement();
  var lbScrollDiv = this.GetScrollDivElement();
  var height = customHeight;
  lbMainElement.style.height = "0px";
  lbScrollDiv.style.height = "0px";
  lbMainElement.style.height = height;
  var trueLbOffsetHeight = lbMainElement.offsetHeight;
  var trueLbClientHeight = lbMainElement.clientHeight;
  lbScrollDiv.style.height = lbMainElement.clientHeight + "px";
  var lbHeightCorrection = lbMainElement.offsetHeight - trueLbOffsetHeight;
  lbScrollDiv.style.height = (trueLbClientHeight - lbHeightCorrection) + "px";
  height = lbMainElement.offsetHeight;
  return height;
 },
 GetLoadingParentElement: function() {
  return this.GetScrollDivElement().parentNode;
 },
 ShowLoadingPanel: function() { 
  if(!this.isComboBoxList){
   var loadingParentElement = this.GetLoadingParentElement();
   var lp = this.CreateLoadingPanelWithAbsolutePosition(loadingParentElement);
   this.PreventMouseWheelOnElement(lp);
  }
 },
 ShowLoadingDiv: function () {
  if(!this.isComboBoxList){
   var loadingParentElement = this.GetLoadingParentElement();
   var ld = this.CreateLoadingDiv(loadingParentElement);
   this.PreventMouseWheelOnElement(ld);
  }
 },
 PreventMouseWheelOnElement: function(element) {
  if(!element) return;
  var wheelEventName = ASPx.Evt.GetMouseWheelEventName();
  ASPx.Evt.AttachEventToElement(element, wheelEventName, function(evt) {
   if(this.scrollHelper.GetIsAnySpacerVisible())
    ASPx.Evt.PreventEvent(evt);
  }.aspxBind(this));
 },
 ParseCallbackResult: function(result, shouldSelectSilentDelegate){
  var gottenEgdeOfCollection = false;
  var isLoadindToTopByScroll = this.scrollHelper.IsScrolledToTopSpacer();
  if(result[CONSTANTS.CALLBACK_RESULTS.ITEMS].length) {
   var deserializedItems = this.DeserializeItems(result[CONSTANTS.CALLBACK_RESULTS.ITEMS]);
   this.LoadItemsFromCallback(isLoadindToTopByScroll, deserializedItems, shouldSelectSilentDelegate);
   gottenEgdeOfCollection = deserializedItems.length < this.callbackPageSize;
  }
  var noMoreItemsForLoadThisDirection = !result[CONSTANTS.CALLBACK_RESULTS.ITEMS].length || gottenEgdeOfCollection;
  this.SetScrollSpacerVisibility(isLoadindToTopByScroll, !noMoreItemsForLoadThisDirection);
  this.scrollHelper.Reset();
 },
 LoadItemsFromCallback: function(isToTop, deserializedItems, shouldSelectSilentDelegate){
  this.LockSynchronizationOnInternalCallback();
  this.BeginUpdate();
  var isMultiSelect = this.MultiSelectionMode();
  this.RemoveAccessibilityHeaderRow();
  if(isToTop){
   var scrollHeightCorrection = 0;
   for(var i = deserializedItems.length - 1; i >= 0; i--) {
    this.InsertItemInternal(0, deserializedItems[i]);
    scrollHeightCorrection += this.GetItemHeight(0);
   } 
   this.GetScrollDivElement().scrollTop += scrollHeightCorrection;
   this.serverIndexOfFirstItem -= deserializedItems.length;
   if(this.serverIndexOfFirstItem < 0) this.serverIndexOfFirstItem = 0;
  } else {
   for(var i = 0; i < deserializedItems.length; i++) {
    var itemIndex = this.AddItemInternal(deserializedItems[i]);
    var shouldSelectSilent = shouldSelectSilentDelegate && shouldSelectSilentDelegate(deserializedItems[i].value, deserializedItems[i].text);
    this.SelectValueOnLoad(itemIndex, deserializedItems[i].selected, shouldSelectSilent, isMultiSelect);
   } 
  }
  if(this.changeSelectAfterCallback != 0) {
   var newIndex = this.GetSelectedIndex() + this.changeSelectAfterCallback;
   newIndex = this.GetAdjustedIndex(newIndex);
   this.SelectIndexSilent(newIndex);
   if(this.scrollHelper.isScrolledToTopSpacer)
    this.ScrollItemToTop(newIndex);
   else
    this.ScrollToItemVisible(newIndex);
  }
  this.AddAccessibilityHeaderRow();
  this.EndUpdate();
  this.UnlockSynchronizationOnInternalCallback();
 },
 SelectValueOnLoad: function (index, selected, shouldSelectSilent, isMultiSelect) {
  if(selected && this.changeSelectAfterCallback == 0) {
   if(isMultiSelect) {
    this.SelectIndices([index]);
   } else {
    if(shouldSelectSilent)
     this.SelectIndexSilent(index);
    else
     this.SelectIndex(index);
   }
  }
 },
 CreateSerializingHelper: function(){
  return new ListBoxItemsSerializingHelper(this);
 },
 InCallback: function(){
  var callbackOwner = this.GetCallbackOwnerControl();
  if(callbackOwner != null)
   return callbackOwner.InCallback();
  return ASPxClientListEdit.prototype.InCallback.call(this);
 },
 GetItemsRangeForLoad: function(){
  return this.scrollHelper.GetItemsRangeForLoad();
 },
 GetScrollSpacerElement: function(isTop){
  return document.getElementById(this.name + (isTop ? lbTSIdSuffix : lbBSIdSuffix));
 },
 GetScrollSpacerVisibility: function(isTop){
  if(!this.clientEnabled)
   return false;
  return isTop ? this.isTopSpacerVisible : this.isBottomSpacerVisible;
 },
 SetScrollSpacerVisibility: function(isTop, visibility){
  this.LockScrollHandler();
  var spacer = this.GetScrollSpacerElement(isTop);
  if(spacer){
   if(visibility)
    spacer.style.height = this.GetRequiredScrollSpacerHeight() + "px";
   if(this.clientEnabled){
    if(isTop)
     this.isTopSpacerVisible = visibility;
    else
     this.isBottomSpacerVisible = visibility;
   }
   if(ASPx.GetElementDisplay(spacer) != visibility){
    ASPx.SetElementDisplay(spacer, visibility);
    ASPx.GetElementVisibility(spacer, visibility);
   }
  }
  this.itemsManager.OnScrollSpacerVisibilityChanged();
  this.UnlockScrollHandler();
 },
 GetRequiredScrollSpacerHeight: function() {
  return this.GetScrollDivElement().clientHeight;
 },
 SetTopScrollSpacerVisibility: function(visibility){
  this.SetScrollSpacerVisibility(true, visibility);
 },
 SetBottomScrollSpacerVisibility: function(visibility){
  this.SetScrollSpacerVisibility(false, visibility);
 },
 GetTopScrollSpacerHeight: function(){
  return this.GetScrollSpacerVisibility(true) ? this.GetScrollSpacerElement(true).clientHeight : 0;
 },
 GetBottomScrollSpacerHeight: function(){
  return this.GetScrollSpacerVisibility(false) ? this.GetScrollSpacerElement(false).clientHeight : 0;
 },
 GetTopSpacersHeight: function() {
  return this.itemsManager.GetTopSpacersHeight();
 },
 SendCallback: function(onSuccess) {
  if(!this.InCallback()){
   this.ShowLoadingElements();
   var callbackOwner = this.GetCallbackOwnerControl();
   if(callbackOwner != null)
    callbackOwner.SendCallback(onSuccess);
   else {
    var argument = this.GetCallbackArguments();
    this.CreateCallback(argument, null, onSuccess);
   }
  }
 },
 OnCallback: function(result, shouldSelectSilentDelegate) {
  if(result.serverMode)
   this.UpdateStateObjectWithObject({serverMode: true});
  if(!this.filterStrategy || !this.filterStrategy.ShouldDiscardCallbackResult()) {
   this.ParseCallbackResult(result, shouldSelectSilentDelegate);
   if(!this.isComboBoxList)
    this.filterStrategy.OnCallback(result);
   this.OnCallbackFinally();
  }
 },
 OnCallbackError: function(result){
  ASPxClientListBoxBase.prototype.OnCallbackError.call(this, result);
  this.OnCallbackFinally();
 },
 OnCallbackFinally: function () {
  this.itemsManager.Adjust();
  this.HideLoadingPanel();
  this.changeSelectAfterCallback = 0;
 },
 DoEndCallback: function() {
  this.filterStrategy.OnBeforeDoEndCallback();
  ASPxClientListBoxBase.prototype.DoEndCallback.call(this);
  this.filterStrategy.OnAfterDoEndCallback();
 },
 RaiseEndCallback: function() {
  if(this.preventEndCallbackRising)
   this.preventEndCallbackRising = false;
  else
   ASPxClientListBoxBase.prototype.RaiseEndCallback.call(this);
 },
 LockScrollHandler: function(){
  this.scrollHandlerLockCount ++;
 },
 UnlockScrollHandler: function(){
  this.scrollHandlerLockCount --;
 },
 IsScrollHandlerLocked: function(){
  return this.scrollHandlerLockCount > 0;
 },
 OnScroll: function(){
  if(this.IsScrollHandlerLocked()) return;
  if(this.IsVisible() && !this.InCallback() && ( this.GetScrollSpacerVisibility(true) || this.GetScrollSpacerVisibility(false))) {
   this.scrollHelper.OnScroll();
   if(this.scrollHelper.GetIsNeedToHideTopSpacer())
    this.SetTopScrollSpacerVisibility(false);
   if(this.scrollHelper.GetIsNeedCallback()) {
    this.isComboBoxScrollingCallbackProcessing = this.isComboBoxList;
    this.SendCallback();
   }
  }
 },
 OnBrowserWindowResize: function(e) {
  if(this.IsVisible())
   this.CorrectSize();
 },
 KeyboardSupportAllowed: function(){
  return !this.CheckColumnSelectionMode();
 },
 InitializeKeyHandlers: function() {
  if(this.KeyboardSupportAllowed()){
   this.AddKeyDownHandler(ASPx.Key.PageUp, "OnPageUp");
   this.AddKeyDownHandler(ASPx.Key.PageDown, "OnPageDown");
   this.AddKeyDownHandler(ASPx.Key.End, "OnEndKeyDown");
   this.AddKeyDownHandler(ASPx.Key.Home, "OnHomeKeyDown");
   this.AddKeyDownHandler(ASPx.Key.Up, "OnArrowUp");
   this.AddKeyDownHandler(ASPx.Key.Down, "OnArrowDown");
  } else if(this.accessibilityCompliant && !this.IsNativeCheckBoxes()) {
   this.AddKeyDownHandler(ASPx.Key.Up, "OnAccessArrowUp");
   this.AddKeyDownHandler(ASPx.Key.Down, "OnAccessArrowDown");
  }
 },
 OnArrowUp: function(evt){
  if(this.isInitialized)
   this.SelectNeighbour(-1);
  return true;
 },
 OnArrowDown: function(evt){
  if(this.isInitialized)
   this.SelectNeighbour(1);
  return true;
 },
 OnAccessArrowUp: function(evt){
  if(!this.isInitialized) return true;
  var index = this.GetFocusedIndex();
  var isItemCheckBoxFocused = this.GetInternalCheckBox(index) && this.GetInternalCheckBox(index).focused;
  var isSelectAllCheckBoxFocused = this.selectAllCheckBox && this.selectAllCheckBox.focused;
  if(index > 0 && isItemCheckBoxFocused)
   this.SetFocusedIndex(index - 1);
  else if(index == 0 && this.selectAllCheckBox && !isSelectAllCheckBoxFocused) {
   this.selectAllCheckBox.mainElement.focus();
   this.GetItemSelectionHelper().SetFocusedIndexInternal(index, false);
  }
  else
   this.SetFocusedIndex(this.GetItemCount() - 1);
  return true;
 },
 OnAccessArrowDown: function(evt){
  if(!this.isInitialized) return true;
  var index = this.GetFocusedIndex();
  var isItemCheckBoxFocused = this.GetInternalCheckBox(index) && this.GetInternalCheckBox(index).focused;
  var isSelectAllCheckBoxFocused = this.selectAllCheckBox && this.selectAllCheckBox.focused;
  if(index < this.GetItemCount() - 1 && isItemCheckBoxFocused)
   this.SetFocusedIndex(index + 1);
  else if(index == this.GetItemCount() - 1 && this.selectAllCheckBox && !isSelectAllCheckBoxFocused) {
   this.selectAllCheckBox.mainElement.focus();
   this.GetItemSelectionHelper().SetFocusedIndexInternal(index, false);
  }
  else
   this.SetFocusedIndex(0);
  return true;
 },
 SetFocusedIndex: function(index) {
  if(this.GetIsCheckColumnExists()) {
   this.MakeItemVisible(index);
   setTimeout(function () { this.GetInternalCheckBox(index).mainElement.focus(); }.aspxBind(this), 0);
  }
  this.GetItemSelectionHelper().SetFocusedIndexInternal(index, false);
 },
 OnPageUp: function(evt){
  if(this.isInitialized)
   this.SelectNeighbour(-this.scrollPageSize);
  return true;
 },
 OnPageDown: function(evt){
  if(this.isInitialized)
   this.SelectNeighbour(this.scrollPageSize);
  return true;
 },
 OnHomeKeyDown: function(evt){
  if(this.isInitialized)
   this.SelectNeighbour(-this.GetItemCount());
  return true;
 },
 OnEndKeyDown: function(evt){
  if(this.isInitialized)
   this.SelectNeighbour(this.GetItemCount());
  return true;
 },
 GetAdjustedIndex: function(index){
  if(index < 0) index = 0;
  else{
   var itemCount = this.GetItemCount();
   if(index >= itemCount) index = itemCount - 1;
  }
  return index;
 },
 SelectNeighbour: function (step) {
  var itemCount = this.GetItemCount();
  if(itemCount > 0) {
   this.changeSelectAfterCallback = 0;
   var selectedIndex = this.GetFocusedIndex();
   var newSelectedIndex = this.GetNewSelectedIndex(selectedIndex, step);
   newSelectedIndex = this.GetAdjustedIndex(newSelectedIndex);
   if(selectedIndex != newSelectedIndex && this.IsItemFiltered(newSelectedIndex)) {
    this.LockScrollOnKBNavigation();
    this.SetSelectedIndexCore(newSelectedIndex);
    this.UnlockScrollOnKBNavigation();
   }
   if(this.GetIsNeedToCallbackLoadItemsToTop(newSelectedIndex, step, itemCount)) {
    this.LoadItemsOnCallback(true, newSelectedIndex);
   } else if(this.GetIsNeedToCallbackLoadItemsToBottom(newSelectedIndex, step, itemCount)) {
    this.LoadItemsOnCallback(false, newSelectedIndex);
   }
   this.ScrollToItemVisible(newSelectedIndex);
  }
 },
 GetNewSelectedIndex: function(selectedIndex, step) {
  var pageDownSize = step == 1 ? this.scrollPageSize + 1 : this.scrollPageSize; 
  var isFirstPageDown = selectedIndex == -1 && step == pageDownSize && step > 1;
  if(isFirstPageDown)
   step++;
  var newSelectedIndex = 0;
  var areThereUnfilteredItems = this.GetVisibleItemCount() < this.GetItemCount();
  if(areThereUnfilteredItems)
   newSelectedIndex = this.itemsManager.GetNewItemIndexInFilteredRange(selectedIndex, step);
  else
   newSelectedIndex = selectedIndex + step;
  return newSelectedIndex;
 },
 GetIsNeedToCallbackLoadItemsToTop: function(selectedIndex, step, itemCount){
  return this.isCallbackMode && this.GetScrollSpacerVisibility(true) && 
   this.serverIndexOfFirstItem > 0 && ((step < 0 && selectedIndex <= 0) || step <= -itemCount);
 },
 GetIsNeedToCallbackLoadItemsToBottom: function(selectedIndex, step, itemCount){
  return this.isCallbackMode && this.GetScrollSpacerVisibility(false) && 
   ((step > 0 && selectedIndex >= itemCount - 1) || step >= itemCount);
 },
 LoadItemsOnCallback: function(isToTop, index){
  this.changeSelectAfterCallback = index - this.GetSelectedIndex();
  this.scrollHelper.SetItemsRangeForLoad(isToTop);
  this.isComboBoxScrollingCallbackProcessing = this.isComboBoxList;
  this.SendCallback();
 },
 FindInputElement: function(){
  if(this.accessibilityCompliant)
   return this.isComboBoxList ? null : this.GetAccessibilityAssistantElement();
  return this.GetKBSInput();
 },
 GetKBSInput: function() {
  return this.GetChildElement("KBS");
 },
 GetAccessibilityActiveElements: function() {
  var accessibilityElements = [];
  if(this.CheckColumnSelectionMode()) {
   for(var i = 0; i < this.GetItemCount() ; i++) {
    var checkBoxFocusableElement = this.GetCheckBoxFocusableElement(i);
    if(checkBoxFocusableElement)
     accessibilityElements.push(checkBoxFocusableElement);
   }
  }
  accessibilityElements.push(this.accessibilityHelper ? this.accessibilityHelper.GetActiveElement() : this.GetInputElement());
  return accessibilityElements;
 },
 SetHoverElement: function(element){
  ASPx.GetStateController().SetCurrentHoverElementBySrcElement(element);
 },
 InitOnContainerMadeVisible: function(){
  this.AdjustControl();
 },
 ClearItemsCore: function(){
  this.itemsManager.ClearItems();
  this.EnsureFixWidthRow();
  this.AddAccessibilityHeaderRow();
  this.OnItemsCleared();
  this.SetValue(null);
 },
 OnItemsCleared: function(){
  this.GetItemSelectionHelper().OnItemsCleared();
 },
 CorrectCellWidthsOnFirstRowItemReplacement: function(oldFirstRowItemIndex, newFirstRowItemIndex) {
  if (!this.ContainsFixWidthRow() && !this.HasVirtualScrolling()) {
   var oldFirstRowItemHasTemplate = this.ItemRowHasTemplate(oldFirstRowItemIndex);
   var newFirstRowItemHasTemplate = this.ItemRowHasTemplate(newFirstRowItemIndex);
   if(!oldFirstRowItemHasTemplate && !newFirstRowItemHasTemplate)
    this.CopyCellWidths(oldFirstRowItemIndex, newFirstRowItemIndex);
  }
 },
 CopyCellWidths: function(sourceRowIndex, destinationRowIndex){
  var cellCount = this.GetItemCellCount();
  var sourceRow = this.GetItemRow(sourceRowIndex);
  var destRow = this.GetItemRow(destinationRowIndex);
  if (!sourceRow || !destRow) return; 
  var lastDestCellIndex = destRow.cells.length - 1;
  for(var i = 0; i < lastDestCellIndex; i++) {
   destRow.cells[i].style.width = sourceRow.cells[i].style.width;
  }
  if(destRow.cells.length === cellCount) {
   destRow.cells[lastDestCellIndex].style.width = sourceRow.cells[lastDestCellIndex].style.width;
  } else {
   var cellWidths = ASPx.Data.CollectionToArray(sourceRow.cells)
    .slice(lastDestCellIndex)
    .map(function(cell) { return ASPx.PxToInt(cell.style.width); })
    .reduce(function(accumulator, current) { return accumulator + current; }, 0);
   destRow.cells[lastDestCellIndex].style.width = cellWidths + "px";
  }
  if(this.NeedToHandleCellWidth())
   this.CorrectCellNullWidthStyle(destRow);
 },
 RemoveItem: function (index) {
  var firstRenderedItem = this.itemsManager.GetFirstRenderedItem();
  if (firstRenderedItem && index == firstRenderedItem.index && this.GetItemRow(firstRenderedItem.index + 1) !== null)
   this.CorrectCellWidthsOnFirstRowItemReplacement(firstRenderedItem.index, firstRenderedItem.index + 1);
  if (0 <= index && index < this.GetItemCount()) {
   this.UpdateSyncArraysItemDeleted(this.GetItem(index), true);
   this.itemsManager.RemoveItem(index);
   this.OnItemRemoved(index);
  }
 },
 GetItem: function(index, preventEncodeText) {
  return this.itemsManager.GetItem(index, preventEncodeText);
 },
 GetItemRowTexts: function(row) {
  var serializedTexts = this.GetTextsDataAttribute(row);
  if(ASPx.IsExists(serializedTexts))
   return JSON.parse(serializedTexts);
  var texts = [];
  var i = this.GetItemFirstTextCellIndex();
  var cellsLength = this.IsMultiColumn() ? row.cells.length : i + 1;
  for(; i < cellsLength; i++) {
   var textCell = row.cells[i];
   texts.push(ASPxClientListBox.GetItemCellInnerText(textCell));
  }
  return texts;
 },
 ItemRowHasTemplate: function(itemIndex) {
  var itemRow = this.GetItemRow(itemIndex);
  return itemRow ? this.ItemRowHasTemplateCore(itemRow) : false;
 },
 ItemRowHasTemplateCore: function(itemRow) {
  return this.ItemRowHasSerializedTextsAttr(itemRow);
 },
 ItemRowHasSerializedTextsAttr: function(itemRow) {
  return ASPx.Attr.IsExistsAttribute(itemRow, itemSerializedTextsAttributeName);
 },
 ItemCellHasTextAttr: function(itemTextCell) {
  return ASPx.Attr.IsExistsAttribute(itemTextCell, itemCellTextAttributeName);
 },
 GetFirstVisibleItem: function() {
  return this.itemsManager.GetFirstVisibleItem();
 },
 GetFirstFilteredItemIndex: function () {
  return this.itemsManager.GetFirstFilteredItemIndex();
 },
 PerformCallback: function(arg, onSuccess) {
  this.SetScrollSpacerVisibility(true, false);
  this.SetScrollSpacerVisibility(false, false);
  this.ClearItemsForPerformCallback();
  this.serverIndexOfFirstItem = 0;
  this.SetScrollSpacerVisibility(true, false);
  this.SetScrollSpacerVisibility(false, false);
  this.FormatAndSetCustomCallbackArg(arg, true);
  this.SendCallback(onSuccess);
  this.FormatAndSetCustomCallbackArg(arg, false);
 },
 GetTableRowParent: function(table){
  if(table.tBodies.length > 0)
   return table.tBodies[0];
  return table;
 },
 ProtectWhitespaceSerieses: function(text){
  if(text == "") 
   text = nbsp;
  else {
   if(text.charAt(0) == ' ')
    text = nbsp + text.slice(1);
   if(text.charAt(text.length - 1) == ' ')
    text = text.slice(0, -1) + nbsp;
   text = text.replace(new RegExp("  ", "g"), " &nbsp;");
  }
  return text;
 }, 
 InsertItemInternal: function(index, itemProperties) {
  if(!this.hasSampleItem) 
   return;
  this.AdjustItemProperties(itemProperties);
  ASPx.Data.ArrayInsert(this.itemsValue, itemProperties.value, index);
  this.itemsManager.InsertItem(index, itemProperties);
  this.RegisterInsertedItem(index, itemProperties);
  this.OnItemInserted(index);
 },
 GetListTableRowBeforeNewItemRow: function (newItemIndex, listTable) {
  var lastRenderedItem = this.itemsManager.GetLastRenderedItem();
  if (!lastRenderedItem || lastRenderedItem.index < newItemIndex) {
   var lastItemRow = lastRenderedItem ? this.GetItemRow(lastRenderedItem.index) : null;
   var lastListTableRow = listTable.rows[listTable.rows.length - 1];
   if (lastItemRow)
    return lastItemRow === lastListTableRow ? null : lastItemRow.nextSibling;
   if (!!this.GetAccessibilityHeaderRow())
    return this.ContainsFixWidthRow() ? listTable.rows[1] : listTable.rows[0];
   return null;
  }
  for (var i = 0; i < listTable.rows.length; i++)
   if (this.GetItemIndexByRow(listTable.rows[i]) >= newItemIndex)
    return listTable.rows[i];
  return null;
 },
 AdjustItemProperties: function(itemProperties) {
  if(!itemProperties.texts || itemProperties.texts.length == 0)
   itemProperties.texts = [""];
  else if(typeof (itemProperties.texts) === "string")
   itemProperties.texts = [itemProperties.texts];
  if(typeof (itemProperties.value) === "undefined")
   itemProperties.value = itemProperties.texts[0];
  if(!ASPx.IsExists(itemProperties.imageUrl) || itemProperties.imageUrl === "")
   itemProperties.imageUrl = this.defaultImageUrl;
 },
 AddStateControllerClasses: function(itemId){
  var itemCellsIdPostfixes = this.GetItemCellsIdPostfixes();
  var sampleItemFirstTextCell = this.GetSampleItemFirstTextCell();
  var styleController = ASPx.GetStateController();
  var hoverStyleClasses = this.CreateStyleClasses(itemId, itemCellsIdPostfixes, 
      styleController.GetHoverElement(sampleItemFirstTextCell), ASPx.HoverItemKind);
  var selectedStyleClasses = this.CreateStyleClasses(itemId, itemCellsIdPostfixes, 
      styleController.GetSelectedElement(sampleItemFirstTextCell), ASPx.SelectedItemKind);
  var disabledStyleClasses = this.CreateStyleClasses(itemId, itemCellsIdPostfixes, 
      styleController.GetDisabledElement(sampleItemFirstTextCell), ASPx.DisabledItemKind);
    ASPx.AddHoverItems(this.name, hoverStyleClasses, true);
    ASPx.AddSelectedItems(this.name, selectedStyleClasses, true);
    ASPx.AddDisabledItems(this.name, disabledStyleClasses, true);
  ASPx.Attr.RemoveAttribute(sampleItemFirstTextCell, ASPx.CachedStatePrefix + ASPx.HoverItemKind);
  ASPx.Attr.RemoveAttribute(sampleItemFirstTextCell, ASPx.CachedStatePrefix + ASPx.SelectedItemKind);
  ASPx.Attr.RemoveAttribute(sampleItemFirstTextCell, ASPx.CachedStatePrefix + ASPx.DisabledItemKind);
 },
 RemoveStateControllerClasses: function(itemId){
  var itemCellsIdPostfixes = this.GetItemCellsIdPostfixes();
  var classes = [];
  classes[0] = [];
  classes[0][0] = [itemId];
  classes[0][1] = itemCellsIdPostfixes;
    ASPx.RemoveHoverItems(this.name, classes);
    ASPx.RemoveSelectedItems(this.name, classes);
    ASPx.RemoveDisabledItems(this.name, classes);
 },
 GetCellInfo: function(index, infoArray) {
  if(!infoArray) return null;
  var filteredArray = infoArray.filter(function(info) { return info.index === index; });
  return filteredArray.length ? filteredArray[0].value : null;
 },
 PrepareItem: function(newItemRow, itemProperties) {
  var i = 0;
  if(this.GetIsCheckColumnExists())
   i++;
  if(this.imageCellExists) {
   this.PrepareItemImage(newItemRow, i, itemProperties.imageUrl);
   i++;
  }
  if(itemProperties.htmlContent) {
   this.SetItemHtmlContent(newItemRow, itemProperties.htmlContent);
   this.SetTextsDataAttribute(newItemRow, itemProperties.texts);
  } else {
   this.SetItemTextContent(i, newItemRow, itemProperties);
  }
  this.AssignDecorationSettingsToElement(newItemRow, itemProperties.style, itemProperties.cssClass, itemProperties.tooltip, itemProperties.attributes);
 },
 LockRunStartupSciptsInItemRow: function() {
  this.lockRunStartupScipts = true;
 },
 UnlockRunStartupSciptsInItemRow: function() {
  this.lockRunStartupScipts = false;
 },
 IsRunStartupSciptsInItemRowLocked: function() {
  return this.lockRunStartupScipts;
 },
 EnsureStartupScriptsInContainer: function(container) {
  if(!this.InCallback() && !this.IsRunStartupSciptsInItemRowLocked())
   ASPx.RunStartupScripts(false, container);
 },
 SetItemHtml: function(index, html) {
  this.hasDecoratedItems = true;
  this.hasItemTemplate = true;
  this.EnsureFixWidthRow(true);
  this.itemsManager.SetItemHtml(index, html);
  this.ProcessItemRow(index, function(itemRow) {
   if(!this.ItemRowHasSerializedTextsAttr(itemRow))
    this.SetTextsDataAttribute(itemRow, this.GetItem(index).texts);
   this.SetItemHtmlContent(itemRow, html);
   this.itemsManager.OnDecoratedItemsRendering();
  }.bind(this));
 },
 SetTextsDataAttribute: function(itemRow, texts) { ASPx.Attr.SetAttribute(itemRow, itemSerializedTextsAttributeName, JSON.stringify(texts)); },
 GetTextsDataAttribute: function(itemRow) { return ASPx.Attr.GetAttribute(itemRow, itemSerializedTextsAttributeName); },
 SetItemTooltip: function(index, tooltip) {
  this.itemsManager.SetItemTooltip(index, tooltip);
  this.ProcessItemRow(index, function(itemRow) { this.SetElementTooltip(itemRow, tooltip); }.aspxBind(this));
 },
 SetItemAttribute: function(index, attributeName, attributeValue) {
  this.itemsManager.SetItemAttribute(index, attributeName, attributeValue);
  this.ProcessItemRow(index, function(itemRow) { ASPx.Attr.SetAttribute(itemRow, attributeName, attributeValue); }.aspxBind(this));
 },
 AddItemCssClass: function(index, className) {
  this.hasDecoratedItems = true;
  this.itemsManager.AddItemCssClass(index, className);
  this.ProcessItemRow(index, function(itemRow) {
   ASPx.AddClassNameToElement(itemRow, className);
   this.itemsManager.OnDecoratedItemsRendering();
  }.bind(this));
 },
 RemoveItemCssClass: function(index, className) {
  this.hasDecoratedItems = true;
  this.itemsManager.RemoveItemCssClass(index, className);
  this.ProcessItemRow(index, function(itemRow) {
   ASPx.RemoveClassNameFromElement(itemRow, className);
   this.itemsManager.OnDecoratedItemsRendering();
  }.bind(this));
 },
 SetItemTextCellHtml: function(itemIndex, textCellIndex, html) {
  this.hasDecoratedItems = true;
  this.itemsManager.SetItemTextCellHtml(itemIndex, textCellIndex, html);
  this.ProcessItemTextCell(itemIndex, textCellIndex, function(textCell) {
   if(!this.ItemCellHasTextAttr(textCell))
    this.SetItemCellTextDataAttribute(textCell, this.GetItem(itemIndex).texts[textCellIndex]);
   this.SetItemTextCellHtmlContent(textCell, html);
   this.itemsManager.OnDecoratedItemsRendering();
  }.aspxBind(this));
 },
 SetItemCellTextDataAttribute: function(textCell, text) {
  ASPx.Attr.SetAttribute(textCell, itemCellTextAttributeName, text);
 },
 SetItemTextCellTooltip: function(itemIndex, textCellIndex, tooltip) {
  this.itemsManager.SetItemTextCellTooltip(itemIndex, textCellIndex, tooltip);
  this.ProcessItemTextCell(itemIndex, textCellIndex, function(textCell) { this.SetElementTooltip(textCell, tooltip); }.aspxBind(this));
 },
 SetItemTextCellAttribute: function(itemIndex, textCellIndex, attributeName, attributeValue) {
  this.itemsManager.SetItemTextCellAttribute(itemIndex, textCellIndex, attributeName, attributeValue);
  this.ProcessItemTextCell(itemIndex, textCellIndex, function(textCell) { ASPx.Attr.SetAttribute(textCell, attributeName, attributeValue); }.aspxBind(this));
 },
 AddItemTextCellCssClass: function(itemIndex, textCellIndex, className) {
  this.hasDecoratedItems = true;
  this.itemsManager.AddItemTextCellCssClass(itemIndex, textCellIndex, className);
  this.ProcessItemTextCell(itemIndex, textCellIndex, function(textCell) {
   ASPx.AddClassNameToElement(textCell, className);
   this.itemsManager.OnDecoratedItemsRendering();
  }.bind(this));
 },
 RemoveItemTextCellCssClass: function(itemIndex, textCellIndex, className) {
  this.hasDecoratedItems = true;
  this.itemsManager.RemoveItemTextCellCssClass(itemIndex, textCellIndex, className);
  this.ProcessItemTextCell(itemIndex, textCellIndex, function(textCell) {
   ASPx.RemoveClassNameFromElement(textCell, className);
   this.itemsManager.OnDecoratedItemsRendering();
  }.bind(this));
 },
 ProcessItemRow: function(index, action) {
  var itemRow = this.GetItemRow(index);
  if(itemRow)
   action(itemRow);
 },
 ProcessItemTextCell: function(itemIndex, textCellIndex, action) {
  var itemTextCell = this.GetItemTextCell(itemIndex, textCellIndex);
  if(itemTextCell && !this.ItemRowHasTemplateCore(itemTextCell.parentNode))
   action(itemTextCell);
 },
 SetItemHtmlContent: function(itemRow, html) {
  var redundantCells = ASPx.Data.CollectionToArray(itemRow.cells)
   .slice(this.GetItemFirstTextCellIndex(), itemRow.cells.length - 1);
  redundantCells.forEach(function(cell) { itemRow.removeChild(cell); });
  var itemHtmlContainerCell = itemRow.cells[itemRow.cells.length - 1];
  ASPx.SetElementDisplay(itemHtmlContainerCell, this.GetVisibleColumnCount() !== 0);
  itemHtmlContainerCell.colSpan = Math.max(itemHtmlContainerCell.colSpan, this.GetVisibleColumnCount());
  if(this.IsMultiColumn()) {
   if(this.GetItemFirstTextCellIndex() === 0)
    ASPx.AddClassNameToElement(itemHtmlContainerCell, FIRST_CELL_MARKER_CSS_CLASS_NAME);
   ASPx.AddClassNameToElement(itemHtmlContainerCell, LAST_CELL_MARKER_CSS_CLASS_NAME);
  }
  itemHtmlContainerCell.style.width = "";
  itemHtmlContainerCell.innerHTML = html;
  this.RemoveEllipsisFromNode(itemHtmlContainerCell);
  this.EnsureStartupScriptsInContainer(itemHtmlContainerCell);
 },
 SetItemTextContent: function(textCellIndex, newItemRow, itemProperties) {
  var cellCount = this.GetItemCellCount();
  for(var j = 0; textCellIndex < cellCount; textCellIndex++, j++) {
   var cellStyle = this.GetCellInfo(j, itemProperties.cellStyles);
   var cellCssClass = this.GetCellInfo(j, itemProperties.cellCssClasses);
   var cellTooltip = this.GetCellInfo(j, itemProperties.cellTooltips);
   var cellAttributes = this.GetCellInfo(j, itemProperties.cellAttributes);
   var htmlContent = this.GetCellInfo(j, itemProperties.htmlContents);
   this.PrepareItemTextCell(newItemRow.cells[textCellIndex], itemProperties.texts[j], cellStyle, cellCssClass, cellTooltip, cellAttributes, htmlContent);
  }
 },
 SetItemTextCellHtmlContent: function(cell, html) {
  cell.innerHTML = html;
  this.RemoveEllipsisFromNode(cell);
  this.EnsureStartupScriptsInContainer(cell);
 },
 PrepareItemImage: function(newItemRow, imageCellIndex, imageUrl){
  var imageCell = newItemRow.cells[imageCellIndex];
  var image = ASPx.GetNodeByTagName(imageCell, "IMG", 0);
  if(!imageUrl) {
   if(image)
    ASPx.RemoveElement(image);
   imageCell.innerHTML = "&nbsp;";
  } else {
   if(!image) {
    image = document.createElement("IMG");
    imageCell.innerHTML = "";
    imageCell.appendChild(image);
   }
   ASPx.ImageUtils.SetImageSrc(image, imageUrl);
  }
 }, 
 PrepareItemTextCell: function(cell, text, style, cssClass, tooltip, attributes, htmlContent) {
  if(!ASPx.IsExists(text)) 
   text = "";
  if(this.encodeHtml)
   text = ASPx.Str.EncodeHtml(text);
  if(htmlContent) {
   this.SetItemTextCellHtmlContent(cell, htmlContent);
   this.SetItemCellTextDataAttribute(cell, this.ProtectWhitespaceSerieses(text));
  }
  else {
   cell.innerHTML = this.ProtectWhitespaceSerieses(text);
   if(this.enableEllipsis)
    ASPx.AddClassNameToElement(cell, ASPx.ELLIPSIS_MARKER_CLASS);
  }
  this.AssignDecorationSettingsToElement(cell, style, cssClass, tooltip, attributes);
  if(text == "")
   ASPx.Attr.SetAttribute(cell, "DXText", text);
 },
 AssignDecorationSettingsToElement: function(element, style, cssClass, tooltip, attributes) {
  if(cssClass)
   ASPx.AddClassNameToElement(element, cssClass);
  if(style) {
   var styleSheet = ASPx.GetCurrentStyleSheet();
   ASPx.AddClassNameToElement(element, ASPx.CreateImportantStyleRule(styleSheet, style));
  }
  if(tooltip)
   this.SetElementTooltip(element, tooltip);
  if(attributes)
   for(var key in attributes)
    if(attributes.hasOwnProperty(key))
     ASPx.Attr.SetAttribute(element, key, attributes[key]);
 },
 SetElementTooltip: function(element, tooltip) {
  this.RemoveEllipsisTooltip(element);
  ASPx.Attr.SetAttribute(element, "title", tooltip);
 },
 FormatText: function(texts, value) {
  if(typeof(texts) === "string")
   return texts;
  else if(!this.IsMultiColumn())
   return texts[0];
  else
   return this.FormatTextCore(texts, value);
 },
 FormatTextCore: function(texts, value) {
  var result = "";
  if(this.isComboBoxList) {
   if(this.nullValueItemDisplayText !== null && value === null)
    result = this.nullValueItemDisplayText;
   else
    result = ASPx.Formatter.Format(this.textFormatString, texts);
  } else
   result = texts.join("; ");
  return result;
 },
 OnItemInserted: function(index){
  this.GetItemSelectionHelper().OnItemInserted(index);
 },
 OnItemRemoved: function(index){
  this.GetItemSelectionHelper().OnItemRemoved(index);
 },
 CreateItemId: function(index){
  return lbIIdSuffix + index;
 },
 CreateItemClientId: function(index){
  return this.name + "_" + lbIIdSuffix + index;
 },
 CreateStyleClasses: function(id, postfixes, item, kind){
  var classes = [];
  if(item && item[kind]){
   classes[0] = [];
   classes[0][0] = item[kind].classNames;
   classes[0][1] = item[kind].cssTexts;
   classes[0][2] = [];
   classes[0][2][0] = id;
   classes[0][3] = postfixes;
  }
  return classes;
 },
 CorrectSizeByTimer: function(){
  if(this.APILockCount == 0 && this.IsDisplayed())
   window.setTimeout(function() { this.OnCorrectSizeByTimer(); }.aspxBind(this), 0);
 },
 FindFreeIndex: function(){
  return this.freeUniqIndex ++;
 },
 GetSampleItemRowID: function(){
  return this.name + "_" + lbSIIdSuffix;
 },
 GetAccessibilitySampleHeaderRowID: function() {
  return this.name + "_" + lbAIRTIdSuffix;
 },
 GetSampleItemRow: function(){
  if(this.SampleItem == null)
   this.SampleItem = ASPx.GetElementById(this.GetSampleItemRowID());
  return this.SampleItem;
 },
 GetAccessibilitySampleHeaderRow: function() {
  if(this.sampleHeaderRow == null)
   this.sampleHeaderRow = ASPx.GetElementById(this.GetAccessibilitySampleHeaderRowID());
  return this.sampleHeaderRow;
 },
 AddAccessibilityHeaderRow: function() {
  if(!this.accessibilityCompliant || !this.IsMultiColumn()) return;
  var listTableBody = ASPx.GetChildByTagName(this.GetListTable(), "TBODY", 0);
  var headerRow = this.GetAccessibilitySampleHeaderRow().cloneNode(true);
  headerRow.id = this.GetAccessibilityHeaderRowID();
  listTableBody.appendChild(headerRow);
 },
 GetAccessibilityHeaderRow: function() {
  return this.GetChildElement(lbAIRIdSuffix);
 },
 RemoveAccessibilityHeaderRow: function() {
  var headerRow = this.GetAccessibilityHeaderRow();
  if(headerRow)
   ASPx.RemoveElement(headerRow);
 },
 GetAccessibilityHeaderRowID: function() {
  return this.name + "_" + lbAIRIdSuffix;
 },
 GetSampleItemFirstTextCell: function(){
  if(!ASPx.IsExistsElement(this.sampleItemFirstTextCell)){
   var sampleItemRow = this.GetSampleItemRow();
   if(ASPx.IsExistsElement(sampleItemRow))
    this.sampleItemFirstTextCell = sampleItemRow.cells[this.imageCellExists ? 1 : 0];
  }
  return this.sampleItemFirstTextCell;
 },
 ChangeEnabledAttributes: function(enabled){
  this.ChangeListTableEvents(this.GetListTable(), ASPx.Attr.ChangeEventsMethod(enabled));
  var focusableElement = this.GetInputElement();
  if(focusableElement) {
   this.ChangeSpecialInputEnabledAttributes(focusableElement, ASPx.Attr.ChangeEventsMethod(enabled));
   if(this.accessibilityCompliant)
    this.ChangeFocusableElementTabIndex(focusableElement, enabled);
   else if(!this.isComboBoxList) {
    var changeMethod = enabled ? ASPx.Attr.RestoreTabIndexAttribute : ASPx.Attr.SaveTabIndexAttributeAndReset;
    changeMethod(focusableElement);
   }
  }
 },
 ChangeFocusableElementTabIndex: function(focusableElement, enabled) {
  if(!this.isComboBoxList) {
   if(enabled)
    ASPx.Attr.SetAttribute(focusableElement, "tabindex", "0");
   else
    focusableElement.removeAttribute("tabindex");
  }
 },
 ChangeEnabledStateItems: function(enabled){
  var controller = ASPx.GetStateController();
  controller.SetElementEnabled(this.GetMainElement(), enabled);
  var count = this.GetItemCount();
  var i = this.hasSampleItem ? -1 : 0 ;
  for(; i < count; i ++){
   this.ChangeEnabledStateItem(i, enabled, controller);
  }
  this.changeSelectAllElementsEnabledState(enabled);
  var changeEventMethod = ASPx.Attr.ChangeEventsMethod(enabled);
  if(this.filteringTextBox && !this.customFilteringEditorID) {
   this.filteringTextBox.SetEnabled(enabled);
   this.ChangeSpecialInputEnabledAttributes(this.filteringTextBox.GetInputElement(), changeEventMethod, true);
  }
  if(this.showFilterButton) {
   this.showFilterButton.SetEnabled(enabled);
   this.ChangeSpecialInputEnabledAttributes(this.showFilterButton.GetInternalButton(), changeEventMethod, true);
  }
 },
 ChangeEnabledStateItem: function (index, enabled, controller) {
  var element = this.GetItemFirstTextCell(index);
  if (element)
   controller.SetElementEnabled(element, enabled);
  if (this.GetIsCheckColumnExists() && index >= 0)
   this.SetCheckBoxEnabled(index, enabled);
 },
 ChangeListTableEvents: function(listTable, method){
  if(this.isComboBoxList){
   method(listTable, "mouseup", aspxLBIClick);
   if(ASPx.Browser.Firefox)
    method(listTable, "mousedown", ASPx.Evt.PreventEvent); 
  }
  else{
   method(listTable, "click", aspxLBIClick);   
   method(listTable, "dblclick", aspxLBIClick); 
   if(this.MultiSelectionMode())
    this.AttachSelectStartHandlerToElement(listTable);
  }
 },
 AttachSelectStartHandlerToElement: function(element) {
  ASPx.Evt.AttachEventToElement(element, "selectstart", aspxLBTSelectStart);
 },
 IsValueChanged: function(){
  return this.cachedValue != this.GetValue();
 },
 OnItemSelectionChanged: function(index, selected, fromSelectAllClick, forceValueChanged){
  if(this.CheckColumnSelectionMode() && !fromSelectAllClick)
   this.SetCheckBoxChecked(index, selected);
  if(!this.IsSelectionEventsLocked()) {
   this.SetRaiseSelectedIndexChangedArguments(this.autoPostBack, index, selected);
   var valueChanged = this.IsValueChanged() || forceValueChanged;
   if(valueChanged) {
    this.RaisePersonalStandardValidation();
    this.OnValueChanged();
   } else {
    if(this.RaiseSelectedIndexChanged())
     this.SendPostBackInternal("");
   }
  }
  this.CacheValue();
  if(this.accessibilityHelper && !fromSelectAllClick)
   this.accessibilityHelper.OnSelectedIndexChanged(index);
 },
 SetRaiseSelectedIndexChangedArguments: function(processOnServer, index, selected){
  this.selectedIndexChangedArguments = {
   processOnServer: processOnServer,
   index: index,
   selected: selected
  };
 },
 GetRaiseSelectedIndexChangedArguments: function(){
  if(!this.selectedIndexChangedArguments)
   this.SetRaiseSelectedIndexChangedArguments(false, this.GetSelectedIndex(), true);
  return this.selectedIndexChangedArguments;
 },
 RaiseSelectedIndexChanged: function (processOnServer) {
  this.RaiseValidationInternal();
  var savedArgs = this.GetRaiseSelectedIndexChangedArguments();
  processOnServer = savedArgs.processOnServer || processOnServer;
  if(!this.SelectedIndexChanged.IsEmpty()){
   var args = new ASPxClientListEditItemSelectedChangedEventArgs(savedArgs.index, savedArgs.selected, processOnServer);
   this.SelectedIndexChanged.FireEvent(this, args);
   processOnServer = args.processOnServer;
  }
  return processOnServer;
 },
 RaiseItemFiltering: function(item, filter, isFit) {
  if(!this.ItemFiltering.IsEmpty()) {
   var args = new ASPxClientListEditItemFilteringEventArgs(item, filter, isFit);
   this.ItemFiltering.FireEvent(this, args);
   isFit = args.isFit;
  }
  return isFit;
 },
 RaiseCustomHighlighting: function(filter, callbackHighlighting) {
  if(!this.CustomHighlighting.IsEmpty()) {
   var args = new ASPxClientListEditCustomHighlightingEventArgs(filter);
   args.highlighting = callbackHighlighting;
   this.CustomHighlighting.FireEvent(this, args);
   return args.highlighting;
  }
  return callbackHighlighting;
 },
 SetWidth: function(width) {
  this.width = width + "px";
  this.GetScrollDivElement().style.width = "100%";
  ASPxClientListBoxBase.prototype.SetWidth.call(this, width);
 },
 SetHeight: function(height) {
  this.heightCorrected = false;
  ASPxClientListBoxBase.prototype.SetHeight.call(this, height);
  this.CorrectHeight();
 },
 OnAssociatedLabelClick: function(focusableElement) {
  var isValidElement = focusableElement && ASPx.IsActionElement(focusableElement) && ASPx.GetIsParent(this.GetMainElement(), focusableElement);
  if(isValidElement)
   focusableElement.focus();
  else
   ASPxClientListBoxBase.prototype.OnDelayedSpecialFocusMouseDown.call(this, null);
 },
 TryApplyHighlighting: function() {
  var ownerControl = this.GetCallbackOwnerControl();
  var filterStrategy = ownerControl && ownerControl.filterStrategy ? ownerControl.filterStrategy : this.filterStrategy;
  if(filterStrategy.ApplyHighlighting)
   filterStrategy.ApplyHighlighting();
 },
 onDropDownModalChanged: function(enabled) {
  if(!this.IsMultiColumn())
   return;
  if(enabled && !this.itemsManager.GetFirstVisibleItemRow())
   return;
  this.updateCellWidthsOnDropDownChanged(enabled);
 },
 updateCellWidthsOnDropDownChanged: function(enabled) {
  var applyFunction = this.getUpdateCellWidthsFunctionOnDropDownChanged(enabled);
  var sampleRow = this.GetSampleItemRow();
  var headerRow = this.GetHeaderTableElement().rows[0];
  var dataRows = this.itemsManager.GetListTableRows();
  for(var i = this.columnFieldNames.length - 1; i >= 0; i--) {
   applyFunction(sampleRow, i);
   applyFunction(headerRow, i);
   for(var row, j = 0; row = dataRows[j]; j++)
    applyFunction(row, i);
  }
 },
 getUpdateCellWidthsFunctionOnDropDownChanged: function(enabled) {
  if(enabled) {
   var row = this.itemsManager.GetFirstVisibleItemRow();
   var widths = Array.prototype.slice.call(row.cells, 0).map(function(cell) { return cell.offsetWidth; });
   var commonWidth = widths.reduce(function(a, b) { return a + b; }, 0);
   widths = widths.map(function(w) { return (w * 100) / commonWidth; });
   return function(row, cellIndex) {
    ASPx.Attr.ChangeStyleAttribute(row.cells[cellIndex], "width", widths[cellIndex] + "%");
   };
  }
  return function(row, cellIndex) {
   ASPx.Attr.RestoreStyleAttribute(row.cells[cellIndex], "width");
  };
 }
});
ASPxClientListBox.GetItemCellInnerText = function(itemTextCell) {
 var text;
 if(typeof(itemTextCell.attributes["DXText"]) != "undefined")
  text = ASPx.Attr.GetAttribute(itemTextCell, "DXText");
 else {
  var itemCellTextAttribute = ASPx.Attr.GetAttribute(itemTextCell, itemCellTextAttributeName);    
  text = ASPx.IsExists(itemCellTextAttribute) ? itemCellTextAttribute : ASPx.GetInnerText(itemTextCell);
 }
 text = text.replace(new RegExp(nbspChar, "g"), " ");
 return text;
};
var ASPxClientNativeListBox = ASPx.CreateClass(ASPxClientListBoxBase, {
 constructor: function(name) {
  this.constructor.prototype.constructor.call(this, name);
 },
 InitializeEvents: function() {
  ASPxClientListBoxBase.prototype.InitializeEvents.call(this);
  if(!!this.GetMainElement()) {
   ASPx.Evt.AttachEventToElement(this.GetMainElement(), "keydown", this.OnKeyDown.aspxBind(this));
   ASPx.Evt.AttachEventToElement(this.GetMainElement(), "keyup", this.OnKeyUp.aspxBind(this));
   ASPx.Evt.AttachEventToElement(this.GetMainElement(), "keypress", this.OnKeyPress.aspxBind(this));
  }
 },
 SetReadOnlyInternal: function(readOnly) {
  ASPxClientListBoxBase.prototype.SetReadOnlyInternal.call(this, readOnly);
  var options = this.GetMainElement().querySelectorAll("option");
  for (var i = 0, option; option = options[i]; i++) {
   if (readOnly)
    ASPx.Attr.SetAttribute(option, "disabled", "disabled");
   else
    ASPx.Attr.RemoveAttribute(option, "disabled");
  }
 }, 
 SetMainElement: function(mainElement){
  this.mainElement = mainElement;
 },
 FindInputElement: function(){
  return this.GetMainElement();
 }, 
 GetOptionCount: function(){
  return this.GetMainElement().options.length;
 },
 GetOption: function(index){
  return this.GetMainElement().options[index];
 },
 GetItemCount: function(){
  return this.GetOptionCount();
 },
 SelectIndexSilent: function(index){
  var selectedIndex = this.GetSelectedIndexInternal();
  var isValidIndex = (-1 <= index && index < this.GetItemCount());
  if((selectedIndex != index && isValidIndex) || !this.isInitialized){
   this.SetSelectedIndexInternal(index);
   return true;
  }
  return false;
 },
 GetSelectedIndexInternal: function(){
  return this.GetMainElement().selectedIndex; 
 },
 SetSelectedIndexInternal: function(index){
  this.GetMainElement().selectedIndex = index; 
 },
 ClearItemsCore: function(){
  this.GetMainElement().innerHTML = "";
 },
 RemoveItem: function(index){
  if(0 <= index && index < this.GetItemCount()){
   var oldSelectedIndex = this.GetSelectedIndexInternal();
   this.UpdateSyncArraysItemDeleted(this.GetItem(index), true);
   var option = this.GetOption(index);
   this.GetMainElement().removeChild(option);
   this.UpdateOptionValues();
   this.OnItemRemoved(oldSelectedIndex, index);
  }
 },
 OnItemRemoved: function(oldSelectedIndex, newSelectedIndex){
  if(newSelectedIndex == oldSelectedIndex && !this.MultiSelectionMode())
   this.SetSelectedIndexInternal(-1);
 },
 MultiSelectionMode: function(){
  return this.GetMainElement().multiple;
 },
 GetItem: function(index){
  if(0 <= index && index < this.GetOptionCount()) {
   var text = this.GetOption(index).text;
   var selected = this.GetMainElement().options[index].selected;
   var itemValue = this.itemsValue[index] !== undefined ? this.itemsValue[index] : null;
   if(ASPx.IsExists(text))
    return new ASPxClientListBoxItem(this, index, text, itemValue, "", selected);
  }
  return null;
 },
 PerformCallback: function(arg) {
  this.ClearItemsForPerformCallback();
  this.FormatAndSetCustomCallbackArg(arg, true);
  this.SendCallback();
  this.FormatAndSetCustomCallbackArg(arg, false);
 },
 SendCallback: function(){
  if(!this.InCallback()){
   var callbackOwner = this.GetCallbackOwnerControl();
   if(callbackOwner != null)
    callbackOwner.SendCallback();
    else {
    var argument = this.GetCallbackArguments();
    this.CreateCallback(argument);
   }
  }
 },
 ParseCallbackResult: function(result){
  var deserializedItems = this.DeserializeItems(result[CONSTANTS.CALLBACK_RESULTS.ITEMS]);
  this.LoadItemsFromCallback(true, deserializedItems);
 },
 InsertItemInternal: function(index, itemProperties) {
  if(typeof (itemProperties.value) == "undefined")
   itemProperties.value = itemProperties.texts;
  var oldSelectedIndex = this.GetSelectedIndexInternal();
  var isAdd = this.GetOptionCount() <= index;
  var newOption = document.createElement("OPTION");
  if(isAdd)
   this.GetMainElement().appendChild(newOption);
  else
   this.GetMainElement().insertBefore(newOption, this.GetOption(index));
  newOption.innerHTML = itemProperties.texts;
  this.UpdateOptionValues();
  ASPx.Data.ArrayInsert(this.itemsValue, itemProperties.value, index);
  this.RegisterInsertedItem(index, itemProperties); 
  if(index == oldSelectedIndex && index != -1)
   this.SetSelectedIndex(index + 1);
 },
 UpdateOptionValues: function() {
  if(this.APILockCount == 0){
   for(var i = 0; i < this.GetOptionCount(); i++)
    this.GetOption(i).value = i;
  }
 },
 ChangeEnabledAttributes: function(enabled){
  if(!this.isComboBoxList)
   this.GetMainElement().disabled = !enabled;
 },
 OnCallback: function(result) {
  this.ParseCallbackResult(result);
 },
 OnItemDblClick: function(){
  this.RaiseItemDoubleClick();
 },
 LoadItemsFromCallback: function(isToTop, deserializedItems){
  this.BeginUpdate();
  this.LockSynchronizationOnInternalCallback();
  var mainElement = this.GetMainElement();
  for(var i = deserializedItems.length - 1; i >= 0; i--) {
   this.InsertItemInternal(0, deserializedItems[i]);
   if(deserializedItems[i].selected)
    mainElement.options[0].selected = true;
  }
  this.UnlockSynchronizationOnInternalCallback();
  this.EndUpdate();
 },
 EndUpdate: function(){
  ASPxClientListBoxBase.prototype.EndUpdate.call(this);
  this.UpdateOptionValues();
 },
 GetSelectedIndices: function(){
  var selectedIndices = [];
  var mainElement = this.GetMainElement();
  for(var i = 0; i < mainElement.options.length; i++){
   if(mainElement.options[i].selected)
    selectedIndices.push(i);
  }
  return selectedIndices;
 },
 GetSelectedValues: function(){ 
  var selectedValues = [];
  var selectedIndices = this.GetSelectedIndices();
  for(var i = 0; i < selectedIndices.length; i++)
   selectedValues.push(this.GetItemValue(selectedIndices[i]));
  return selectedValues;
 },
 GetSelectedItems: function(){
  var selectedItems = [];
  var selectedIndices = this.GetSelectedIndices();
  for(var i = 0; i < selectedIndices.length; i++)
   selectedItems.push(this.GetItem(selectedIndices[i]));
  return selectedItems;
 },
 SelectAll: function(){
  this.SetAllItemsSelectedValue(true);
 },
 UnselectAll: function(){
  this.SetAllItemsSelectedValue(false);
 },
 SetAllItemsSelectedValue: function(selected){
  var mainElement = this.GetMainElement();
  for(var i = 0; i < mainElement.options.length; i++)
   mainElement.options[i].selected = selected;
 },
 SelectIndices: function(indices){
  this.SetIndicesSelectionState(indices, true);
 },
 UnselectIndices: function(indices){
  this.SetIndicesSelectionState(indices, false);
 },
 SetIndicesSelectionState: function(indices, selected){
  var mainElement = this.GetMainElement();
  for(var i = 0; i < indices.length; i++){
   mainElement.options[indices[i]].selected = selected;
  }
 },
 SelectItems: function(items){
  if(ASPx.IsExists(items))
   this.SetItemsSelectionState(items, true);
  else
   this.SelectAll();
 },
 UnselectItems: function(items){
  if(ASPx.IsExists(items))
   this.SetItemsSelectionState(items, false);
  else
   this.UnselectAll();
 },
 SetItemsSelectionState: function(items, selected){
  var mainElement = this.GetMainElement();
  for(var i = 0; i < items.length; i++){
   mainElement.options[items[i].index].selected = selected;
  }
 },
 SelectValues: function(values){
  this.SetValuesSelectedState(values, true);
 },
 UnselectValues: function(values){
  this.SetValuesSelectedState(values, false);
 },
 SetValuesSelectedState: function(values, selected){
  var mainElement = this.GetMainElement();
  var index;
  for(var i = 0; i < values.length; i++){
   index = this.FindItemIndexByValue(values[i]);
   mainElement.options[index].selected = selected;
  }
 },
 EnsureRequiredNativeAttributesExists: function() {
  var input = this.GetInputElement();
  if(!input.onchange)
   ASPx.Evt.AttachEventToElement(input, "change", function() { ASPx.EValueChanged(this.name); }.aspxBind(this));
 }
});
var AccessibilityHelperListBox = ASPx.CreateClass(ASPx.AccessibilityHelperBase, {
 constructor: function(listBox) {
  this.constructor.prototype.constructor.call(this, listBox);
  this.checkBoxRefocusTimeout = 1000;
  this.firstReadingColumnIndex = this.control.CheckColumnSelectionMode() ? 1 : 0;
  this.Initialize();
 },
 Initialize: function() {
  if(this.control.CheckColumnSelectionMode() && !this.control.IsNativeCheckBoxes())
   this.control.GotFocus.AddHandler(function() { this.SetActionElementFocus(); }.aspxBind(this));
  this.control.GotFocus.AddHandler(function() { this.OnSelectedIndexChanged(this.control.GetSelectedIndex()); }.aspxBind(this));
  this.control.LostFocus.AddHandler(function() { 
   setTimeout(function() { 
    this.changeActivityAttributes(this.getMainElement(), { "aria-activedescendant": "" }); 
   }.aspxBind(this), 200); 
  }.aspxBind(this));
 },
 OnSelectedIndexChanged: function(index) {
  var stateSelected = index != -1 && this.control.GetItem(index) && this.control.GetItem(index).selected;
  var selectedIndex = this.control.GetSelectedIndex();
  if(this.control.CheckColumnSelectionMode() || stateSelected || selectedIndex == -1)
   this.setSelectionAttributes(index, stateSelected);
 },
 getPronounceTimeout: function() {
  if(ASPx.Browser.WebKitFamily && this.control.CheckColumnSelectionMode())
   return 1000;
  return ASPx.AccessibilityHelperBase.prototype.getPronounceTimeout.call(this);
 },
 getHeaderCellCaptionText: function(index) {
  var headerDiv = this.control.GetHeaderDivElement();
  if(!headerDiv) return "";
  var headerTable = headerDiv.firstElementChild;
  return headerTable.rows[0].cells[this.firstReadingColumnIndex + index].textContent;
 },
 isItemCheckBoxFocused: function() {
  for(var i = 0; i < this.control.GetItemCount() ; i++) {
   var internalCheckBox = this.control.GetInternalCheckBox(i);
   if(internalCheckBox && internalCheckBox.focused)
    return true;
  }
  return false;
 },
 isSelectAllCheckBoxFocused: function() {
  return this.control.selectAllCheckBox && this.control.selectAllCheckBox.focused;
 },
 SetActionElementFocus: function() {
  if(this.control.enableFiltering) {
   if(!this.control.HasInternalFilteringTextBoxFocus())
    this.SetFilterPanelFocus();
  }
  else
   this.SetCheckBoxFocus();
 },
 SetCheckBoxFocus: function () {
  var isCheckBoxFocused = this.isItemCheckBoxFocused() || this.isSelectAllCheckBoxFocused();
  if(!isCheckBoxFocused)
   this.ProcessRefocusHandler(function() {
    this.control.SetFocusedIndex(0);
   }.aspxBind(this));
 },
 SetFilterPanelFocus: function() {
  if(this.control.customFilteringEditorID || ASPx.ElementHasCssClass(this.control.filterMainElement, this.control.GetInactiveFilterElementClassName())) {
   if(this.control.showFilterButton)
    this.ProcessRefocusHandler(function() {
     this.control.showFilterButton.Focus(); 
    }.aspxBind(this));
  } else 
    this.ProcessRefocusHandler(function() {
     ASPx.FindFirstChildActionElement(this.control.filterMainElement).focus(); 
    }.aspxBind(this));
 },
 ProcessRefocusHandler: function(handler) {
   setTimeout(function() {
   if(!this.control.focused) return;
   handler();
  }.aspxBind(this), this.checkBoxRefocusTimeout);
 },
 setSelectionAttributes: function(index, stateSelected) {
  if(index == -1) index = 0;
  var item = this.control.GetItem(index);
  if(!item) return;
  var assistText = "";
  if(!this.control.IsMultiColumn()) {
   assistText = item.text;
  } else {
   var columnsCount = this.control.columnFieldNames.length;
   var formatString = ASPx.AccessibilitySR.TableItemFormatString; 
   for(var i = 0; i < columnsCount; i++)
    assistText += ASPx.Str.ApplyReplacement(formatString, [["{0}", this.getHeaderCellCaptionText(i)], ["{1}", item.texts[i]]]);
  }
  var activeItemArgs = {
   "role"    : "option",
   "aria-posinset" : index + 1,
   "aria-setsize"  : this.control.itemTotalCount,
   "aria-selected" : stateSelected
  };
  var inactiveItemArgs = {
   "role"    : "",
   "aria-posinset" : "",
   "aria-setsize"  : "",
   "aria-selected" : ""
  };
  this.PronounceMessage(assistText, activeItemArgs, inactiveItemArgs);
 },
 SetCheckBoxesValidationAttributes: function() {
  if(!this.control.CheckColumnSelectionMode() || !this.control.GetErrorCell()) return;
  var errorTextElement = this.control.ariaExplanatoryTextManager.GetErrorTextElement();
  for (var i = 0; i < this.control.GetItemCount() ; i++) {
   var checkBoxFocusableElement = this.control.GetCheckBoxFocusableElement(i);
   if(checkBoxFocusableElement) {
    ASPx.Attr.SetOrRemoveAttribute(checkBoxFocusableElement, "aria-describedby", !this.control.isValid ? errorTextElement.id : null);
    ASPx.Attr.SetOrRemoveAttribute(checkBoxFocusableElement, "aria-invalid", !this.control.isValid);
   }
  }
 }
});
ASPxClientListBox.Cast = ASPxClientControl.Cast;
var ASPxClientCheckListBase = ASPx.CreateClass(ASPxClientListEdit, {
 constructor: function(name) {
  this.constructor.prototype.constructor.call(this, name);          
  this.imageProperties = null;
  this.internalButtonCollection = null; 
  this.icbFocusedStyle = [];
  this.items = [];
 },
 SetData: function(data){
  ASPxClientEdit.prototype.SetData.call(this, data);
  if(data.items)
   this.CreateItems(data.items);
 },
 Initialize: function() {
  ASPxClientListEdit.prototype.Initialize.call(this);
  this.UpdateInternalSelectedIndex(); 
 },
 UpdateInternalSelectedIndex: function() {
  var selectedIndexFromServer = this.GetSelectedIndex();
  var stateInput = this.FindStateInputElement();
  if(stateInput) {
   var restoredSelectedIndex = stateInput.value;
   if(restoredSelectedIndex != '' && restoredSelectedIndex != selectedIndexFromServer) {
    this.SetSelectedIndex(selectedIndexFromServer);
    this.SetSelectedIndex(restoredSelectedIndex);
   }
  }
 },
 CreateButtonInternalCollection: function() { 
  this.internalButtonCollection = this.CreateCheckBoxInternalCollection();
  for(var i = 0; i < this.GetItemCount(); i++) {
   var icbInputElement = this.GetItemInput(i);
   var internalButton = this.internalButtonCollection.Add(icbInputElement.id, icbInputElement, this.GetItemElement(i));
   internalButton.CreateFocusDecoration(this.icbFocusedStyle);
   internalButton.SetEnabled(this.GetEnabled());
   internalButton.GetReadOnly = this.GetReadOnly.bind(this);
   internalButton.CheckedChanged.AddHandler(function(s, e) {
    this.OnItemClick(this.GetItemIndexByElement(ASPx.Evt.GetEventSource(e)));
   }.aspxBind(this));
   internalButton.Focus.AddHandler(function(s, e) { this.OnFocus(); }.aspxBind(this));
   internalButton.LostFocus.AddHandler(function(s, e) { this.OnLostFocus(); }.aspxBind(this));
   this.attachToCellsClick(i);
   this.PrepareInternalButton(internalButton, i);
  }
  this.attachToMainElementMouseDown();
 },
 CreateCheckBoxInternalCollection: function () {
  return new ASPx.CheckBoxInternalCollection(this.imageProperties, false, true, ASPx.CheckEditElementHelper.Instance, undefined,
   this.accessibilityCompliant);
 },
 CheckableElementsExist: function() {
  return !!this.imageProperties;
 },
 SetEnabled: function(enabled){
  ASPxClientListEdit.prototype.SetEnabled.call(this, enabled);
  var stateInput = this.FindStateInputElement();
  if(enabled)
   ASPx.Attr.RemoveAttribute(stateInput, "disabled");
  else
   ASPx.Attr.SetAttribute(stateInput, "disabled", "disabled");
 },
 SetFocus: function() {
  this.UpdateFocus(); 
 },
 UpdateFocus: function() {
 },
 IsElementBelongToInputElement: function(element) {
  return this.GetItemIndexByElement(element) != -1;
 },
 attachToCellsClick: function(index) {
  var element = this.GetItemElement(index);
  ASPx.Evt.AttachEventToElement(element, "click", function(evt) {
   var src = ASPx.Evt.GetEventSource(evt);
   var label = ASPx.CheckEditElementHelper.Instance.GetLabelElement(element);
   var button = this.internalButtonCollection.Get(this.GetItemInput(index).id);
   if(!ASPx.GetIsParent(button.mainElement, src) && src !== label && src.parentElement !== label) {
    ASPx.CheckEditElementHelper.Instance.InvokeClick(button, evt);
   }
  }.aspxBind(this));
 },
 attachToMainElementMouseDown: function() {
  var mainElement = this.GetMainElement();
  ASPx.Evt.AttachEventToElement(mainElement, "mousedown", function() {
   if(!this.enabled || this.readOnly)
    return;
   this.LockFocusEvents();
   setTimeout(function() { this.UnlockFocusEvents(); }.aspxBind(this), 0);
  }.aspxBind(this));
 },
 GetItemIndexByElement: function(element) {
  for(var i = 0; i < this.GetItemCount(); i++) {
   var itemElement = this.GetItemElement(i);
   if(ASPx.GetIsParent(itemElement, element))
    return i;
  }
  return -1;  
 },
 GetItemInput: function(index) {
  return this.GetChildElement("RB" + index + "_I");
 },
 GetItemElement: function(index) {
  return this.GetChildElement("RB" + index);
 },
 GetItemFocusableElement: function(index) {
  return this.accessibilityCompliant ? this.GetChildElement("RB" + index + "_I_D") : this.GetItemInput(index);
 },
 GetAccessibilityActiveElements: function() {
  var accessibilityElements = [];
  for(var i = 0; i < this.GetItemCount(); i++) 
   accessibilityElements.push(this.GetItemFocusableElement(i));
  return accessibilityElements;
 },
 GetItemCount: function() {
  return this.items.length;
 },
 OnItemClick: function(index) {
 },
 OnItemClickReadonly: function() {
  var index = this.GetSelectedIndexInternal();
  this.SelectIndexSilent(index);
 },
 UpdateHiddenInputs: function(index) {
  var stateInput = this.FindStateInputElement();
  if(ASPx.IsExistsElement(stateInput))
   stateInput.value = index;
  var valueInput = this.GetValueInputElement();
  if(ASPx.IsExistsElement(valueInput)) {
   var value = this.GetValue();
   valueInput.value = ASPx.IsExists(value) ? value : " ";
  }
 },
 GetItemValue: function(index){
  if(index > -1 && index < this.items.length) {
   if(typeof(this.items[index].value) == "string" && this.items[index].value == "" && this.convertEmptyStringToNull)
    return null;
   else
    return this.items[index].value;
  }
  return null;
 },
 SetValue: function(value) {
  for(var i = 0; i < this.items.length; i++) {
   if(this.GetItemValue(i) == value) {   
    this.SelectIndexSilent(i);
    return;
   }
  } 
  this.SelectIndexSilent(-1);    
 },
 CreateItems: function(itemsProperties){
  for(var i = 0; i < itemsProperties.length; i++)
   this.CreateItem(i, { texts: itemsProperties[i][0], value: this.GetDecodeValue(itemsProperties[i][1]), imageUrl: itemsProperties[i][2] });
 },
 CreateItem: function(index, itemProperties){
  var item = new ASPxClientListEditItem(this, index, itemProperties.texts, itemProperties.value, itemProperties.imageUrl);
  this.items.push(item);
 },
 GetItem: function(index){
  return (0 <= index && index < this.items.length) ? this.items[index] : null;
 },
 ChangeEnabledAttributes: function(enabled){
  if(!this.CheckableElementsExist()) {
   for(var i = 0; i < this.GetItemCount(); i++){
    var element = this.GetItemInput(i);
    if(element){
     this.ChangeItemEnabledAttributes(element, ASPx.Attr.ChangeAttributesMethod(enabled));
     element.disabled = !enabled;
    }
   }
  } else {
   var selectedIndex = this.GetSelectedIndexInternal();
   this.UpdateCheckableElementDecorations(selectedIndex, enabled);
  }
 },
 ChangeEnabledStateItems: function(enabled){
  ASPx.GetStateController().SetElementEnabled(this.GetMainElement(), enabled);
  if(this.isNative){
   for(var i = 0; i < this.GetItemCount(); i++){
    var element = this.GetItemInput(i);
    if(element)
     ASPx.GetStateController().SetElementEnabled(element, enabled);
   }
  }
 },
 ChangeItemEnabledAttributes: function(element, method){
  method(element, "onclick");
 }
});
var ASPxClientRadioButtonList = ASPx.CreateClass(ASPxClientCheckListBase, {
 constructor: function(name) {
  this.constructor.prototype.constructor.call(this, name);          
 },
 InlineInitialize: function() {
  if(this.CheckableElementsExist()) 
   this.CreateButtonInternalCollection();
  ASPxClientCheckListBase.prototype.InlineInitialize.call(this);
 },
 Initialize: function() {
  ASPxClientCheckListBase.prototype.Initialize.call(this);
  this.UpdateHiddenInputs(this.GetSelectedIndex());
  this.SetSelectedIndex(this.GetSelectedIndex()); 
 },
 PrepareInternalButton: function(internalRadioButton){
  internalRadioButton.autoSwitchEnabled = false;
 },
 GetInputElement: function() {
  if(this.isNative) {
   var index = this.GetSelectedIndexInternal();
   return this.GetItemInput(index);
  } else 
   return this.GetValueInputElement();
 },
 GetValueInputElement: function() {
  if(this.valueInput == null) {
   var stateInput = this.FindStateInputElement();
   this.valueInput = this.GetHiddenField(null, this.name + "_ValueInput", stateInput.parentNode, stateInput);
  }
  return this.valueInput;
 },
 GetValueInputToValidate: function() {
  return this.GetValueInputElement();
 },
 SelectIndexSilent: function(index) {
  var itemCount = this.GetItemCount();
  var isValidIndex = (-1 <= index && index < itemCount);
  if(isValidIndex) {
   if(this.CheckableElementsExist()) 
    this.UpdateCheckableElementDecorations(index, this.GetEnabled());
   else {
    for(var i = 0; i < itemCount; i++) {
     var element = this.GetItemInput(i);
     if(element)
      element.checked = (i == index);
    }
   }
   this.SetSelectedIndexInternal(index);
   this.UpdateHiddenInputs(index);
  }
 },
 UpdateCheckableElementDecorations: function(selectedIndex, enabled) {
  if(this.CheckableElementsExist()) {
   for(var i = 0; i < this.items.length; i++) {
    var inputElement = this.GetItemInput(i);
    var internalButton = this.internalButtonCollection.Get(inputElement.id);
    internalButton.SetEnabled(enabled);
    internalButton.SetValue(i == selectedIndex ? ASPx.CheckBoxInputKey.Checked : ASPx.CheckBoxInputKey.Unchecked);
   }
  }
 },
 UpdateFocus: function() {
  var index = this.GetSelectedIndexInternal();
  if(index == -1)
   index = 0;
  var itemElement = this.GetItemFocusableElement(index);
  if(itemElement != null && ASPx.GetActiveElement() != itemElement && ASPx.IsEditorFocusable(itemElement)) 
   ASPx.SetFocus(itemElement);
 },
 OnItemClick: function(index) {
  if(this.GetSelectedIndexInternal() != index) {
   this.SelectIndexSilent(index);
   this.RaisePersonalStandardValidation();
   this.OnValueChanged();
  }
  this.UpdateFocus();
 },
 RequireInputElementToValidate: function() {
  return false;
 },
 GetItem: function(index){
  var item = ASPxClientCheckListBase.prototype.GetItem.call(this, index);
  if(item)
   item.selected = index == this.GetSelectedIndexInternal();
  return item;
 }
});
ASPxClientRadioButtonList.Cast = ASPxClientControl.Cast;
var ASPxClientCheckBoxList = ASPx.CreateClass(ASPxClientCheckListBase, {
 constructor: function(name) {
  this.constructor.prototype.constructor.call(this, name);          
  this.selectionEventsLockCount = 0;
  this.initializeInputValue = null;
  this.restoredSelectedIndices = null;
 },
 InlineInitialize: function() {
  if(this.CheckableElementsExist()) 
   this.CreateButtonInternalCollection();
  ASPxClientCheckListBase.prototype.InlineInitialize.call(this);
 },
 Initialize: function() {
  this.initializeInputValue = this.GetInputElement().value;
  ASPxClientCheckListBase.prototype.Initialize.call(this);
  this.SaveRestoredIndices();
  this.InitSelection();
 },
 SaveRestoredIndices: function() {
  var value = this.initializeInputValue;
  if(!ASPx.IsExists(value) || value === "")
   return;
  var serializer = this.GetSerializingHelper();
  var itemStringIndices = serializer.DeserializeValues(value);
  var itemIndices = [];
  for(var i = 0; i < itemStringIndices.length; i++) {
   var itemIndex = parseInt(itemStringIndices[i]);
   itemIndices.push(itemIndex);
  }
  this.restoredSelectedIndices = itemIndices;
 },
 InitSelection: function() {
  if(this.restoredSelectedIndices)
   this.UnselectAll();
  var selectedIndices = this.restoredSelectedIndices || this.initSelectedIndices;
  this.SelectIndices(selectedIndices);
  this.CacheValue();
 },
 PrepareInternalButton: function(internalCheckBox, index){
  internalCheckBox.autoSwitchEnabled = true;
  internalCheckBox.SetChecked(this.GetItemSelectionHelper().GetIsItemSelected(index));
 },
 SelectIndexSilent: function(index) {
  var itemCount = this.GetItemCount();
  var isValidIndex = (-1 <= index && index < itemCount);
  if(isValidIndex)
   this.SelectIndices([index]);
 },
 UpdateCheckableElementDecorations: function(selectedIndex, enabled) {
  if(this.CheckableElementsExist()) {
   for(var i = 0; i < this.items.length; i++) {
    var inputElement = this.GetItemInput(i);
    var internalButton = this.internalButtonCollection.Get(inputElement.id);
    internalButton.SetEnabled(enabled);
   }
  }
 },
 SetSelectionDecoration: function(index, selected){ 
  if(this.CheckableElementsExist()){
   var inputElement = this.GetItemInput(index);
   var internalButton = this.internalButtonCollection.Get(inputElement.id);
   internalButton.SetValue(selected ? ASPx.CheckBoxInputKey.Checked : ASPx.CheckBoxInputKey.Unchecked);
  } else {
   var element = this.GetItemInput(index);
   if(element)
    element.checked = (selected); 
  }
 },
 OnItemClick: function(index) {
  this.GetItemSelectionHelper().OnItemClick(index);
 },
 UpdateFocus: function() {
  var index = this.GetItemSelectionHelper().GetFocusedItemIndex();
  if(index == -1)
   index = this.GetSelectedIndexInternal();
  if(index == -1)
   index = 0;
  var itemElement = this.GetItemFocusableElement(index);
  if(itemElement != null && ASPx.GetActiveElement() != itemElement && ASPx.IsEditorFocusable(itemElement)) 
   ASPx.SetFocus(itemElement);
 },
 UpdateInternalState: function(){
  this.UpdateHiddenInputs();
 },
 IsUpdateHiddenInputsLocked: function(){
  return this.GetItemSelectionHelper().IsUpdateInternalSelectionStateLocked();
 },
 UpdateHiddenInputs: function(){
  if(this.IsUpdateHiddenInputsLocked()) 
   return;
  var element = this.FindStateInputElement();
  if(ASPx.IsExistsElement(element)) { 
   var sb = [ ];
   var serialiser = this.GetSerializingHelper();
   var selectedIndices = this.GetSelectedIndices();
   for(var i = 0; i < selectedIndices.length; i++)
    serialiser.SerializeAtomValue(sb, selectedIndices[i]);
   element.value = sb.join("");
  }
 },
 GetSerializingHelper: function(){ 
  if(this.serializingHelper == null)
   this.serializingHelper = new ListBoxBaseItemsSerializingHelper(this);
  return this.serializingHelper;
 },
 SetItemSelectionAppearance: function(index, selected, controller, checkCanChangeSelection){
 },
 LockSelectionEvents: function(){
  this.selectionEventsLockCount++;
 },
 UnlockSelectionEvents: function(){
  this.selectionEventsLockCount--;
 },
 IsSelectionEventsLocked: function(){
  return this.selectionEventsLockCount > 0;
 },
 CacheValue: function(){
  this.cachedValue = this.GetValue();
 },
 IsValueChanged: function(){
  return this.cachedValue != this.GetValue();
 },
 OnItemSelectionChanged: function(index, selected){
  this.SetSelectionDecoration(index, selected);
  if(!this.IsSelectionEventsLocked()) {
   this.SetRaiseSelectedIndexChangedArguments(this.autoPostBack, index, selected);
   var valueChanged = this.IsValueChanged();
   if(valueChanged) {
    this.RaisePersonalStandardValidation();
    this.OnValueChanged();
   } else {
    if(this.RaiseSelectedIndexChanged())
     this.SendPostBackInternal("");
   }
  }
  this.CacheValue();
 },
 SetRaiseSelectedIndexChangedArguments: function(processOnServer, index, selected){
  this.selectedIndexChangedArguments = {
   processOnServer: processOnServer,
   index: index,
   selected: selected
  };
 },
 GetRaiseSelectedIndexChangedArguments: function(){
  if(!this.selectedIndexChangedArguments)
   this.SetRaiseSelectedIndexChangedArguments(false, this.GetSelectedIndex(), true);
  return this.selectedIndexChangedArguments;
 },
 RaiseSelectedIndexChanged: function (processOnServer) {
  this.RaiseValidationInternal();
  var savedArgs = this.GetRaiseSelectedIndexChangedArguments();
  processOnServer = savedArgs.processOnServer || processOnServer;
  if(!this.SelectedIndexChanged.IsEmpty()){
   var args = new ASPxClientListEditItemSelectedChangedEventArgs(savedArgs.index, savedArgs.selected, processOnServer);
   this.SelectedIndexChanged.FireEvent(this, args);
   processOnServer = args.processOnServer;
  }
  return processOnServer;
 },
 GetItemSelectionHelper: function(){
  if(!this.itemSelectionHelper)
   this.itemSelectionHelper = this.CreateItemSelectionHelper();
  return this.itemSelectionHelper;
 },
 CreateItemSelectionHelper: function(){
  return new CheckBoxListMultiSelectionHelper(this);
 },
 GetItem: function(index){
  var item = ASPxClientCheckListBase.prototype.GetItem.call(this, index);
  item.selected = this.GetItemSelectionHelper().GetIsItemSelected(index);
  return item;
 },
 SetValue: function(value){
  var index = this.FindItemIndexByValue(value);
  this.SetSelectedIndex(index);
 },
 GetSelectedIndexInternal: function(){
  if(!this.isInitialized)
   return ASPxClientCheckListBase.prototype.GetSelectedIndexInternal.call(this);
  return this.GetItemSelectionHelper().GetSelectedIndex();
 },
 SetSelectedIndex: function(index){
  this.LockSelectionEvents();
  this.GetItemSelectionHelper().SetSelectedIndex(index);
  this.UnlockSelectionEvents();
 },
 GetSelectedIndices: function(){
  return this.GetItemSelectionHelper().GetSelectedIndices();
 },
 GetSelectedValues: function(){ 
  return this.GetItemSelectionHelper().GetSelectedValues();
 },
 GetSelectedItems: function(){
  return this.GetItemSelectionHelper().GetSelectedItems();
 },
 SelectAll: function(){
  this.SelectIndices();
 },
 UnselectAll: function(){
  this.UnselectIndices();
 },
 SelectIndices: function(indices){
  this.LockSelectionEvents();
  this.GetItemSelectionHelper().SelectIndices(indices);
  this.UnlockSelectionEvents();
 },
 SelectItems: function(items){
  this.LockSelectionEvents();
  this.GetItemSelectionHelper().SelectItems(items);
  this.UnlockSelectionEvents();
 },
 SelectValues: function(values){
  this.LockSelectionEvents();
  this.GetItemSelectionHelper().SelectValues(values);
  this.UnlockSelectionEvents();
 },
 UnselectIndices: function(indices){
  this.LockSelectionEvents();
  this.GetItemSelectionHelper().UnselectIndices(indices);
  this.UnlockSelectionEvents();
 },
 UnselectItems: function(items){
  this.LockSelectionEvents();
  this.GetItemSelectionHelper().UnselectItems(items);
  this.UnlockSelectionEvents();
 },
 UnselectValues: function(values){
  this.LockSelectionEvents();
  this.GetItemSelectionHelper().UnselectValues(values);
  this.UnlockSelectionEvents();
 }
});
ASPxClientCheckBoxList.Cast = ASPxClientControl.Cast;
var ASPxClientListEditItemSelectedChangedEventArgs = ASPx.CreateClass(ASPxClientProcessingModeEventArgs, {
 constructor: function(index, isSelected, processOnServer){
  this.constructor.prototype.constructor.call(this, processOnServer);
  this.index = index;
  this.isSelected = isSelected;
 }
});
function aspxLBTSelectStart(evt){
 var shiftPressed = evt.shiftKey;
 var ctrlKey = evt.ctrlKey || evt.metaKey;
 if(shiftPressed || ctrlKey){
  ASPx.Selection.Clear();
  ASPx.Evt.PreventEventAndBubble(evt);
 }
}
function aspxLBIClick(evt){
 if(ASPx.TouchUIHelper.isMouseEventFromScrolling) return;
 var element = ASPx.Evt.GetEventSource(evt);
 while(element != null && element.tagName != "BODY"){
  if(element.tagName == "TR"){
   var table = element.offsetParent;
   if(table && table.ListBoxId){
    var lb = ASPx.GetControlCollection().Get(table.ListBoxId);
    if(lb != null) {
     var retValue;
     if(evt.type == "dblclick") 
      retValue =lb.OnItemDblClick();
     else if(!lb.isComboBoxList || ASPx.Evt.IsLeftButtonPressed(evt)) {
      var itemIndex = lb.GetItemIndexByRow(element);
      retValue = lb.OnItemClick(itemIndex, evt);
     }
     if(typeof(retValue) != "undefined")
      return retValue;
    }
    break;
   }
  }
  element = element.parentNode;
 }
}
function aspxLBScroll(evt){
 var sourceId = ASPx.Evt.GetEventSource(evt).id;
 if(sourceId.slice(-lbDSuffix.length) == lbDSuffix){
  var name = sourceId.slice(0, -2);
  var lb = ASPx.GetControlCollection().Get(name);
  if(lb != null && lb.isInitialized) 
   lb.OnScroll();
 }
}
ASPx.NLBIDClick = function(evt) {
 var element = ASPx.Evt.GetEventSource(evt);
 if(element != null && element.tagName == "SELECT"){
  var lb = ASPx.GetControlCollection().Get(element.id);
  if(lb != null)
   lb.OnItemDblClick();
 }
};
ASPx.ERBLIClick = function(name, index) {
 var list = ASPx.GetControlCollection().Get(name);
 if(list != null) {
  if(list.GetReadOnly())
   return false;
  list.OnItemClick(index);
 }
};
ASPx.ERBLICancel = function(name) {
 var list = ASPx.GetControlCollection().Get(name);
 if(list != null)
  list.OnItemClickReadonly();
};
ASPx.ShowListBoxFilter = function(name) {
 var list = ASPx.GetControlCollection().Get(name);
 if(list != null)
  list.ShowFilterElement();
};
ASPx.HideListBoxFilter = function(name) {
 var list = ASPx.GetControlCollection().Get(name);
 if (list != null)
  list.HideFilterElement();
};
ASPx.ListBoxHighlightingHelper = ASPx.CreateClass(null, {
 constructor: function(listBox, tagName) {
  this.listBox = listBox;
  this.tagName = tagName;
  this.customReplacer = "<" + tagName + ">$&</" + tagName + ">";
 },
 Apply: function(text, isCustom) {
  if(text == "") return;
  if(isCustom)
   this.applyCustom(text);
  else
   this.apply(text, ASPx.ContainsFilteringUtils.SelectContainsTextInElement, false);
 },
 Remove: function(text, isCustom) {
  if(isCustom)
   this.removeCustom(text);
  else
   this.apply(text, ASPx.ContainsFilteringUtils.UnselectContainsTextInElement, true);
 },
 Refresh: function(text, isCustom) {
  if(text == "") return;
  if(isCustom)
   this.applyCustom(text, true);
  else
   this.apply(text, ASPx.ContainsFilteringUtils.ReselectContainsTextInElement, false);
 },
 applyCustom: function(highlighting, refreshing) { 
  var count = this.listBox.GetItemCount();
  var highlightingRegExpxByColumns = this.getCustomHighlightingRegExpsByColumns(highlighting);
  for(var i = 0; i < count; i++) {
   var item = this.listBox.GetItemRow(i);
   if(!item || this.listBox.ItemRowHasTemplate(i)) continue;
   this.applyCustomCore(item, highlightingRegExpxByColumns, refreshing);
  }
 },
 applyCustomCore: function(item, highlightingRegExpxByColumns, refreshing) {
  var firstTextCellIndex = this.getFirstTextCellIndex();
  var elements = Array.prototype.slice.call(this.listBox.GetItemSelectableElementsByRow(item), -firstTextCellIndex);
  for(var i = 0, el; el = elements[i]; i++) {
   if(refreshing)
    this.removeCustomFromItem(el);
   this.applyCustomToItem(el, highlightingRegExpxByColumns[i]);
  }
 },
 applyCustomToItem: function(element, regexp) {
  if(!regexp)
   return;
  var currentText = ASPx.Attr.GetAttribute(element, "DXText");
  if(!ASPx.IsExists(currentText)) ASPx.Attr.SetAttribute(element, "DXText", ASPx.GetInnerText(element));
  var oldInnerText = ASPx.GetInnerText(element);
  var newInnerText = oldInnerText.replace(regexp, this.customReplacer);
  if(newInnerText !== oldInnerText)
   ASPx.SetInnerHtml(element, newInnerText);
 },
 removeCustomFromItem: function(element) {
  var currentText = ASPx.Attr.GetAttribute(element, "DXText");
  if(ASPx.IsExists(currentText)) {
   currentText = ASPx.ContainsFilteringUtils.PrepareElementText(currentText);
   ASPx.SetInnerHtml(element, currentText === "" ? "&nbsp;" : currentText);
  }
 },
 removeCustom: function() {
  var count = this.listBox.GetItemCount();
  for(var i = 0; i < count; i++) {
   var item = this.listBox.GetItemRow(i);
   if(!item || this.listBox.ItemRowHasTemplate(i)) continue;
   this.removeCustomCore(item);
  }
 },
 removeCustomCore: function(item) {
  var firstTextCellIndex = this.getFirstTextCellIndex();
  var elements = Array.prototype.slice.call(this.listBox.GetItemSelectableElementsByRow(item), -firstTextCellIndex);
  for(var i = 0, el; el = elements[i]; i++)
   this.removeCustomFromItem(el);
 },
 getCustomHighlightingRegExpsByColumns: function(highlighting) {
  var columns = this.listBox.IsMultiColumn() ? this.listBox.columnFieldNames : [""];
  return columns.map(function(fieldName) {
   if(typeof (highlighting) === "string" || Array.isArray(highlighting) || highlighting instanceof RegExp)
    return this.arrayToRegEx(highlighting);
   if(typeof (highlighting) === "object")
    return this.arrayToRegEx(highlighting[fieldName]);
   return null;
  }.bind(this));
 },
 arrayToRegEx: function(texts) {
  if(texts instanceof RegExp)
   return texts;
  if(typeof (texts) === "string")
   return this.arrayToRegEx([texts]);
  if(Array.isArray(texts)) {
   texts = texts
    .filter(function(t) { return typeof (t) === "string" && t.length; })
    .sort(function(a, b) { return b.length - a.length; })
    .map(ASPx.Str.EscapeForRegEx);
   if(texts.length)
    return new RegExp("(" + texts.join("|") + ")", "gi");
  }
  return null;
 },
 apply: function(text, func, allColumns) {
  var count = this.listBox.GetItemCount();
  for (var i = 0; i < count; i++) {
   var item = this.listBox.GetItemRow(i);
   if (item && (allColumns || ASPx.GetElementDisplay(item)) && this.canApply(item)) {
    var elements = this.listBox.GetItemSelectableElementsByRow(item);
    this.applyToItem(text, elements, func, allColumns);
   }
  }
 },
 applyToItem: function(text, elements, func, allColumns) {
  var itemValues = this.getItemValues(elements);
  var itemSelection = ASPx.ContainsFilteringUtils.GetColumnSelectionsForItem(itemValues, this.listBox.textFormatString, text);
  var firstTextCellIndex = this.getFirstTextCellIndex();
  if (allColumns) {
   for (var i = 0; i < elements.length; i++)
    this.applyToItemCore(func, elements[i], itemSelection[i]);
  } else
   this.applyToTextCells(func, firstTextCellIndex, elements, itemSelection);
 },
 applyToTextCells: function(func, firstTextCellIndex, elements, itemSelection) {
  for(var i = 0; i < itemSelection.length; i++)
   this.applyToItemCore(func, elements[itemSelection[i].index + firstTextCellIndex], itemSelection[i]);
 },
 applyToItemCore: function (func, itemElement, itemSelection) {
  if (!this.listBox.ItemCellHasTextAttr(itemElement))
   func(itemElement, itemSelection, this.tagName);
 },
 getItemValues: function (elements) {
  var result = [];
  for (var i = this.getFirstTextCellIndex() ; i < elements.length; i++)
   result.push(ASPxClientListBox.GetItemCellInnerText(elements[i]));
  return result;
 },
 canApply: function (item) {
  return !this.listBox.ItemRowHasTemplateCore(item);
 },
 getFirstTextCellIndex: function () {
  return this.listBox.GetItemFirstTextCellIndex();
 }
});
var ListEditFilterStrategyBase = ASPx.CreateClass(null, {
 OnPaste: function(evt) { },
 OnInput: function() { },
 OnClearButtonClick: function() { },
 OnTextChanged: function() { },
 OnEscape: function() { },
 OnKeyDown: function(evt) { },
 OnAfterEnter: function() { },
 OnSelectedIndexChanged: function() { },
 OnLostFocus: function() { },
 OnCallback: function(result) { },
 OnBeforeDoEndCallback: function() { },
 OnAfterDoEndCallback: function() { },
 OnBeforeCallbackFinally: function() { },
 OnAfterCallbackFinally: function() { },
 OnPerformCallback: function() { },
 Filtering: function() { },
 CancelFiltering: function() { },
 ShouldDiscardCallbackResult: function() { },
 GetCallbackArguments: function() { return ""; },
 CanNavigateByKbd: function() { return true; },
 IsFilterMeetRequirementForMinLength: function (filter) { return true; },
 ResetCallbackState: function() { },
 OnDropDownHideArea: function() { },
 OnDropDownButtonClick: function() { },
 OnDropDownCloseByDocumentOrWindowEvent: function() { },
 OnApplyChanges: function() { },
 OnCancelChanges: function() { },
 OnUndo: function() { }
});
var ListEditIncrementalFilterStrategyBase = ASPx.CreateClass(ListEditFilterStrategyBase, {
 constructor: function(filterDelay, filterMinLength, isCallbackMode) {
  this.filterTimeoutId = -1;
  this.filterDelay = filterDelay;
  this.filterMinLength = filterMinLength;
  this.isCallbackMode = isCallbackMode;
  this.filter = "";
  this.highlighting = "";
  this.filterInitialized = false;
  this.needEmptyFilterBeforeFiltering = false;
  this.currentCallbackIsFiltration = false;
  this.refiltrationRequired = false;
 },
 GetInputFilterValue: function() { throw "Not Implemented"; },
 GetListBoxControl: function() { throw "Not Implemented"; },
 IsSatisfy: function(text, filter) { throw "Not Implemented"; },
 InCallback: function() { throw "Not Implemented"; },
 IsEnabled: function() { throw "Not Implemented"; },
 SendCallbackCore: function() { throw "Not Implemented"; },
 PreventEndCallbackRising: function() { throw "Not Implemented"; },
 GetSelectedIndex: function() { throw "Not Implemented"; },
 NotifyCollectionChanged: function() { throw "Not Implemented"; },
 OnCallbackCore: function(highlighting, newFilterLength) { throw "Not Implemented"; },
 RaiseItemFilteringEvent: function(item, filter, isFit) { throw "Not Implemented"; },
 RaiseCustomHighlightingEvent: function(filter, highlighting) { throw "Not Implemented"; },
 OnBeforeFilteringOnClient: function(filter) { }, 
 OnAfterFilteringOnClientCore: function (filter, firstSatisfyItemIndex) { throw "Not Implemented"; },
 SupportsFilterCorrection: function() { throw "Not Implemented"; },
 OnFirstSatisfiedItemFound: function(index, text, isTextClearing) { },
 TryProcessFilterLessMinLength: function() { return true; },
 AllowEmptyFilterResults: function() { return true; },
 OnBeforeFiltering: function() { },
 OnAfterFiltering: function() { },
 OnFilteringCancelled: function() { },
 OnTextChanged: function() { },
 OnFilterRollback: function() { },
 CanStartFilterOnInput: function() {
  return this.IsEnabled() && !this.InCallback();
 },
 OnAfterFilteringOnClient: function (filter, satisfyItemIndices) {
  this.GetListBoxControl().RewriteFilteredItemIndices(satisfyItemIndices);
  var firstSatisfyItemIndex = satisfyItemIndices.length > 0 ? satisfyItemIndices[0] : -1;
  this.OnAfterFilteringOnClientCore(filter, firstSatisfyItemIndex);
 },
 ShouldClearFilterBeforeFiltering: function(filter) { return false; },
 OnInput: function() {
  if(this.CanStartFilterOnInput()) {
   this.FilterStopTimer();
   this.FilterStartTimer();
  }
 },
 OnCallback: function(result) {
  this.OnCallbackCore(result[CONSTANTS.CALLBACK_RESULTS.FILTER_CUSTOMHIGHLIGHTING], result[CONSTANTS.CALLBACK_RESULTS.FILTER_LENGTH]);
  this.currentCallbackIsFiltration = false;
 },
 CancelFiltering: function() {
  this.FilterStopTimer();
 },
 Filtering: function(fromApi) {
  this.FilterStopTimer();
  var inputValue = this.GetInputFilterValue();
  this.needEmptyFilterBeforeFiltering = this.ShouldClearFilterBeforeFiltering(inputValue);
  var newFilter = this.needEmptyFilterBeforeFiltering ? "" : inputValue;
  var oldFilter = this.filter;
  if(!this.FilterCompare(newFilter)) {
   this.SetFilter(newFilter);
   if(!this.IsFilterMeetRequirementForMinLength() && this.TryProcessFilterLessMinLength(oldFilter))
    return;
   else {
    this.OnBeforeFiltering();
    if(this.isCallbackMode)
     this.FilteringOnServer();
    else
     this.FilteringOnClient();
    this.OnAfterFiltering();
   }
  }
  else
   this.OnFilteringCancelled(fromApi);
 },
 FilteringOnClient: function() {
  var listBox = this.GetListBoxControl(),
   count = listBox.GetItemCount(),
   filter = this.filter,
   listTable = listBox.GetListTable(),
   visibleItems = [],
   visibleItemFound = false;
  this.DiscardHighlighting();
  if(ASPx.Browser.IE && ASPx.Browser.Version > 9) 
   ASPx.SetElementDisplay(listTable, false);
  while(true) {
   var preparedFilter = ASPx.Str.PrepareStringForFilter(filter);
   listBox.BeforeClientFiltering();
   for(var i = 0; i < count; i++) {
    var item = listBox.GetItem(i);
    var isFit = this.IsSatisfy(item.text, preparedFilter);
    isFit = this.RaiseItemFilteringEvent(item, filter, isFit);
    if(isFit) {
     if(!visibleItemFound) {
      this.OnBeforeFilteringOnClient(filter);
      for(var j = 0; j < i; j++)
       listBox.ApplyFilterToItem(j, false);
      var isTextClearing = filter == "" && this.filter != item.text;
      this.OnFirstSatisfiedItemFound(i, item.text, isTextClearing);
      visibleItemFound = true;
     }
     visibleItems.push(i);
    }
    if(visibleItemFound)
     listBox.ApplyFilterToItem(i, isFit);
   }
   if(visibleItemFound || this.AllowEmptyFilterResults() || !filter)
    break;
   filter = filter.substr(0, filter.length - 1);
  }
  if(!visibleItemFound) {
   this.OnBeforeFilteringOnClient(filter); 
   if(this.AllowEmptyFilterResults()) {
    for(var i = 0; i < count; i++)
     listBox.ApplyFilterToItem(i, false);
   }
  }
  if(ASPx.Browser.IE && ASPx.Browser.Version > 9) 
   ASPx.SetElementDisplay(listTable, true);
  this.OnAfterFilteringOnClient(filter, visibleItems);
  this.SetHighlighting(filter);
  this.OnEndFiltering(visibleItemFound || this.AllowEmptyFilterResults());
 },
 FilteringOnServer: function() {
  if(!this.InCallback()) {
   var listBox = this.GetListBoxControl();
   listBox.ClearItems(); 
   listBox.serverIndexOfFirstItem = 0;
   listBox.SetScrollSpacerVisibility(true, false);
   listBox.SetScrollSpacerVisibility(false, false);
  }
  this.SendFilteringCallback();
 },
 SendFilteringCallback: function(owner) {
  this.currentCallbackIsFiltration = true;
  this.SendCallbackCore();
 },
 OnEndFiltering: function(visibleCollectionChanged) {
  if(visibleCollectionChanged)
   this.NotifyCollectionChanged();
  this.ApplyHighlighting();
 },
 IsFilterTimerActive: function() {
  return this.filterTimeoutId !== -1;
 },
 FilterStopTimer: function() {
  if(this.IsFilterTimerActive()) {
   clearTimeout(this.filterTimeoutId);
   this.filterTimeoutId = -1;
  }
 },
 FilterStartTimer: function() {
  this.filterTimeoutId = setTimeout(function() {
   this.filterTimeoutId = -1;
   this.Filtering();
  }.bind(this), this.filterDelay);
 },
 IsFilterMeetRequirementForMinLength: function(filter) {
  if(typeof (filter) !== "string")
   filter = this.GetInputFilterValue();
  return typeof (filter) === "string" ? filter.length >= this.filterMinLength : true;
 },
 GetCallbackArguments: function() {
  if(this.filter) {
   var callbackPrefix = this.SupportsFilterCorrection() ? CONSTANTS.CALLBACK_PREFIXES.FILTERING_CORRECT : CONSTANTS.CALLBACK_PREFIXES.FILTERING;
   return ASPx.FilteringUtils.FormatCallbackArg(callbackPrefix, this.filter);
  }
  return "";
 },
 OnAfterDoEndCallback: function() {
  if(this.refiltrationRequired) {
   this.refiltrationRequired = false;
   window.setTimeout(this.Filtering.bind(this), 0);
  }
 },
 OnBeforeDoEndCallback: function() {
  if(this.refiltrationRequired)
   this.PreventEndCallbackRising();
 },
 OnSelectedIndexChanged: function() {
  this.ClearFilterApplied();
 },
 SetHighlighting: function(filter, callbackHighlighting) {
  callbackHighlighting = this.ProcessCallbackHighlighting(callbackHighlighting);
  var customHighlighting = this.RaiseCustomHighlightingEvent(filter, callbackHighlighting);
  this.isCustomHighlighting = customHighlighting !== null && customHighlighting !== undefined;
  this.highlighting = this.isCustomHighlighting ? customHighlighting : filter;
 },
 ProcessCallbackHighlighting: function(obj) {
  if(obj === undefined || obj === null)
   return undefined;
  var val = obj.val;
  var regEx = !!obj.regEx;
  if(regEx) {
   if(typeof (val) === "string")
    val = new RegExp(val, "gi");
   if(!Array.isArray(val) && typeof (val) === "object") {
    for(var col in val) {
     if(!val.hasOwnProperty(col)) continue;
     if(typeof (val[col]) === "string")
      val[col] = new RegExp(val[col], "gi");
    }
   }
  }
  return val;
 },
 IsEmptyFilter: function() {
  return !this.filterInitialized || this.filter === "";
 },
 ShouldDiscardCallbackResult: function() {
  var discardCallbackResult = !this.needEmptyFilterBeforeFiltering && !this.IsFilterEqualInputValue() && this.currentCallbackIsFiltration;
  if(discardCallbackResult)
   this.refiltrationRequired = true;
  return discardCallbackResult;
 },
 IsFilterEqualInputValue: function() {
  var currentFilter = this.GetInputFilterValue();
  return this.FilterCompareLower(ASPx.Str.PrepareStringForFilter(currentFilter));
 },
 FilterCompare: function(value) {
  return this.filterInitialized && this.filter === value;
 },
 FilterCompareLower: function(value) {
  if(!this.filterInitialized)
   return false;
  return ASPx.Str.PrepareStringForFilter(this.filter) == value;
 },
 DiscardHighlighting: function() {
  this.GetListBoxControl().highlighting.Remove(this.highlighting, this.isCustomHighlighting);
 },
 ApplyHighlighting: function() {
  this.GetListBoxControl().highlighting.Apply(this.highlighting, this.isCustomHighlighting);
 },
 RefreshHighlighting: function() {
  this.GetListBoxControl().highlighting.Refresh(this.highlighting, this.isCustomHighlighting);
 },
 MakeAllItemsVisible: function() {
  this.GetListBoxControl().MakeAllItemsVisible();
 },
 SetFilter: function(newFilter) {
  this.filter = newFilter;
  this.highlighting = "";
  this.isCustomHighlighting = undefined;
  this.filterInitialized = true;
 },
 ClearFilter: function() {
  this.filter = "";
  this.highlighting = "";
  this.isCustomHighlighting = undefined;
  this.filterInitialized = false;
 },
 ClearFilterApplied: function() {
  this.filterInitialized = false;
 },
 FilteringBackspace: function() {
  throw "Not Implemented";
 },
});
var ListBoxFilterStrategy = ASPx.CreateClass(ListEditIncrementalFilterStrategyBase, {
 constructor: function(listBox) {
  this.constructor.prototype.constructor.call(this, listBox.filteringDelay, listBox.filterMinLength, listBox.isCallbackMode);
  this.listBox = listBox;
 },
 SupportsFilterCorrection: function() {
  return false;
 },
 IsEnabled: function() {
  return this.listBox.GetEnabled();
 },
 GetInputFilterValue: function() {
  return this.listBox.filteringTextBox.GetInputElement().value;
 },
 NotifyCollectionChanged: function() {
  this.listBox.CollectionChanged(true);
 },
 TryProcessFilterLessMinLength: function(oldFilter) {
  this.SetFilter("");
  return !oldFilter;
 },
 IsSatisfy: function(text, filter) {
  return ASPx.Str.PrepareStringForFilter(text).indexOf(filter) !== -1;
 },
 GetListBoxControl: function() {
  return this.listBox;
 },
 OnAfterFilteringOnClientCore: function (filter, firstSatisfyItemIndex) {
  if(firstSatisfyItemIndex !== -1)
   this.listBox.CorrectCellWidthsOnFirstRowItemReplacement(0, firstSatisfyItemIndex);
 },
 OnEndFiltering: function(visibleCollectionChanged) {
  ListEditIncrementalFilterStrategyBase.prototype.OnEndFiltering.call(this, visibleCollectionChanged);
  if(this.listBox.IsMultiColumn())
   this.listBox.CorrectWidth();
  this.listBox.updateSelectAllElementsState();
 },
 SendCallbackCore: function() {
  this.listBox.SendCallback();
 },
 InCallback: function() {
  return this.listBox.InCallback();
 },
 PreventEndCallbackRising: function() {
  this.listBox.preventEndCallbackRising = true;
 },
 GetSelectedIndex: function() {
  return this.listBox.GetSelectedIndex();
 },
 OnCallbackCore: function(highlighting, newFilterLength) {
  if(this.currentCallbackIsFiltration)
   this.SetHighlighting(this.filter, highlighting);
  if(this.filter)
   this.OnEndFiltering();
 },
 FilteringBackspace: function() {
  var textBox = this.listBox.filteringTextBox;
  if(textBox)
   ASPx.StartWithFilteringUtils.RollbackOneSuggestedChar(textBox.GetInputElement());
  this.FilterStartTimer();
 },
 RaiseItemFilteringEvent: function(item, filter, isFit) {
  return this.listBox.RaiseItemFiltering(item, filter, isFit);
 },
 RaiseCustomHighlightingEvent: function(filter, callbackHighlighting) {
  return this.listBox.RaiseCustomHighlighting(filter, callbackHighlighting);
 }
});
ASPx.ListBoxItemsDefaultManager = ListBoxItemsDefaultManager;
ASPx.ListBoxItemsVirtualManager = ListBoxItemsVirtualManager;
ASPx.ListEditIncrementalFilterStrategyBase = ListEditIncrementalFilterStrategyBase;
ASPx.ListBoxFilterStrategy = ListBoxFilterStrategy;
ASPx.ListEditFilterStrategyBase = ListEditFilterStrategyBase;
var ASPxClientListEditItemFilteringEventArgs = ASPx.CreateClass(ASPxClientEventArgs, {
 constructor: function(item, filter, isFit) {
  this.constructor.prototype.constructor.call(this);
  this.item = item;
  this.isFit = isFit;
  this.filter = filter;
 }
});
var ASPxClientListEditCustomHighlightingEventArgs = ASPx.CreateClass(ASPxClientEventArgs, {
 constructor: function(filter) {
  this.constructor.prototype.constructor.call(this);
  this.highlighting = null;
  this.filter = filter;
 }
});
window.ASPxClientListEdit = ASPxClientListEdit;
window.ASPxClientListEdit.CONSTANTS = CONSTANTS;
window.ASPxClientListEditItem = ASPxClientListEditItem;
window.ASPxClientListBoxItem = ASPxClientListBoxItem;
window.ASPxClientListBoxBase = ASPxClientListBoxBase;
window.ASPxClientListBox = ASPxClientListBox;
window.ASPxClientNativeListBox = ASPxClientNativeListBox;
window.ASPxClientCheckListBase = ASPxClientCheckListBase;
window.ASPxClientRadioButtonList = ASPxClientRadioButtonList;
window.ASPxClientCheckBoxList = ASPxClientCheckBoxList;
window.ASPxClientListEditItemSelectedChangedEventArgs = ASPxClientListEditItemSelectedChangedEventArgs;
window.ASPxClientListEditItemFilteringEventArgs = ASPxClientListEditItemFilteringEventArgs;
window.ASPxClientListEditCustomHighlightingEventArgs = ASPxClientListEditCustomHighlightingEventArgs;
})();

